/**  Obiekt przechowujcy globalne ustawienia.
 */

#ifndef _Configuration_h
#define _Configuration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "DoubleParameter.h"

// FORWARD REFERENCES
//


class Configuration
{
public:
    friend class ConfigurationDialog;

// LIFECYCLE

    /** Destruktor.
     */
    ~Configuration(void);


// OPERATORS

// OPERATIONS

    static Configuration&       GetInstance();

    /** Zapisuje konfiguracj na dysk.
     */
    void                        Save();

    /** Ustawia domylne wartoci parametrw.
     */
    void                        SetDefaults();

// ACCESS

    /** Zwraca limit krokw dla metod.
     */
    long                        StepLimit() const;

    /** Zwraca delt dla obliczania przybliena pochodnej w punkcie.
     */
    double                      DifferentiationDelta() const;

    /** Zwraca dugo pocztkowego odcinka dla metod w kierunku.
     */
    double                      InitialSectionLength() const;

    /** Zwraca tolerancj odejcia od ograniczenia w problemie optymalizacji z
     * ograniczeniami z zewntrzn funkcj kary.
     *
     * @return tolerancja odejcia od ograniczenia
     */
    DoubleParameter             Tolerance() const;

// INQUIRY


protected:
private:

    /** Konstruktor domylny.
     */
    Configuration(void);

    /** Wczytuje konfiguracj z dysku.
     */
    void                        Load();


    /// Limit krokw dla metod.
    // [ signed, bo wxConfig nie obsuguje unsigned ]
    long            mStepLimit;
    /// Delta dla obliczania pochodnej w punkie.
    DoubleParameter mDifferentiationDelta;
    /// Pocztkowa dugo odcinka dla metod w kierunku (tych z podziaem).
    DoubleParameter mInitialSectionLength;

    const wxString          mApplicationName;
    const wxString          mVendorName;

    const static wxString   mConfigPath;
    const static wxString   mStepLimitPath;
    const static wxString   mDifferentiationDeltaPath;
    const static wxString   mInitialSectionLengthPath;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _Configuration_h
