#include <precomp.h>

#include "ConstrainedOptimizationIteration.h"  // class implemented
//#include "util.h"

using namespace std;

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

ConstrainedOptimizationIteration::ConstrainedOptimizationIteration
                                  (bool             previousApproximationValid,
                                   bool             newApproximationValid,
                                   unsigned         evaluationCount,
                                   unsigned         iterationCount,
                                   double           penaltyParam)
    : mPreviousApproximationValid(previousApproximationValid),
      mNewApproximationValid(newApproximationValid),
      mEvaluationCount(evaluationCount),
      mIterationCount(iterationCount),
      mPenaltyParam(penaltyParam)
{
}// ConstrainedOptimizationIteration

ConstrainedOptimizationIteration::~ConstrainedOptimizationIteration()
{
}// ~ConstrainedOptimizationIteration

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ vector<IterationData::IterationDataIdType>
ConstrainedOptimizationIteration::ClassIds() const
{
    // Bierzemy identyfikatory od bezporedniego rodzica
    vector<IterationDataIdType> base_ids(IterationData::ClassIds());

    base_ids.insert(base_ids.begin(),
                    ConstrainedOptimizationIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
ConstrainedOptimizationIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId

/* virtual *//* ColumnVector
ConstrainedOptimizationIteration::EndValuePoint() const
{
    return mNewApproximation;
}// EndValue*/



unsigned
ConstrainedOptimizationIteration::EvaluationCount() const
{
    return mEvaluationCount;
}

unsigned
ConstrainedOptimizationIteration::IterationCount() const
{
    return mIterationCount;
}

double
ConstrainedOptimizationIteration::PenaltyParam() const
{
    return mPenaltyParam;
}

//============================= INQUIRY    ===================================

bool
ConstrainedOptimizationIteration::IsPreviousApproximationValid() const
{
    return mPreviousApproximationValid;
}

bool
ConstrainedOptimizationIteration::IsNewApproximationValid() const
{
    return mNewApproximationValid;
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
