/** Warunek stopu metody ewolucyjnej oparty
 * na liczbie kolejnych iteracji, w ktrych nie zmieni
 * si najlepszy punkt.
 *
 * Sprawdza, czy liczba kolejnych iteracji,
 * w ktrych nie zmieni si najlepszy punkt,
 * jest wiksza ni (<em>epsilon</em>).
 */

#ifndef _EMIterationsCondition_h
#define _EMIterationsCondition_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "EMStopCondition.h"

// FORWARD REFERENCES
//


class EMIterationsCondition
    : public EMStopCondition
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    EMIterationsCondition(void);


    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    EMIterationsCondition(const EMIterationsCondition& from);


    /** Destruktor.
     */
    ~EMIterationsCondition(void);


// OPERATORS

// OPERATIONS

    /** Tworzy kopi obiektu.
     */
    virtual std::auto_ptr<StopConditionBase>    Clone() const;

// ACCESS

    /** Zwraca tekstowy opis warunku stopu.
     */
    virtual wxString        ToString() const;

// INQUIRY

    virtual bool        IsMet(
                const ColumnVector&         previousBestPoint,
                const ColumnVector&         bestPoint,
                const FunctionBase&         function,
                double                      pointStandardDeviation,
                double                      valueStandardDeviation,
                unsigned                    stagnantIterations) const;

protected:
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _EMIterationsCondition_h
