/** Warunek stopu metody ewolucyjnej oparty
 * na odchyleniu standardowym liczonym
 * dla wszystkich punktw w populacji.
 *
 * Sprawdza, czy odchylenie standardowe
 * punktw jest mniejsze ni (<em>epsilon</em>).
 */

#ifndef _EMPointDeviationCondition_h
#define _EMPointDeviationCondition_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "EMStopCondition.h"

// FORWARD REFERENCES
//


class EMPointDeviationCondition
    : public EMStopCondition
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    EMPointDeviationCondition(void);


    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    EMPointDeviationCondition(const EMPointDeviationCondition& from);


    /** Destruktor.
     */
    ~EMPointDeviationCondition(void);


// OPERATORS

// OPERATIONS

    /** Tworzy kopi obiektu.
     */
    virtual std::auto_ptr<StopConditionBase>    Clone() const;

// ACCESS

// INQUIRY

    virtual bool        IsMet(
                const ColumnVector&         previousBestPoint,
                const ColumnVector&         bestPoint,
                const FunctionBase&         function,
                double                      pointStandardDeviation,
                double                      valueStandardDeviation,
                unsigned                    stagnantIterations) const;

protected:
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _EMPointDeviationCondition_h
