#include <precomp.h>

#include "EMStopCondition.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

EMStopCondition::EMStopCondition()
    : StopConditionBase(),
      mcpComparison()
{
}// EMStopCondition

EMStopCondition::EMStopCondition(CountedPtr<StandardStopCondition> cpComparison)
    : StopConditionBase(),
      mcpComparison(cpComparison)
{
}//EMStopCondition

EMStopCondition::EMStopCondition(const EMStopCondition& from)
    : StopConditionBase(from),
      mcpComparison(from.mcpComparison)
{
}// EMStopCondition

EMStopCondition::~EMStopCondition()
{
}// ~EMStopCondition


//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
std::auto_ptr<StopConditionBase>
EMStopCondition::Clone() const
{
    return std::auto_ptr<StopConditionBase>(new EMStopCondition(*this));
}// Clone
//============================= ACCESS     ===================================

/* virtual */ DoubleParameter
EMStopCondition::Epsilon() const
{
    assert(mcpComparison.Get() != NULL);

    return mcpComparison->Epsilon();
}// Epsilon

/* virtual */ DoubleParameter&
EMStopCondition::rEpsilon()
{
    assert(mcpComparison.Get() != NULL);

    return mcpComparison->rEpsilon();
}// Epsilon

//============================= INQUIRY    ===================================
/* virtual */ bool
EMStopCondition::IsMet(const ColumnVector&      previousBestPoint,
                       const ColumnVector&      bestPoint,
                       const FunctionBase&      function,
                       double                   pointStandardDeviation,
                       double                   valueStandardDeviation,
                       unsigned                 stagnantIterations)
                                                                    const
{
    assert(mcpComparison.Get() != NULL);

    // Implementacja sprawdzenia dla trzech podstawowych warunkw,
    // pozostae warunki maj swoje klasy pochodne.
    return mcpComparison->IsMet(previousBestPoint, bestPoint, function);
}// IsMet

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
