#include <precomp.h>

#include "CustomValueCondition.h"
#include "util.h"

#include "EMValueDeviationCondition.h"  // class implemented
#include "Logger.h"

LOGGER(DEBUG);

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

EMValueDeviationCondition::EMValueDeviationCondition()
    : EMStopCondition(CountedPtr<StandardStopCondition>(
                        new CustomValueCondition(
                            DoubleParameter(1, 0, true))))
{
    // TODO: nazwa
    mName = _("Value standard deviation");
}// EMValueDeviationCondition

EMValueDeviationCondition::EMValueDeviationCondition
    (const EMValueDeviationCondition& from)
    : EMStopCondition(from)
{
}// EMValueDeviationCondition

EMValueDeviationCondition::~EMValueDeviationCondition()
{
}// ~EMValueDeviationCondition


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

std::auto_ptr<StopConditionBase>
EMValueDeviationCondition::Clone() const
{
    return std::auto_ptr<StopConditionBase>(new EMValueDeviationCondition(*this));
}// Clone

//============================= ACCESS     ===================================

//============================= INQUIRY    ===================================

/* virtual */ bool
EMValueDeviationCondition::IsMet(
                const ColumnVector&         previousBestValue,
                const ColumnVector&         bestValue,
                const FunctionBase&         function,
                double                      pointStandardDeviation,
                double                      valueStandardDeviation,
                unsigned                    stagnantIterations) const
{
    assert(mcpComparison.Get() != NULL);

    return mcpComparison->IsMet(NullPoint, NullPoint, 0.0, 0.0,
            valueStandardDeviation);
}// IsMet

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
