/** Warunek stopu metody ewolucyjnej oparty
 * na odchyleniu standardowym liczonym
 * dla wartoci funkcji we wszystkich punktach
 * w populacji.
 *
 * Sprawdza, czy odchylenie standardowe wartoci funkcji
 * we wszystkich punktach jest mniejsze ni (<em>epsilon</em>).
 */

#ifndef _EMValueDeviationCondition_h
#define _EMValueDeviationCondition_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "EMStopCondition.h"

// FORWARD REFERENCES
//


class EMValueDeviationCondition
    : public EMStopCondition
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    EMValueDeviationCondition(void);


    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    EMValueDeviationCondition(const EMValueDeviationCondition& from);


    /** Destruktor.
     */
    ~EMValueDeviationCondition(void);


// OPERATORS

// OPERATIONS

    /** Tworzy kopi obiektu.
     */
    virtual std::auto_ptr<StopConditionBase>    Clone() const;

// ACCESS

// INQUIRY

    virtual bool        IsMet(
                const ColumnVector&         previousBestValue,
                const ColumnVector&         bestValue,
                const FunctionBase&         function,
                double                      pointStandardDeviation,
                double                      valueStandardDeviation,
                unsigned                    stagnantIterations) const;

protected:
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _EMValueDeviationCondition_h
