#include <precomp.h>

#include "EvaluationError.h"  // class implemented
#include "util.h"


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

//EvaluationError::EvaluationError()
//    : Error()
//{
//}// EvaluationError

EvaluationError::EvaluationError(const EvaluationError& from)
    : Error(from), mPoint(from.mPoint)
{
}// EvaluationError

EvaluationError::EvaluationError(const wxString&        description,
                                 const ColumnVector&    point)
    : Error(GenerateDescription(description, point)), mPoint(point)
{
}// EvaluationError

EvaluationError::~EvaluationError()
{
}// ~EvaluationError


//============================= OPERATORS ====================================

EvaluationError&
EvaluationError::operator=(const EvaluationError& from)
{
    Error::operator=(from);

    mPoint = from.mPoint;

    return *this;
}// =

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

ColumnVector
EvaluationError::Point() const
{
    return mPoint;
}// Point

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

wxString
EvaluationError::GenerateDescription(const wxString&        description,
                                     const ColumnVector&    point) const
{
    wxString string(_("Function evaluation error in point:\n"));
    string << point << wxT('\n');
    string << description;

    return string;
}// GenerateDescription
