/** Klasa reprezentujca bd w obliczaniu wartoci funkcji.
 *
 * Zawiera komunikat bdu oraz punkt, w ktrym bd wystpi.
 */

#ifndef _EvaluationError_h
#define _EvaluationError_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "Error.h"

// FORWARD REFERENCES
//


class EvaluationError
    : public Error
{
public:
// LIFECYCLE

//    /** Konstruktor domylny.
//     */
//    EvaluationError(void);


    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    EvaluationError(const EvaluationError& from);

    /** Konstruktor.
     *
     * @param description Opis/komunikat bdu.
     * @param point Punkt, w ktrym prbowano obliczy warto funkcji.
     */
    EvaluationError(const wxString& description, const ColumnVector& point);

    /** Destruktor.
     */
    ~EvaluationError(void);


// OPERATORS

    /** Operator przypisania.
     *
     * @param from Przypisywana warto.
     *
     * @return Referencja do biecego obiektu.
     */
    EvaluationError&    operator=(const EvaluationError& from);

// OPERATIONS
// ACCESS

    /** Zwraca punkt, w ktrym wystpi bd.
     */
    ColumnVector        Point() const;

// INQUIRY

protected:
private:
    wxString            GenerateDescription(const wxString&     description,
                                            const ColumnVector& point) const;

    ColumnVector mPoint;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _EvaluationError_h
