#include <precomp.h>
//#include <cassert>

#include "FunctionDecorator.h"  // class implemented

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

FunctionDecorator::FunctionDecorator()
    : mcpFunction()
{
}// FunctionDecorator

FunctionDecorator::FunctionDecorator(CountedPtr<const FunctionBase> cpFunction)
    : mcpFunction(cpFunction)
{
}// FunctionDecorator

FunctionDecorator::FunctionDecorator(const FunctionDecorator& from)
    : mcpFunction(from.mcpFunction->Clone())
{
}// FunctionDecorator

FunctionDecorator::~FunctionDecorator()
{
}// ~FunctionDecorator


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

void
FunctionDecorator::SetInnerFunction(CountedPtr<const FunctionBase> cpFunction)
{
    mcpFunction = cpFunction;
}// SetInner

const FunctionBase&
FunctionDecorator::InnerFunction() const
{
    assert(mcpFunction.Get() != NULL);

    return *(mcpFunction.Get());
}// InnerFunction

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
