/** Dekorator funkcji.
 *
 * Klasa definiuje interface dla dekoratorow funkcji.
 */

#ifndef _FunctionDecorator_h
#define _FunctionDecorator_h


// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "CountedPtr.h"
#include "FunctionBase.h"

// FORWARD REFERENCES
//

class FunctionDecorator
{
public:
// LIFECYCLE

    /** Konstruktor dmylny.
     */
    FunctionDecorator(void);

    /** Konstruktor.
     *
     * @param cpFunction <code>CountedPtr</code> na funkcje wewnetrzna.
     */
    FunctionDecorator(CountedPtr<const FunctionBase> cpFunction);

    /** Konstruktor kopiujcy.
     *
     * Klonuje funkcj wewntrzn.
     */
    FunctionDecorator(const FunctionDecorator& from);

    /** Destruktor.
     */
    ~FunctionDecorator(void);


// OPERATORS
// OPERATIONS

    /** Ustawia funkcje wewnetrzna.
     */
    void                SetInnerFunction(CountedPtr<const FunctionBase> cpFunction);

    /** Funkcja wewnetrzna.
     */
    const FunctionBase& InnerFunction() const;

// ACCESS
// INQUIRY

protected:
private:
    CountedPtr<const FunctionBase> mcpFunction;  ///< Funkcja wewnetrzna.
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _FunctionDecorator_h
