/** Klasa bazowa dla klas zawierajcych dane iteracji algorytmu optymalizacji.
 *
 * @see Result
 */

#ifndef _IterationData_h
#define _IterationData_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "FunctionBase.h"

// FORWARD REFERENCES
//


class IterationData
{
public:
    typedef unsigned    IterationDataIdType;

// LIFECYCLE


    virtual ~IterationData();

// OPERATORS

// OPERATIONS
// ACCESS

    /** Punkt, w ktrym naley mierzy warto na koniec iteracji.
     */
    virtual ColumnVector EndValuePoint() const = 0;

    /** Zwraca identyfikatory klasy oraz jej rodzicw.
     *
     * Kolejno identyfikatorw musi by od najbardziej szczegowej klasy do
     * najbardziej oglnej.
     *
     * Ten niezbyt adny mechanizm identyfikacji typw bdzie potrzebny przy
     * wyszukiwaniu odpowiedniego moduu wizualizacji dla danej klasy iteracji.
     */
    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();
// INQUIRY

protected:

    /** Generuje unikalny identyfikator.
     */
    static IterationDataIdType  GenerateId();

private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _IterationData_h
