#include <precomp.h>

#include "Error.h"
#include "LineSearch.h"  // class implemented
#include "Logger.h"
#include "OptimizationError.h"
#include "UnconstrainedProblem.h"
#include "UnivariateFunction.h"

LOGGER(INFO);

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

LineSearch::~LineSearch()
{
}// ~Method


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

double
LineSearch::FindOptimalStep(const UnivariateFunction& function) const
{
    Prestart();
    return this->Optimize(function);
}// FindOptimalStep

//============================= ACCESS     ===================================
/*
void
LineSearch::SetInitialSectionLength(double& initialSectionLength)
{
    mInitialSectionLength = initialSectionLength;
}
*/
//============================= INQUIRY    ===================================

/* virtual */ bool
LineSearch::CanHandle(const ProblemBase *pProblem) const
{
    // TODO: powinien by bardziej oglny?
    return ((dynamic_cast<const UnconstrainedProblem *>(pProblem) != NULL)
            && (dynamic_cast<const UnivariateFunction *>(&(pProblem->Function())) != NULL));
}// CanHandle

/////////////////////////////// PROTECTED  ///////////////////////////////////

LineSearch::LineSearch()
    : Method()
{
}// LineSearch

/////////////////////////////// PRIVATE    ///////////////////////////////////
