/**  Metoda optymalizacji w kierunku
 *   (optymalizacji funkcji jednej zmiennej).
 *
 * Klasa bazowa dla metod optymalizacji w kierunku.
 */

#ifndef _LineSearch_h
#define _LineSearch_h


// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "Method.h"
#include "UnivariateFunction.h"

// FORWARD REFERENCES
//


class LineSearch
    : public Method
{
public:
// LIFECYCLE

    /** Destruktor.
     */
    ~LineSearch(void);


// OPERATORS

// OPERATIONS

    /** Znajd optymaln dugo kroku.
     *
     * Wykonuje czynnoci przygotowawcze, a nastpnie dokonuje optymalizacji za
     * pomoc metody wirtualnej Optimize().
     *
     * @see Optimize
     */
    double          FindOptimalStep(const UnivariateFunction& function) const;

// ACCESS

// INQUIRY

    /** Sprawdza, czy metoda moe wspomc rozwizanie danego zadania.
     *
     * Dokadniej rzecz biorc sprawdzane jest, czy metoda moe by wykorzystana
     * przez metod optymalizacji wielu zmiennych do optymalizacji w kierunku
     * przy rozwizywaniu danego zadania optymalizacji.
     */
    virtual bool    CanAssist(const ProblemBase* pProblem) const = 0;

    // TODO: zrobi z tym porzdek
    virtual bool    CanHandle(const ProblemBase* pProblem) const;

protected:

    /** Konstruktor domylny.
     */
    LineSearch(void);

    /** Znajd optymaln dugo kroku.
      *
      * Wywoywana z FindOptimalStep.
      *
      * @see FindOptimalStep
      */
    // TODO: specyfikacja wyjtku to co?
    virtual double  Optimize(const UnivariateFunction& function)
                               const = 0;

private:

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _LineSearch_h_
