/**  Funkcja liniowa.
 *
 * Oprcz obliczania wartoci funkcji w punkcie mona obliczy wektor
 * wspczynnikw przy poszczeglnych zmiennych oraz warto wyrazu wolnego.
 */

#ifndef _LinearFunction_h
#define _LinearFunction_h


// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "NonlinearFunction.h"

// FORWARD REFERENCES
//

class LinearFunction
    : public NonlinearFunction
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    LinearFunction(void);


    /** Konstruktor przyjmujcy wektor wspczynnikw i zmienne.
     *
     * @param coefficients Wspczynniki przy kolejnych zmiennych.
     * @param a0 Wyraz wolny.
     * @param textForm Reprezentacja tekstowa funkcji.
     */
    LinearFunction(std::auto_ptr<const FunctionTree>    apFunction,
                   const wxString&                      textForm = wxT(""));


    /** Destructor.
     */
    virtual ~LinearFunction(void);


// OPERATORS

// OPERATIONS
    virtual std::auto_ptr<FunctionBase> Clone() const;

// ACCESS
    virtual wxString                ToString(bool full) const;

    /** Wylicza wektor wspczynnikw definiujcych funkcj.
     */
    virtual RowVector               Coefficients() const;

    /** Oblicza wspczynnik a0.
     */
    virtual double                  A0() const;

// INQUIRY

protected:
    LinearFunction(const LinearFunction& from);

private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _LinearFunction_h_
