/** Parser funkcji liniowych.
 *
 */

#ifndef _LinearParser_h
#define _LinearParser_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "Parser.h"
#include "Tokenizer.h"

// FORWARD REFERENCES
//


class LinearParser
    : public Parser
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    LinearParser(void);


    /** Destruktor.
     */
    ~LinearParser(void);


// OPERATORS

// OPERATIONS

    virtual std::auto_ptr<FunctionBase> CreateFunction(
                                                const wxString& input,
                                                VariableNames&  rVariables,
                                                bool            resetVariables)
                                        const throw(ParseError);


// ACCESS
// INQUIRY

protected:
private:
    /// Parsuje wyraenie
    std::auto_ptr<const FunctionTree>   Expression(Tokenizer& rTokenizer) const;

    /// Parsuje iloczyn (zezwala tylko na jedn zmienn)
    std::auto_ptr<const FunctionTree>   Product(Tokenizer&  rTokenizer,
                                                bool        first = false)
                                        const;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _LinearParser_h
