#include <precomp.h>

#include "MultivariateConstrainedIteration.h"  // class implemented

using namespace std;

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

MultivariateConstrainedIteration::MultivariateConstrainedIteration
                            (const ColumnVector&    previousApproximation,
                                   bool             previousApproximationValid,
                             const ColumnVector&    newApproximation,
                                   bool             newApproximationValid,
                                   unsigned         evaluationCount,
                                   unsigned         iterationCount,
                                   double           penaltyParam)
    : ConstrainedOptimizationIteration
        (previousApproximationValid,
         newApproximationValid,
         evaluationCount,
         iterationCount,
         penaltyParam),
      mPreviousApproximation(previousApproximation),
      mNewApproximation(newApproximation)
{
}// MultivariateConstrainedIteration

MultivariateConstrainedIteration::~MultivariateConstrainedIteration()
{
}// ~MultivariateConstrainedIteration

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ vector<IterationData::IterationDataIdType>
MultivariateConstrainedIteration::ClassIds() const
{
    // Bierzemy identyfikatory od bezporedniego rodzica
    vector<IterationDataIdType> base_ids
                            (ConstrainedOptimizationIteration::ClassIds());

    base_ids.insert(base_ids.begin(),
                    MultivariateConstrainedIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
MultivariateConstrainedIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId

/* virtual */ ColumnVector
MultivariateConstrainedIteration::EndValuePoint() const
{
    return mNewApproximation;
}// EndValue


const ColumnVector&
MultivariateConstrainedIteration::PreviousApproximation() const
{
    return mPreviousApproximation;
}

const ColumnVector&
MultivariateConstrainedIteration::NewApproximation() const
{
    return mNewApproximation;
}

//============================= INQUIRY    ===================================

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
