/** Dane pojedynczej iteracji optymalizacji z ograniczeniami w wielu wymiarach.
 *
 * @see ConstrainedOptimizationIteration
 */

#ifndef _MultivariateConstrainedIteration_h
#define _MultivariateConstrainedIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "ConstrainedOptimizationIteration.h"

// FORWARD REFERENCES
//

class MultivariateConstrainedIteration
    : public ConstrainedOptimizationIteration
{
public:

// LIFECYCLE

    MultivariateConstrainedIteration(const ColumnVector&      previousApproximation,
                                 bool               previousApproximationValid,
                           const ColumnVector&      newApproximation,
                                 bool               newApproximationValid,
                                 unsigned           evaluationCount,
                                 unsigned           iterationCount,
                                 double             penaltyParam);

    /** Destruktor.
     */
    ~MultivariateConstrainedIteration(void);

// OPERATORS
// OPERATIONS
// ACCESS

    virtual ColumnVector                EndValuePoint() const;

    virtual vector<IterationDataIdType> ClassIds() const;

    static  IterationDataIdType         ClassId();

    const   ColumnVector&               PreviousApproximation() const;
    const   ColumnVector&               NewApproximation() const;

// INQUIRY

protected:
private:

    ColumnVector    mPreviousApproximation;
    ColumnVector    mNewApproximation;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _MultivariateConstrainedIteration_h
