#include <precomp.h>

#include "util.h"

#include "NMBestWorstCondition.h"  // class implemented
#include "Logger.h"

LOGGER(DEBUG);

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

NMBestWorstCondition::NMBestWorstCondition()
    : NMStopCondition()
{
    // TODO: nazwy
//    mName = wxT("|| x_b k - x_w k ||");
}// NMBestWorstCondition

NMBestWorstCondition::NMBestWorstCondition(
        CountedPtr<StandardStopCondition> cpComparison)
    : NMStopCondition(cpComparison)
{
}// NMBestWorstCondition

NMBestWorstCondition::NMBestWorstCondition(const NMBestWorstCondition& from)
    : NMStopCondition(from)
{
}// NMBestWorstCondition

NMBestWorstCondition::~NMBestWorstCondition()
{
}// ~NMBestWorstCondition


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

std::auto_ptr<StopConditionBase>
NMBestWorstCondition::Clone() const
{
    return std::auto_ptr<StopConditionBase>(new NMBestWorstCondition(*this));
}// Clone

//============================= ACCESS     ===================================

//============================= INQUIRY    ===================================

/* virtual */ bool
NMBestWorstCondition::IsMet(const PointWithValue&     bestPoint,
                            const PointWithValue&     worstPoint,
                            const PointWithValue&     previousWorstPoint,
                            const PointWithValue&     worstReplacement,
                            double                    circumference) const
{
    assert(mcpComparison.Get() != NULL);

    return mcpComparison->IsMet(worstPoint.mPoint, bestPoint.mPoint,
                                worstPoint.mValue, bestPoint.mValue);
}// IsMet

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
