#include <precomp.h>

#include "CustomValueCondition.h"
#include "util.h"

#include "NMCircumferenceCondition.h"  // class implemented
#include "Logger.h"

LOGGER(DEBUG);

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

NMCircumferenceCondition::NMCircumferenceCondition()
    : NMStopCondition(CountedPtr<StandardStopCondition>(
                        new CustomValueCondition))
{
    mName = _("Circumference");
}// NMCircumferenceCondition

NMCircumferenceCondition::NMCircumferenceCondition
    (const NMCircumferenceCondition& from)
    : NMStopCondition(from)
{
}// NMCircumferenceCondition

NMCircumferenceCondition::~NMCircumferenceCondition()
{
}// ~NMCircumferenceCondition


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

std::auto_ptr<StopConditionBase>
NMCircumferenceCondition::Clone() const
{
    return std::auto_ptr<StopConditionBase>(new NMCircumferenceCondition(*this));
}// Clone

//============================= ACCESS     ===================================

//============================= INQUIRY    ===================================

/* virtual */ bool
NMCircumferenceCondition::IsMet(const PointWithValue&     bestPoint,
                                const PointWithValue&     worstPoint,
                                const PointWithValue&     previousWorstPoint,
                                const PointWithValue&     worstReplacement,
                                double                    circumference) const
{
    assert(mcpComparison.Get() != NULL);

    return mcpComparison->IsMet(NullPoint, NullPoint, 0.0, 0.0, circumference);
}// IsMet

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
