/** Warunek stopu oparty na obwodzie sympleksu
 *
 * Sprawdza, czy obwd obecnego sympleksu jest
 * mniejszy ni (<em>epsilon</em>).
 */

#ifndef _NMCircumferenceCondition_h
#define _NMCircumferenceCondition_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "NMStopCondition.h"

// FORWARD REFERENCES
//


class NMCircumferenceCondition
    : public NMStopCondition
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    NMCircumferenceCondition(void);


    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    NMCircumferenceCondition(const NMCircumferenceCondition& from);


    /** Destruktor.
     */
    ~NMCircumferenceCondition(void);


// OPERATORS

// OPERATIONS

    /** Tworzy kopi obiektu.
     */
    virtual std::auto_ptr<StopConditionBase>    Clone() const;

// ACCESS

// INQUIRY

    /** Sprawd warunek stopu.
     *
     * @see NMStopCondition::IsMet
     */
     virtual bool        IsMet(const PointWithValue&     bestPoint,
                               const PointWithValue&     worstPoint,
                               const PointWithValue&     previousWorstPoint,
                               const PointWithValue&     worstReplacement,
                               double                    circumference) const;
protected:
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _NMCircumferenceCondition_h
