#include <precomp.h>

#include "util.h"

#include "NMPreviousWorstCondition.h"  // class implemented
#include "Logger.h"

LOGGER(DEBUG);

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

NMPreviousWorstCondition::NMPreviousWorstCondition()
    : NMStopCondition()
{
    // TODO: nazwy
//    mName = wxT("|| x_b k - x_w k ||");
}// NMPreviousWorstCondition

NMPreviousWorstCondition::NMPreviousWorstCondition(
        CountedPtr<StandardStopCondition> cpComparison)
    : NMStopCondition(cpComparison)
{
}// NMPreviousWorstCondition

NMPreviousWorstCondition::NMPreviousWorstCondition(
        const NMPreviousWorstCondition& from)
    : NMStopCondition(from)
{
}// NMPreviousWorstCondition

NMPreviousWorstCondition::~NMPreviousWorstCondition()
{
}// ~NMPreviousWorstCondition


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

std::auto_ptr<StopConditionBase>
NMPreviousWorstCondition::Clone() const
{
    return std::auto_ptr<StopConditionBase>(new NMPreviousWorstCondition(*this));
}// Clone

//============================= ACCESS     ===================================

//============================= INQUIRY    ===================================

/* virtual */ bool
NMPreviousWorstCondition::IsMet(const PointWithValue&     bestPoint,
                                const PointWithValue&     worstPoint,
                                const PointWithValue&     previousWorstPoint,
                                const PointWithValue&     worstReplacement,
                                double                    circumference)
                                                                        const
{
    assert(mcpComparison.Get() != NULL);

    return mcpComparison->IsMet(previousWorstPoint.mPoint, worstPoint.mPoint,
                                previousWorstPoint.mValue, worstPoint.mValue);
}// IsMet

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
