#include <precomp.h>

#include "NMStopCondition.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

NMStopCondition::NMStopCondition()
    : StopConditionBase(),
      mcpComparison()
{
}// NMStopCondition

NMStopCondition::NMStopCondition(CountedPtr<StandardStopCondition> cpComparison)
    : StopConditionBase(),
      mcpComparison(cpComparison)
{
}//NMStopCondition

NMStopCondition::NMStopCondition(const NMStopCondition& from)
    : StopConditionBase(from),
      mcpComparison(from.mcpComparison)
{
}// NMStopCondition

NMStopCondition::~NMStopCondition()
{
}// ~NMStopCondition


//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ DoubleParameter
NMStopCondition::Epsilon() const
{
    assert(mcpComparison.Get() != NULL);

    return mcpComparison->Epsilon();
}// Epsilon

/* virtual */ DoubleParameter&
NMStopCondition::rEpsilon()
{
    assert(mcpComparison.Get() != NULL);

    return mcpComparison->rEpsilon();
}// Epsilon

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
