#include <precomp.h>

#include "util.h"

#include "NMWorstReplacementCondition.h"  // class implemented
#include "Logger.h"

LOGGER(DEBUG);

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

NMWorstReplacementCondition::NMWorstReplacementCondition()
    : NMStopCondition()
{
    // TODO: nazwy
//    mName = wxT("|| x_b k - x_w k ||");
}// NMWorstReplacementCondition

NMWorstReplacementCondition::NMWorstReplacementCondition(
        CountedPtr<StandardStopCondition> cpComparison)
    : NMStopCondition(cpComparison)
{
}// NMWorstReplacementCondition

NMWorstReplacementCondition::NMWorstReplacementCondition(
        const NMWorstReplacementCondition& from)
    : NMStopCondition(from)
{
}// NMWorstReplacementCondition

NMWorstReplacementCondition::~NMWorstReplacementCondition()
{
}// ~NMWorstReplacementCondition


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

std::auto_ptr<StopConditionBase>
NMWorstReplacementCondition::Clone() const
{
    return std::auto_ptr<StopConditionBase>(new NMWorstReplacementCondition(*this));
}// Clone

//============================= ACCESS     ===================================

//============================= INQUIRY    ===================================

/* virtual */ bool
NMWorstReplacementCondition::IsMet(const PointWithValue&     bestPoint,
                                   const PointWithValue&     worstPoint,
                                   const PointWithValue&     previousWorstPoint,
                                   const PointWithValue&     worstReplacement,
                                   double                    circumference)
                                                                        const
{
    assert(mcpComparison.Get() != NULL);

    return mcpComparison->IsMet(worstPoint.mPoint, worstReplacement.mPoint,
                                worstPoint.mValue, worstReplacement.mValue);
}// IsMet

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
