//TODO: szerszy opis
/** Parser funkcji liniowych.
 *
 * W przypadku funkcji jednej zmiennej tworzy obiekt klasy
 * UnivariateNonlinearFunction.
 */

#ifndef _NonlinearParser_h
#define _NonlinearParser_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "Parser.h"
#include "Tokenizer.h"

// FORWARD REFERENCES
//


class NonlinearParser
    : public Parser
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    NonlinearParser(void);


    /** Destruktor.
     */
    ~NonlinearParser(void);


// OPERATORS

// OPERATIONS

    virtual std::auto_ptr<FunctionBase> CreateFunction(
                                                const wxString& input,
                                                VariableNames&  rVariables,
                                                bool            resetVariables)
                                        const throw(ParseError);


// ACCESS
// INQUIRY

protected:
private:
    /// Parsuje wyraenie.
    std::auto_ptr<const FunctionTree>   Expression(Tokenizer& rTokenizer) const;

    /// Parsuje iloczyn.
    std::auto_ptr<const FunctionTree>   Product(Tokenizer&  rTokenizer,
                                                bool        first = false)
                                        const;

    /// Parsuje wyraenie potgowe (w tym obsuguje negacj, gdy first == true)
    std::auto_ptr<const FunctionTree>   Power(Tokenizer&  rTokenizer,
                                              bool        first = false)
                                        const;

    /// Parsuje operand (funkcja, liczba, zmienna)
    std::auto_ptr<const FunctionTree>   Operand(Tokenizer&  rTokenizer)
                                        const;

    /// Parsuje funkcj (nazwa "(" wyraenie ")")
    std::auto_ptr<const FunctionTree>   Function(Tokenizer&  rTokenizer) const;

    /// Inicjuje list funkcji.
    static Tokenizer::FunctionMap       MakeFunctionMap();

    const static Tokenizer::FunctionMap mFunctions;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _NonlinearParser_h
