#include <precomp.h>

#include "Logger.h"

#include "Observable.h"  // class implemented

LOGGER(INFO)

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

Observable::Observable()
    : mObservers()
{
}// Observable

//Observable::Observable(const Observable& from)
//{
//}// Observable

Observable::~Observable()
{
    while (!mObservers.empty())
    {
        mObservers.back()->RemoveObservable(this);
        mObservers.pop_back();
    }
}// ~Observable


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

void
Observable::AttachObserver(Observer* pObserver) const
{
    assert(pObserver != NULL);
    // TODO: obserwator sam powinien si docza/odcza
    mObservers.push_back(pObserver);
    pObserver->AddObservable(this);
    LOG(DEBUG, wxT("Observer list size: ")
            << static_cast<unsigned>(mObservers.size()));
}// AttachObserver

void
Observable::DetachObserver(Observer* pObserver) const
{
    vector<Observer*>::iterator position;

    position = find(mObservers.begin(), mObservers.end(), pObserver);
    mObservers.erase(position);
    pObserver->RemoveObservable(this);
}// DetachObserver

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

void
Observable::NotifyObservers() const
{
    vector<Observer*>::iterator i;

    LOG(DEBUG, wxT("Notify observers"));
    LOG(DEBUG, wxT("Observer list size: ")
            << static_cast<unsigned>(mObservers.size()));

    for (i = mObservers.begin(); i != mObservers.end(); ++i) (*i)->Update();
}// NotifyObservers

/////////////////////////////// PRIVATE    ///////////////////////////////////
