#ifndef _Observer_h
#define _Observer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//

// FORWARD REFERENCES
//
class Observable;

/** Obserwator.
 *
 * Razem z klas Observable tworz wzorzec projektowy obserwatora, a
 * przynajmniej co na jego ksztat.
 *
 * Obserwator przechowuje wskanik na obiekt obserwowany (ustawiany w
 * Observable::AttachObserver i Observable::DetachObserver).
 *
 * @see Observable
 */

class Observer
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    Observer(void);


    /** Destruktor.
     */
    virtual ~Observer(void);


// OPERATORS

// OPERATIONS

    /** Aktualizacja.
     *
     * Wywoywana przez obiekt obserwowany, gdy nastpi zmiana jego stanu.
     */
    virtual void        Update() = 0;

//    // TODO: to nie jest dobre miejsce na takie rzeczy...
//    virtual bool        IsAborted();

// ACCESS
// INQUIRY

protected:
    std::set<const Observable*> mObservables;

private:

    friend class Observable;
    // Te funkcje s dostpne obserwowanemu:
    void                AddObservable(const Observable* pObservable);
    void                RemoveObservable(const Observable* pObservable);

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _Observer_h
