#include <precomp.h>

#include "OptimizationError.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

//OptimizationError::OptimizationError()
//    : Error(), mcpResult()
//{
//}// OptimizationError

OptimizationError::OptimizationError(const OptimizationError& from)
    : Error(from), mcpResult(from.mcpResult)
{
}// OptimizationError

OptimizationError::OptimizationError(const wxString&        description,
                                     std::auto_ptr<Result>  apResult)
    : Error(description), mcpResult(apResult)
{
}

OptimizationError::~OptimizationError()
{
}// ~OptimizationError


//============================= OPERATORS ====================================

OptimizationError&
OptimizationError::operator=(const OptimizationError& from)
{
    Error::operator=(from);

    mcpResult = from.mcpResult;

    return *this;
}// =

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

Result&
OptimizationError::rResult()
{
    assert(HasResult());

    return *mcpResult;
}// rResult

CountedPtr<Result>
OptimizationError::GiveResult() const
{
    return mcpResult;
}// GiveResult

//============================= INQUIRY    ===================================

bool
OptimizationError::HasResult() const
{
    return mcpResult.Get() != NULL;
}// HasResult

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
