#include <precomp.h>

#include "Logger.h"
#include "ParseError.h"  // class implemented

LOGGER(INFO);

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================


ParseError::ParseError(const wxString&  input,
                       const wxString&  message,
                       unsigned         position)
    : Error(wxT("")), mInput(input), mMessage(message), mPosition(position)
{
    LOG(DEBUG, position);
    mDescription << wxString(_("Parse error at "));
    // Bez Format nie dziaao, syf
    mDescription << wxString::Format(wxT("%u"), mPosition);
    mDescription << wxString(_(": ")) << mMessage;
}// ParseError

ParseError::ParseError(const ParseError& from)
    : Error(from),
      mInput(from.mInput),
      mMessage(from.mMessage),
      mPosition(from.mPosition)
{
}// ParseError


ParseError::~ParseError()
{
}// ~ParseError


//============================= OPERATORS ====================================

ParseError&
ParseError::operator=(const ParseError& from)
{
    mInput      = from.mInput;
    mMessage    = from.mMessage;
    mPosition   = from.mPosition;

    return *this;
}// =

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
const wxString&
ParseError::Input() const
{
    return mInput;
}

const wxString&
ParseError::ErrorMessage() const
{
    return mMessage;
}

unsigned
ParseError::Position() const
{
    return mPosition;
}
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
