/**  Wyjtek reprezentujcy bd parsowania.
 *
 * Zawiera parsowany cig znakw, przyczyn/komunikat oraz offset, na ktrym
 * zatrzyma si parser.
 */

#ifndef _ParseError_h
#define _ParseError_h


// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//
//#include <wx/string.h>

// LOCAL INCLUDES
//
#include "Error.h"

// FORWARD REFERENCES
//


class ParseError
    : public Error
{
public:
// LIFECYCLE

//    /** Konstruktor domylny.
//     */
//    ParseError(void);


    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    ParseError(const ParseError& from);


    /** Konstruktor.
     *
     * @param input Tekst wejciowy, ktrego by parsowany.
     * @param message Komunikat o bdzie.
     * @param position Numer znaku, na ktrym przerwano parsowanie (liczc od
     * 0).
     */
    ParseError(const wxString& input, const wxString& message, unsigned position);


    /** Destruktor.
     */
    ~ParseError(void);


// OPERATORS

    /** Operator przypisania.
     *
     * @param from Przypisywana warto.
     *
     * @return Referencja do biecego obiektu.
     */
    ParseError&                 operator=(const ParseError& from);

// OPERATIONS

// ACCESS

    /** Zwraca cig znakw, ktry by parsowany.
     */
    const wxString&             Input() const;

    /** Zwraca komunikat parsera o bdzie.
     */
    const wxString&             ErrorMessage() const;

    /** Zwraca pozycj znaku, na ktrym zatrzyma si parser (pierwszy znak ma
     * offset 0).
     */
    unsigned                    Position() const;

// INQUIRY

protected:
private:
    wxString    mInput;     ///< Cig wejciowy dla parsera.
    wxString    mMessage;   ///< Komunikat parsera.
    unsigned    mPosition;  ///< Pozycja, na ktrej wystpi bd.
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _ParseError_h_
