/** Klasa bazowa dla parserw wyrae matematycznych.
 */

#ifndef _Parser_h
#define _Parser_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "FunctionBase.h"
#include "ParseError.h"
#include "VariableNames.h"

// FORWARD REFERENCES
//


class Parser
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    Parser(void);

    /** Destruktor.
     */
    virtual ~Parser(void);


// OPERATORS

// OPERATIONS

    /** Tworzy funkcje na podstawie ciagu znakow.
     *
     * @param input Ciag znakow reprezentujacy funkcje.
     * @param variables Referencja na zmienne.
     * @param resetVariables Czy tworzyc zmienne na podst. funkcji, czy uzywac
     * zastanych.
     *
     * @return <code>auto_ptr</code> na funkcje.
     *
     * @exception ParseError Sygnalizowany, gdy nie mozna sparsowac funkcji.
     */
    virtual std::auto_ptr<FunctionBase> CreateFunction(
                                                const wxString& input,
                                                VariableNames&  rVariables,
                                                bool            resetVariables)
                                        const throw(ParseError) = 0;

// ACCESS
// INQUIRY

    /// Operator dodawania dla funkcji.
    static double   OperatorAdd(double a, double b);
    /// Operator odejmowania dla funkcji.
    static double   OperatorSubtract(double a, double b);
    /// Operator mnoenia dla funkcji.
    static double   OperatorMultiply(double a, double b);
    /// Operator dzielenia dla funkcji.
    static double   OperatorDivide(double a, double b);
    /// Operator negacji dla funkcji.
    static double   OperatorNegate(double a);
protected:
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _Parser_h
