#include <precomp.h>

#include "PointWithValue.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

PointWithValue::PointWithValue()
    : mPoint(NullPoint), mValue(0.0)
{
    mPoint = 0.0;
}// PointWithValue

PointWithValue::PointWithValue(unsigned int size)
    : mPoint(size), mValue(0.0)
{
    mPoint = 0.0;
}// PointWithValue

PointWithValue::PointWithValue(const ColumnVector& point)
    : mPoint(point), mValue(0.0)
{
}

PointWithValue::PointWithValue(const ColumnVector& point, double value)
    : mPoint(point),
      mValue(value)
{
}

PointWithValue::PointWithValue(const PointWithValue& from)
    : mPoint(from.mPoint), mValue(from.mValue)
{
}// PointWithValue

PointWithValue::~PointWithValue()
{
}// ~PointWithValue


//============================= OPERATORS ====================================

PointWithValue&
PointWithValue::operator=(const PointWithValue& from)
{
    mPoint = from.mPoint;
    mValue = from.mValue;
    return *this;
}// =

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
//

bool
operator==(const PointWithValue& left, const PointWithValue& right)
{
    if (left.mValue == right.mValue &&
        left.mPoint == right.mPoint)
                                        return true;
    else                                return false;
}

bool
operator!=(const PointWithValue& left, const PointWithValue& right)
{
    if (left.mValue != right.mValue ||
        left.mPoint != right.mPoint)
                                        return true;
    else                                return false;
}

bool
operator> (const PointWithValue& left, const PointWithValue& right)
{
    if (left.mValue >  right.mValue)    return true;
    else                                return false;
}

bool
operator>=(const PointWithValue& left, const PointWithValue& right)
{
    if (left.mValue >= right.mValue)    return true;
    else                                return false;
}

bool
operator< (const PointWithValue& left, const PointWithValue& right)
{
    if (left.mValue <  right.mValue)    return true;
    else                                return false;
}

bool
operator<=(const PointWithValue& left, const PointWithValue& right)
{
    if (left.mValue <= right.mValue)    return true;
    else                                return false;
}
/*
std::ostream&
operator<<(std::ostream& os, const PointWithValue& point)
{
    os << wxT("Point: \n") << point.mPoint.AsRow();
    os << wxT("Value: \n") << point.mValue;

    return os;
}

wxTextOutputStream&
operator<<(wxTextOutputStream& os, const PointWithValue& point)
{
    os << wxT("Point: \n") << point.mPoint.AsRow();
    os << wxT("Value: \n") << point.mValue;

    return os;
}
*/
