/** Punkt z wartoci funkcji
 *
 * Prosta klasa przechowujca wsprzdne punktu wraz z waroci funkcji celu w
 * tym punkcie. Klasa jest wykorzystywana w metodach optymalizacji, w ktrych
 * w kolejnych iteracjach wystpuj te same punkty, takich jak metoda
 * Neldera-Meada i metoda losowa.
 * TODO: genetyczna?
 */

#ifndef _PointWithValue_h
#define _PointWithValue_h


// SYSTEM INCLUDES
//
//#include <iostream>

// PROJECT INCLUDES
//
//#include <newmat/newmat.h>
//#include <wx/txtstrm.h>

// LOCAL INCLUDES
//
#include "util.h"

// FORWARD REFERENCES
//


class PointWithValue
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    PointWithValue(void);

    /** Konstruktor.
     */
    PointWithValue(unsigned int size);

    /** Konstruktor
     *
     * @param point Punkt
     */
    PointWithValue(const ColumnVector& point);

    /** Konstruktor
     *
     * @param point Punkt
     * @param value Warto funkcji w punkcie
     */
    PointWithValue(const ColumnVector& point, double value);

    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    PointWithValue(const PointWithValue& from);


    /** Destruktor.
     */
    ~PointWithValue(void);


// OPERATORS

    /** Operator przypisania.
     *
     * @param from Przypisywana warto.
     *
     * @return Referencja do biecego obiektu.
     */
    PointWithValue&          operator=(const PointWithValue& from);

// OPERATIONS
// ACCESS
// INQUIRY

    ColumnVector    mPoint; ///< Punkt.
    double          mValue; ///< Warto funkcji w punkcie mPoint.

protected:


private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//



bool                operator==(const PointWithValue& left,
                               const PointWithValue& right);

bool                operator!=(const PointWithValue& left,
                               const PointWithValue& right);

bool                operator> (const PointWithValue& left,
                               const PointWithValue& right);

bool                operator>=(const PointWithValue& left,
                               const PointWithValue& right);

bool                operator< (const PointWithValue& left,
                               const PointWithValue& right);

bool                operator<=(const PointWithValue& left,
                               const PointWithValue& right);
/*
std::ostream&       operator<<(std::ostream&         os,
                               const PointWithValue& point);

wxTextOutputStream& operator<<(wxTextOutputStream&   os,
                               const PointWithValue& point);
*/
#endif  // _PointWithValue_h
