#include <precomp.h>

#include "Region.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

Region::Region()
    : mX1(0.0), mX2(0.0), mY1(0.0), mY2(0.0), mValid(false)
{
}// Region

Region::Region(double x1, double y1, double x2, double y2)
    : mX1(x1), mX2(x2), mY1(y1), mY2(y2), mValid(true)
{
}// Region

Region::Region(const Region& from)
    : mX1(from.mX1),
      mX2(from.mX2),
      mY1(from.mY1),
      mY2(from.mY2),
      mValid(from.mValid)
{
}// Region

Region::~Region()
{
}// ~Region


//============================= OPERATORS ====================================

Region&
Region::operator=(const Region& from)
{
    mX1     = from.mX1;
    mX2     = from.mX2;
    mY1     = from.mY1;
    mY2     = from.mY2;
    mValid  = from.mValid;

    return *this;
}// =

Region&
Region::operator+=(const Region& from)
{
    if (from.mValid)
    {
        if (mValid)
        {
            mX1 = min<double>(mX1, from.mX1);
            mX2 = max<double>(mX2, from.mX2);
            mY1 = min<double>(mY1, from.mY1);
            mY2 = max<double>(mY2, from.mY2);
        }
        else *this = from;
    }

    return *this;
}// +=

Region
Region::operator+(const Region& from) const
{
    Region result(*this);

    result += from;
    return result;
}// +

//============================= OPERATIONS ===================================

void
Region::Extend(double x, double y)
{
    if (mValid)
    {
        if (x < mX1)        mX1 = x;
        else if (x > mX2)   mX2 = x;

        if (y < mY1)        mY1 = y;
        else if (y > mY2)   mY2 = y;
    }
    else
    {
        mX1 = x;
        mX2 = x;
        mY1 = y;
        mY2 = y;
        mValid = true;
    }
}// Extend

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
