#include <precomp.h>

#include "StandardStopCondition.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

StandardStopCondition::StandardStopCondition()
    : StopConditionBase(),
      mEpsilon(0.001, 0, true)
{
}// StandardStopCondition

StandardStopCondition::StandardStopCondition(const DoubleParameter epsilon)
    : StopConditionBase(),
      mEpsilon(epsilon)
{
}// StandardStopCondition

StandardStopCondition::StandardStopCondition(const StandardStopCondition& from)
    : StopConditionBase(from),
      mEpsilon(from.mEpsilon)
{
}// StandardStopCondition

StandardStopCondition::~StandardStopCondition()
{
}// ~StandardStopCondition


//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ DoubleParameter
StandardStopCondition::Epsilon() const
{
    return mEpsilon;
}// Epsilon

/* virtual */ DoubleParameter&
StandardStopCondition::rEpsilon()
{
    return mEpsilon;
}// Epsilon

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
