#include <precomp.h>

#include "Symbols.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

Symbols::~Symbols()
{
}// ~Symbols


//============================= OPERATORS ====================================

const wxString&
Symbols::operator[](Symbols::SymbolType symbol) const
{
    assert (mSymbols.find(symbol) != mSymbols.end());

//    return mSymbols[symbol];
    return mSymbols.find(symbol)->second;
}// []

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* static */ const Symbols&
Symbols::GetInstance()
{
    static Symbols instance;

    return instance;
}// GetInstance

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

Symbols::Symbols()
    : mSymbols()
{
    mSymbols[ALPHA]         = wxT("\x03B1");
    mSymbols[BETA]          = wxT("\x03B2");
    mSymbols[GAMMA]         = wxT("\x03B3");
    mSymbols[DELTA]         = wxT("\x03B4");
    mSymbols[EPSILON]       = wxT("\x03B5");
    mSymbols[LAMBDA]        = wxT("\x03BB");
    mSymbols[MU]            = wxT("\x03BC");
    mSymbols[RHO]           = wxT("\x03C1");
    mSymbols[SIGMA]         = wxT("\x03C3");
    mSymbols[TAU]           = wxT("\x03C4");

    mSymbols[LESS_EQUAL]    = wxT("\x2264");
    mSymbols[GREATER_EQUAL] = wxT("\x2265");
    mSymbols[INFINITY]      = wxT("\x221E");
}// Symbols
