/**  Typowe zadanie optymalizacji bez ogranicze.
 */

#ifndef _UnconstrainedProblem_h
#define _UnconstrainedProblem_h


// SYSTEM INCLUDES
//
//#include <memory>

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "ProblemBase.h"
#include "PenaltyFunction.h"

// FORWARD REFERENCES
//


class UnconstrainedProblem
    : public ProblemBase
{
public:

    /** Panel wprowadzania danych zadania.
     */
    friend class UnconstrainedProblemPanel;

// LIFECYCLE

    /** Destruktor.
     */
    ~UnconstrainedProblem(void);


// OPERATORS

// OPERATIONS

    /** Tworzy nowy problem tej samej klasy.
     */
    virtual std::auto_ptr<ProblemBase>  Clone() const;

    /** Tworzy tekstowy opis obiektu.
     */
    virtual wxString                    ToString() const;

// ACCESS

    /** Zwraca nazw problemu.
     */
    virtual wxString                    Name() const;

    /** Zwraca ID problemu.
     */
    virtual ProblemIdType               Id() const;

    /** Zwraca ID klasy problemu.
     */
    static ProblemIdType                ClassId();

// INQUIRY
protected:
    /** Konstruktor domylny.
     *
     * @param doRegister Czy rejestrowac problem jako prototyp.
     */
    UnconstrainedProblem(bool doRegister = false);

    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    UnconstrainedProblem(const UnconstrainedProblem& from);


private:
    static const wxString       mName;                  ///< Nazwa
    static UnconstrainedProblem mUnconstrainedProblem;  ///< Prototyp
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _UnconstrainedProblem_h_
