#include <precomp.h>

#include "UnivariateConstrainedIteration.h"  // class implemented

using namespace std;

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

UnivariateConstrainedIteration::UnivariateConstrainedIteration
                            (double     previousApproximation,
                             bool       previousApproximationValid,
                             double     newApproximation,
                             bool       newApproximationValid,
                             unsigned   evaluationCount,
                             unsigned   iterationCount,
                             double     penaltyParam)
    : ConstrainedOptimizationIteration
        (previousApproximationValid,
         newApproximationValid,
         evaluationCount,
         iterationCount,
         penaltyParam),
      mPreviousApproximation(previousApproximation),
      mNewApproximation(newApproximation)
{
}// UnivariateConstrainedIteration

UnivariateConstrainedIteration::~UnivariateConstrainedIteration()
{
}// ~UnivariateConstrainedIteration

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ vector<IterationData::IterationDataIdType>
UnivariateConstrainedIteration::ClassIds() const
{
    // Bierzemy identyfikatory od bezporedniego rodzica
    vector<IterationDataIdType> base_ids
                            (ConstrainedOptimizationIteration::ClassIds());

    base_ids.insert(base_ids.begin(),
                    UnivariateConstrainedIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
UnivariateConstrainedIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId

/* virtual */ ColumnVector
UnivariateConstrainedIteration::EndValuePoint() const
{
    ColumnVector    result(1);

    result = mNewApproximation;

    return result;
}// EndValue


double
UnivariateConstrainedIteration::PreviousApproximation() const
{
    return mPreviousApproximation;
}

double
UnivariateConstrainedIteration::NewApproximation() const
{
    return mNewApproximation;
}

//============================= INQUIRY    ===================================

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
