/** Dane pojedynczej iteracji metody Neldera-Meada.
 *
 * @see HookeJeevesDiscrete, Result
 */

#ifndef _UnivariateConstrainedIteration_h
#define _UnivariateConstrainedIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "ConstrainedOptimizationIteration.h"

// FORWARD REFERENCES
//

class UnivariateConstrainedIteration
    : public ConstrainedOptimizationIteration
{
public:

// LIFECYCLE

    UnivariateConstrainedIteration(double     previousApproximation,
                                   bool       previousApproximationValid,
                                   double     newApproximation,
                                   bool       newApproximationValid,
                                   unsigned   evaluationCount,
                                   unsigned   iterationCount,
                                   double     penaltyParam);

    /** Destruktor.
     */
    ~UnivariateConstrainedIteration(void);

// OPERATORS
// OPERATIONS
// ACCESS

    virtual ColumnVector                EndValuePoint() const;

    virtual vector<IterationDataIdType> ClassIds() const;

    static  IterationDataIdType         ClassId();

    double                              PreviousApproximation() const;
    double                              NewApproximation() const;

// INQUIRY

protected:
private:

    double  mPreviousApproximation;
    double  mNewApproximation;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _UnivariateConstrainedIteration_h
