#include <precomp.h>

#include "Logger.h"
#include "UnivariateFunction.h"  // class implemented

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

UnivariateFunction::UnivariateFunction(bool differentiable)
    : FunctionBase(differentiable)
{
}// UnivariateFunction

UnivariateFunction::~UnivariateFunction()
{
}// ~UnivariateFunction


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

double
UnivariateFunction::Evaluate(const ColumnVector& point) const
        throw(EvaluationError)
{
    return FunctionBase::Evaluate(point);
}

double
UnivariateFunction::Evaluate(double point) const throw(EvaluationError)
{
    ColumnVector x(1);

    x(1) = point;

    return FunctionBase::Evaluate(x);
}

double
UnivariateFunction::EvaluateNoThrow(const ColumnVector& point) const
        throw()
{
    return FunctionBase::EvaluateNoThrow(point);
}

double
UnivariateFunction::EvaluateNoThrow(double point) const throw()
{
    ColumnVector x(1);

    x(1) = point;

    return FunctionBase::EvaluateNoThrow(x);
}

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////
UnivariateFunction::UnivariateFunction(const UnivariateFunction& from)
    : FunctionBase(from)
{
}// UnivariateFunction

/////////////////////////////// PRIVATE    ///////////////////////////////////
