/** Funkcja jednej zmiennej.
 */

#ifndef _UnivariateFunction_h
#define _UnivariateFunction_h


// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "FunctionBase.h"

// FORWARD REFERENCES
//


class UnivariateFunction
    : public virtual FunctionBase
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    UnivariateFunction(bool differentiable);

    /** Destruktor.
     */
    virtual ~UnivariateFunction(void);


// OPERATORS

// OPERATIONS

    /** Oblicza warto funkcji w punkcie.
     *
     * @param point Jednowymiarowy punkt, w ktrym obliczana jest funkcja.
     */
    // Te metody s tu zdefiniowane ze wzgldu na "regu ukrywania".
    double              Evaluate(const ColumnVector& point) const
        throw(EvaluationError);

    double              EvaluateNoThrow(const ColumnVector& point) const
        throw();

    /** Oblicza warto funkcji w punkcie.
     *
     * Tworzy wektor kolumnowy o jednej skadowej rwnej <code>point</code> i
     * wywouje <code>Evaluate(ColumnVector)</code>.
     *
     * Ta metoda jest pomocnicza, jej stosowanie powinno by ograniczone do
     * specyficznych przypadkw.
     *
     * @param point Punkt, dla ktrego obliczana jest warto.
     */
    double              Evaluate(double point) const throw(EvaluationError);

    double              EvaluateNoThrow(double point) const throw();

// ACCESS
// INQUIRY

protected:
    UnivariateFunction(const UnivariateFunction& from);

private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _UnivariateFunction_h
