#include <precomp.h>

#include "UnivariateNonlinearFunction.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

UnivariateNonlinearFunction::UnivariateNonlinearFunction(
        std::auto_ptr<const FunctionTree>   apFunction,
        const wxString&                     textForm,
        bool                                differentiable)
    : FunctionBase(differentiable),
      UnivariateFunction(differentiable),
      NonlinearFunction(apFunction, textForm, differentiable)
{
    // Tu nie moe by asercji == 1, bo GUI wychwytuje brak zmiennych dopiero po
    // utworzeniu funkcji.
    assert(NonlinearFunction::mapFunctionTree->PresentVariables().GetCount() <= 1);
    assert(mDifferentiable == differentiable);
}// UnivariateNonlinearFunction

UnivariateNonlinearFunction::~UnivariateNonlinearFunction()
{
}// ~UnivariateNonlinearFunction


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

/* virutal */ std::auto_ptr<FunctionBase>
UnivariateNonlinearFunction::Clone() const
{
    return auto_ptr<FunctionBase>(new UnivariateNonlinearFunction(*this));
}// Clone

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

UnivariateNonlinearFunction::UnivariateNonlinearFunction(
        const UnivariateNonlinearFunction& from)
    : FunctionBase(from),
      UnivariateFunction(from),
      NonlinearFunction(from)
{
}

double
UnivariateNonlinearFunction::DoEvaluateNoThrow(const ColumnVector& point) const
    throw()
{
    return NonlinearFunction::DoEvaluateNoThrow(point);
}// Evaluate


/////////////////////////////// PRIVATE    ///////////////////////////////////
