/** Funkcja jednej zmiennej.
 */

#ifndef _UnivariateNonlinearFunction_h
#define _UnivariateNonlinearFunction_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "NonlinearFunction.h"
#include "UnivariateFunction.h"

// FORWARD REFERENCES
//


class UnivariateNonlinearFunction
    : public UnivariateFunction, public NonlinearFunction
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    UnivariateNonlinearFunction(
            std::auto_ptr<const FunctionTree>   apFunction,
            const wxString&                     textForm = wxT(""),
            bool                                differentiable = true);

    /** Destruktor.
     */
    ~UnivariateNonlinearFunction(void);


// OPERATORS

// OPERATIONS

    virtual std::auto_ptr<FunctionBase> Clone() const;

    virtual double          DoEvaluateNoThrow(const ColumnVector& point) const
        throw();

// ACCESS
// INQUIRY

protected:
    UnivariateNonlinearFunction(const UnivariateNonlinearFunction& from);
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _UnivariateNonlinearFunction_h
