#include <precomp.h>

#include "VariableNames.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

VariableNames::VariableNames()
    : wxSortedArrayString()
{
}// VariableNames

VariableNames::VariableNames(const VariableNames& from)
    : wxSortedArrayString(from)
{
}// VariableNames

VariableNames::~VariableNames()
{
}// ~VariableNames


//============================= OPERATORS ====================================

VariableNames&
VariableNames::operator=(const VariableNames& from)
{
    wxSortedArrayString::operator=(from);

    return *this;
}// =

//============================= OPERATIONS ===================================

size_t
VariableNames::AddIfNotPresent(const wxString& name)
{
    int index = Index(name);

    if (index == wxNOT_FOUND)   index = Add(name);

    return index;
}// AddIfNotPresent

void
VariableNames::AddIfNotPresent(const VariableNames& newVariables)
{
    for (size_t i = 0; i < newVariables.GetCount(); ++i)
    {
        AddIfNotPresent(newVariables[i]);
    }
}// AddIfNotPresent

//============================= ACCESS     ===================================

wxString
VariableNames::ToString() const
{
    wxString string;

    unsigned count = GetCount();
    for (unsigned i = 0; i < count; ++i)
    {
        string << (*this)[i];
        if (i != count - 1)     string << wxT(", ");
        else                    string << wxT('.');
    }

    return string;
}// ToString

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
