/** Struktura przechowujca nazwy zmiennych.
 *
 * Jest to posortowana tablica nazw. UWAGA: indeksy mog si zmieni przy
 * dodaniu zmiennej.
 *
 * @see FunctionTree
 */

#ifndef _VariableNames_h
#define _VariableNames_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//

// FORWARD REFERENCES
//


class VariableNames
    : public wxSortedArrayString
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    VariableNames(void);


    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    VariableNames(const VariableNames& from);


    /** Destruktor.
     */
    ~VariableNames(void);


// OPERATORS

    /** Operator przypisania.
     *
     * @param from Przypisywana warto.
     *
     * @return Referencja do biecego obiektu.
     */
    VariableNames&        operator=(const VariableNames& from);

// OPERATIONS

    /** Dodaje zmienn, jeli jeszcze nie istnieje.
     *
     * Zwraca indeks tej zmiennej (dodanej, bd istniejcej wczeniej).
     */
    size_t      AddIfNotPresent(const wxString& name);

    /** Dodaje zmienne z <code>newVariables</code>, jeli jeszcze nie istniej.
     */
    void        AddIfNotPresent(const VariableNames& newVariables);
// ACCESS

    /** Zwraca napis z list zmiennych.
     *
     * Kolejno jest taka, jak w obiekcie zmiennych i, co nie jest w aden
     * sposb wymuszane, jaka powinna by w wektorach punktw.
     */
    wxString    ToString() const;

// INQUIRY

protected:
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _VariableNames_h
