#include <precomp.h>

#include "../ProblemBase.h"

#include "BolzanoDivisionIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

BolzanoDivisionIteration::BolzanoDivisionIteration
                                   (double              a,
                                    double              middle,
                                    double              b)
    : mA(a), mMiddle(middle), mB(b)
{
}// BolzanoDivisionIteration

BolzanoDivisionIteration::~BolzanoDivisionIteration()
{
}// ~BolzanoDivisionIteration


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ ColumnVector
BolzanoDivisionIteration::EndValuePoint() const
{
    ColumnVector end_value_point(1);

    end_value_point(1) = (mA + mB) / 2;

    return end_value_point;
}// EndValuePoint

/* virtual */ vector<IterationData::IterationDataIdType>
BolzanoDivisionIteration::ClassIds() const
{
    // Identyfikatory rodzica
    vector<IterationDataIdType> base_ids(IterationData::ClassIds());

    base_ids.insert(base_ids.begin(), BolzanoDivisionIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
BolzanoDivisionIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId


double
BolzanoDivisionIteration::LeftBound() const
{
    return mA;
}// LeftBound

double
BolzanoDivisionIteration::Middle() const
{
    return mMiddle;
}// Middle

double
BolzanoDivisionIteration::RightBound() const
{
    return mB;
}// RightBound

BolzanoDivisionIteration::HalfChosenType
BolzanoDivisionIteration::HalfChosen() const
{
    return mHalfChosen;
}// HalfChosen

BolzanoDivisionIteration::HalfChosenType&
BolzanoDivisionIteration::rHalfChosen()
{
    return mHalfChosen;
}// rHalfChosen

double
BolzanoDivisionIteration::Length() const
{
    return mB - mA;
}// Length

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
