/** Dane pojedynczej iteracji metody podziau Bolzano.
 *
 * @see DichotomousDivision, Result
 */

#ifndef _BolzanoDivisionIteration_h
#define _BolzanoDivisionIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../IterationData.h"

// FORWARD REFERENCES
//


class BolzanoDivisionIteration
    : public IterationData
{
public:

    typedef enum
    {
        LEFT = 1,
        RIGHT = 2,
        NONE = 3
    } HalfChosenType;

// LIFECYCLE

    /** Konstruktor.
     */
    BolzanoDivisionIteration(double             a,
                             double             middle,
                             double             b);

    /** Destruktor.
     */
    ~BolzanoDivisionIteration(void);

// OPERATORS
// OPERATIONS
// ACCESS

    virtual ColumnVector                EndValuePoint() const;

    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();

    /** Zwraca lewy kraniec przedziau pocztkowego.
     */
    double              LeftBound() const;

    /** Zwraca rodkowy punkt prbny (rodek przedziau)
     */
    double              Middle() const;

    /** Zwraca prawy kraniec przedziau pocztkowego.
     */
    double              RightBound() const;

    HalfChosenType      HalfChosen() const;
    HalfChosenType&     rHalfChosen();

    double              Length() const;

// INQUIRY

protected:
private:

    double  mA;         ///< Lewy kraniec przedziau pocztkowego.
    double  mMiddle;    ///< Punkt prbny porodku przedziau.
    double  mB;         ///< Prawy kraniec przedziau pocztkowego.

    HalfChosenType  mHalfChosen;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _BolzanoDivisionIteration_h
