#include <precomp.h>

#include "ConjugateGradientsMethodIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

ConjugateGradientsMethodIteration::ConjugateGradientsMethodIteration
                                (const ColumnVector&    startingPoint,
                                 const ColumnVector&    gradient,
                                       double           gamma,
                                       bool             directionReset,
                                 const ColumnVector&    direction,
                                       double           tau,
                                 const ColumnVector&    endPoint)
    : GradientMethodIteration(startingPoint,
                              gradient,
                              direction,
                              tau,
                              endPoint),
      mGamma(gamma),
      mDirectionReset(directionReset)
{
}// ConjugateGradientsMethodIteration

ConjugateGradientsMethodIteration::~ConjugateGradientsMethodIteration()
{
}// ~ConjugateGradientsMethodIteration

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ vector<IterationData::IterationDataIdType>
ConjugateGradientsMethodIteration::ClassIds() const
{
    // Bierzemy identyfikatory od bezporedniego rodzica
    vector<IterationDataIdType> base_ids(GradientMethodIteration::ClassIds());

    base_ids.insert(base_ids.begin(), ConjugateGradientsMethodIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
ConjugateGradientsMethodIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId



double
ConjugateGradientsMethodIteration::Gamma() const
{
    return mGamma;
}

bool
ConjugateGradientsMethodIteration::DirectionReset() const
{
    return mDirectionReset;
}

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////
/////////////////////////////// PRIVATE    ///////////////////////////////////
