/** Klasa danych iteracji metody Fletchera-Reevesa
 *
 * @see Result
 */

#ifndef _ConjugateGradientsMethodIteration_h
#define _ConjugateGradientsMethodIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../GradientMethodIteration.h"

// FORWARD REFERENCES
//


class ConjugateGradientsMethodIteration
    : public GradientMethodIteration
{
public:

// LIFECYCLE

    /** Konstruktor.
     *
     * @param staringPoint Punkt pocztkowy danej iteracji.
     * @param gradient Gradient funkcji w punkcie startingPoint.
     * @param gradient macierz hessianu funkcji w punkcie startingPoint.
     * @param endPoint kocowy punkt danej iteracji.
     */
    ConjugateGradientsMethodIteration
                           (const ColumnVector&     startingPoint,
                            const ColumnVector&     gradient,
                                  double            gamma,
                                  bool              directionReset,
                            const ColumnVector&     direction,
                                  double            tau,
                            const ColumnVector&     endPoint);

    /** Destruktor.
     */
    ~ConjugateGradientsMethodIteration(void);

// OPERATORS

// OPERATIONS

// ACCESS

    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();



    double                              Gamma() const;

    bool                                DirectionReset() const;

// INQUIRY

protected:
private:

   double   mGamma; ///< Wspczynnik gamma

   bool     mDirectionReset;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _ConjugateGradientsMethodIteration_h
