#include <precomp.h>

#include "DerivativeIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

DerivativeIteration::DerivativeIteration(double startingPoint,
                                         double firstAlpha,
                                         double gamma)
    : mStartingPoint(startingPoint),
      mFirstAlpha(firstAlpha),
      mGamma(gamma)
{
}// DerivativeIteration

DerivativeIteration::~DerivativeIteration()
{
}// ~DerivativeIteration


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ ColumnVector
DerivativeIteration::EndValuePoint() const
{
    ColumnVector end_value_point(1);

    end_value_point(1) = mTrialPoints.back();
    return end_value_point;
}// EndValuePoint

/* virtual */ vector<IterationData::IterationDataIdType>
DerivativeIteration::ClassIds() const
{
    // Identyfikatory rodzica
    vector<IterationDataIdType> base_ids(IterationData::ClassIds());

    base_ids.insert(base_ids.begin(), DerivativeIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
DerivativeIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId


double
DerivativeIteration::StartingPoint() const
{
    return mStartingPoint;
}// LeftBound

const std::vector<double>&
DerivativeIteration::TrialPoints() const
{
    return mTrialPoints;
}

std::vector<double>&
DerivativeIteration::rTrialPoints()
{
    return mTrialPoints;
}

double
DerivativeIteration::FirstAlpha() const
{
    return mFirstAlpha;
}

double
DerivativeIteration::Gamma() const
{
    return mGamma;
}

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
