#include <precomp.h>

#include "DichotomousDivisionIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

DichotomousDivisionIteration::DichotomousDivisionIteration
                                   (double              a,
                                    double              xL,
                                    double              xM,
                                    double              xR,
                                    double              b)
    : mA(a), mXl(xL), mXm(xM), mXr(xR), mB(b)
{
}// DichotomousDivisionIteration

DichotomousDivisionIteration::~DichotomousDivisionIteration()
{
}// ~DichotomousDivisionIteration


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ ColumnVector
DichotomousDivisionIteration::EndValuePoint() const
{
    ColumnVector end_value_point(1);

    end_value_point(1) = (mA + mB) / 2;
    return end_value_point;
}// EndValuePoint

/* virtual */ vector<IterationData::IterationDataIdType>
DichotomousDivisionIteration::ClassIds() const
{
    // Identyfikatory rodzica
    vector<IterationDataIdType> base_ids(IterationData::ClassIds());

    base_ids.insert(base_ids.begin(), DichotomousDivisionIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
DichotomousDivisionIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId

double
DichotomousDivisionIteration::LeftBound() const
{
    return mA;
}// LeftBound

double
DichotomousDivisionIteration::RightBound() const
{
    return mB;
}// RightBound

double
DichotomousDivisionIteration::LeftStep() const
{
    return mXl;
}// LeftStep

double
DichotomousDivisionIteration::MiddleStep() const
{
    return mXm;
}// MiddleStep

double
DichotomousDivisionIteration::RightStep() const
{
    return mXr;
}// RightStep

DichotomousDivisionIteration::NextMiddleType
DichotomousDivisionIteration::NextMiddle() const
{
    return mNextMiddle;
}//NextMiddle

DichotomousDivisionIteration::NextMiddleType&
DichotomousDivisionIteration::rNextMiddle()
{
    return mNextMiddle;
}//rNextMiddle

DichotomousDivisionIteration::BetterPointType
DichotomousDivisionIteration::BetterPoint() const
{
    return mBetterPoint;
}//BetterPoint

DichotomousDivisionIteration::BetterPointType&
DichotomousDivisionIteration::rBetterPoint()
{
    return mBetterPoint;
}//rBetterPoint


double
DichotomousDivisionIteration::Length() const
{
    return mB - mA;
}// Length

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
