/** Dane pojedynczej iteracji metody Hooke'a Jeevesa z krokiem optymalnym.
 *
 * @see HookeJeevesOptimal, Result
 */

#ifndef _HookeJeevesOptimalIteration_h
#define _HookeJeevesOptimalIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "HookeJeevesIteration.h"

// FORWARD REFERENCES
//


class HookeJeevesOptimalIteration
    : public HookeJeevesIteration
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    HookeJeevesOptimalIteration(void);

    /** Konstruktor.
     *
     * @param staringPoint Punkt wyjcia dla tej iteracji.
     */
    HookeJeevesOptimalIteration(const ColumnVector& staringPoint);

    /** Destruktor.
     */
    ~HookeJeevesOptimalIteration(void);

// OPERATORS

// OPERATIONS

    void		AddTrialPoint(const ColumnVector& point);
    
// ACCESS

    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();

// INQUIRY

protected:
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _HookeJeevesOptimalIteration_h
