#include <precomp.h>

#include "NewtonModifiedIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

NewtonModifiedIteration::NewtonModifiedIteration
                                (const ColumnVector&    startingPoint,
                                 const ColumnVector&    gradient,
                                 const SymmetricMatrix& hessian,
                                 const ColumnVector&    direction,
                                       double           tau,
                                 const ColumnVector&    endPoint)
    : GradientMethodIteration(startingPoint,
                              gradient,
                              direction,
                              tau,
                              endPoint),
      mHessian(hessian)
{
}// NewtonModifiedIteration

NewtonModifiedIteration::~NewtonModifiedIteration()
{
}// ~NewtonModifiedIteration

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ vector<IterationData::IterationDataIdType>
NewtonModifiedIteration::ClassIds() const
{
    // Bierzemy identyfikatory od bezporedniego rodzica
    vector<IterationDataIdType> base_ids(GradientMethodIteration::ClassIds());

    base_ids.insert(base_ids.begin(), NewtonModifiedIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
NewtonModifiedIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId



const SymmetricMatrix&
NewtonModifiedIteration::Hessian() const
{
    return mHessian;
}// Hessian

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////
/////////////////////////////// PRIVATE    ///////////////////////////////////
