/** Klasa danych iteracji metody Newtona.
 *
 * @see Result
 */

#ifndef _NewtonModifiedIteration_h
#define _NewtonModifiedIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../GradientMethodIteration.h"
#include "../util.h"

// FORWARD REFERENCES
//


class NewtonModifiedIteration
    : public GradientMethodIteration
{
public:

// LIFECYCLE

    /** Konstruktor.
     *
     * @param staringPoint Punkt pocztkowy danej iteracji.
     * @param gradient Gradient funkcji w punkcie startingPoint.
     * @param gradient macierz hessianu funkcji w punkcie startingPoint.
     * @param endPoint kocowy punkt danej iteracji.
     */
    NewtonModifiedIteration(const ColumnVector&     startingPoint,
                            const ColumnVector&     gradient,
                            const SymmetricMatrix&  hessian,
                            const ColumnVector&     direction,
                                  double            tau,
                            const ColumnVector&     endPoint);

    /** Destruktor.
     */
    ~NewtonModifiedIteration(void);

// OPERATORS

// OPERATIONS

// ACCESS

    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();



    const SymmetricMatrix&              Hessian() const;

// INQUIRY

protected:
private:

    SymmetricMatrix mHessian;       ///< Hesjan funkcji w punkcie pocztkowym.

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _NewtonModifiedIteration_h
