#include <precomp.h>

#include "NewtonRaphsonIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

NewtonRaphsonIteration::NewtonRaphsonIteration(double startingPoint,
                                             double firstDerivative,
                                             double secondDerivative,
                                             double endPoint)
    : mStartingPoint(startingPoint),
      mFirstDerivative(firstDerivative),
      mSecondDerivative(secondDerivative),
      mEndPoint(endPoint)
{
}// NewtonRaphsonIteration

NewtonRaphsonIteration::~NewtonRaphsonIteration()
{
}// ~NewtonRaphsonIteration


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ ColumnVector
NewtonRaphsonIteration::EndValuePoint() const
{
    ColumnVector end_value_point(1);

    end_value_point(1) = mEndPoint;

    return end_value_point;
}// EndValuePoint

/* virtual */ vector<IterationData::IterationDataIdType>
NewtonRaphsonIteration::ClassIds() const
{
    // Identyfikatory rodzica
    vector<IterationDataIdType> base_ids(IterationData::ClassIds());

    base_ids.insert(base_ids.begin(), NewtonRaphsonIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
NewtonRaphsonIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId


double
NewtonRaphsonIteration::StartingPoint() const
{
    return mStartingPoint;
}// StartingPoint

double
NewtonRaphsonIteration::EndPoint() const
{
    return mEndPoint;
}// EndPoint

double
NewtonRaphsonIteration::FirstDerivative() const
{
    return mFirstDerivative;
}// FirstDerivative

double
NewtonRaphsonIteration::SecondDerivative() const
{
    return mSecondDerivative;
}// SecondDerivative

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
