/** Dane pojedynczej iteracji metody Newtona-Raphsona.
 *
 * @see NewtonRaphson, Result
 */

#ifndef _NewtonRaphsonIteration_h
#define _NewtonRaphsonIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../IterationData.h"

// FORWARD REFERENCES
//


class NewtonRaphsonIteration
    : public IterationData
{
public:

// LIFECYCLE

    /** Konstruktor.
     */
    NewtonRaphsonIteration(double startingPoint,
                          double firstDerivative,
                          double secondDerivative,
                          double endPoint);

    /** Destruktor.
     */
    ~NewtonRaphsonIteration(void);

// OPERATORS
// OPERATIONS
// ACCESS

    virtual ColumnVector                EndValuePoint() const;

    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();

    double                              StartingPoint() const;
    double                              EndPoint() const;
    double                              FirstDerivative() const;
    double                              SecondDerivative() const;

// INQUIRY

protected:
private:

    double  mStartingPoint;     ///< Punkt startowy iteracji
    double  mFirstDerivative;   ///< Pierwsza pochodna w punkcie
    double  mSecondDerivative;  ///< Druga pochodna w punkcie
    double  mEndPoint;          ///< Punkt kocowy iteracji

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _NewtonRaphsonIteration_h
