#include <precomp.h>

#include "PowellVariant2Iteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

PowellVariant2Iteration::PowellVariant2Iteration()
    : PowellIteration(),
      mP(0),
      mTauMax(0.0),
      mDelta(0.0),
      mNewDelta(0.0)
{
}// PowellVariant2Iteration

PowellVariant2Iteration::PowellVariant2Iteration(
        const ColumnVector& startingPoint,
        const SquareMatrix& D)
    : PowellIteration(startingPoint, D),
      mP(0),
      mTauMax(0.0),
      mDelta(0.0),
      mNewDelta(0.0)
{
}// PowellVariant2Iteration

PowellVariant2Iteration::~PowellVariant2Iteration()
{
}// ~PowellVariant2Iteration

//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ vector<IterationData::IterationDataIdType>
PowellVariant2Iteration::ClassIds() const
{
    // Bierzemy identyfikatory od bezporedniego rodzica
    vector<IterationDataIdType> base_ids(PowellIteration::ClassIds());

    base_ids.insert(base_ids.begin(), PowellVariant2Iteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
PowellVariant2Iteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId

unsigned
PowellVariant2Iteration::P() const
{
    return mP;
}// P

unsigned&
PowellVariant2Iteration::rP()
{
    return mP;
}// rP

double
PowellVariant2Iteration::TauMax() const
{
    return mTauMax;
}// TauMax

double&
PowellVariant2Iteration::rTauMax()
{
    return mTauMax;
}// rTauMax

double
PowellVariant2Iteration::Delta() const
{
    return mDelta;
}// Delta

double&
PowellVariant2Iteration::rDelta()
{
    return mDelta;
}// rDelta

double
PowellVariant2Iteration::NewDelta() const
{
    return mNewDelta;
}// NewDelta

double&
PowellVariant2Iteration::rNewDelta()
{
    return mNewDelta;
}// rNewDelta

//============================= INQUIRY    ===================================
bool
PowellVariant2Iteration::BaseChanged() const
{
    return mNewD.ncols() != 0;
}// BaseChanged
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
