/** Dane pojedynczej iteracji drugiego wariantu metody Powella.
 *
 * @see PowellIteration, PowellVariant2, Result
 */

#ifndef _PowellVariant2Iteration_h
#define _PowellVariant2Iteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "PowellIteration.h"

// FORWARD REFERENCES
//


class PowellVariant2Iteration
    : public PowellIteration
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    PowellVariant2Iteration(void);

    /** Konstruktor.
     *
     * @param staringPoint Punkt wyjcia dla tej iteracji.
     * @param D Baza kierunkw, wzdu ktrych wykonywane bd
     * kroki prbne w tej iteracji.
     */
    PowellVariant2Iteration(const ColumnVector& staringPoint,
                            const SquareMatrix& D);

    /** Destruktor.
     */
    ~PowellVariant2Iteration(void);

// OPERATORS

// OPERATIONS

// ACCESS

    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();

    unsigned            P() const;
    unsigned&           rP();

    double              TauMax() const;
    double&             rTauMax();

    double              Delta() const;
    double&             rDelta();

    double              NewDelta() const;
    double&             rNewDelta();

// INQUIRY
    bool                BaseChanged() const;

protected:
private:

    unsigned        mP;         ///< Indeks kierunku, w ktrym wykonano
                                /// najduszy krok prbny.

    double          mTauMax;    ///< Dugo najduszego kroku prbnego.

    double          mDelta;     ///< Wyznacznik aktualnej bazy kierunkw.

    double          mNewDelta;  ///< Wyznacznik bazy kierunkw po wstawieniu
                                /// do niej nowego kierunku sprzonego.
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _PowellVariant2Iteration_h
