#include <precomp.h>

#include "RosenbrockOptimalIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

RosenbrockOptimalIteration::RosenbrockOptimalIteration()
    : RosenbrockIteration(),
      mTrialPoints()
{
}// RosenbrockOptimalIteration

RosenbrockOptimalIteration::RosenbrockOptimalIteration(
        const ColumnVector& startingPoint,
        const SquareMatrix& D)
    : RosenbrockIteration(startingPoint, D),
      mTrialPoints()
{
}// RosenbrockOptimalIteration

RosenbrockOptimalIteration::~RosenbrockOptimalIteration()
{
}// ~RosenbrockOptimalIteration

//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
void
RosenbrockOptimalIteration::AddTrialPoint(const ColumnVector&   point,
                                          double                tau)
{
    mTrialPoints.push_back(TrialPoint(point, tau));
}// AddTrialPoint

//============================= ACCESS     ===================================

/* virtual */ vector<IterationData::IterationDataIdType>
RosenbrockOptimalIteration::ClassIds() const
{
    // Bierzemy identyfikatory od bezporedniego rodzica
    vector<IterationDataIdType> base_ids(RosenbrockIteration::ClassIds());

    base_ids.insert(base_ids.begin(), RosenbrockOptimalIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
RosenbrockOptimalIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId

const RosenbrockOptimalIteration::TrialPointContainer&
RosenbrockOptimalIteration::TrialPoints() const
{
    return mTrialPoints;
}// TrialPoints

//============================= INQUIRY    ===================================

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
