#include <precomp.h>

#include "../ProblemBase.h"

#include "SecantDivisionIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

SecantDivisionIteration::SecantDivisionIteration
                                   (double              a,
                                    double              inside,
                                    double              b)
    : mA(a), mInside(inside), mB(b)
{
}// SecantDivisionIteration

SecantDivisionIteration::~SecantDivisionIteration()
{
}// ~SecantDivisionIteration


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ ColumnVector
SecantDivisionIteration::EndValuePoint() const
{
    ColumnVector end_value_point(1);

    end_value_point(1) = (mA + mB) / 2;

    return end_value_point;
}// EndValuePoint

/* virtual */ vector<IterationData::IterationDataIdType>
SecantDivisionIteration::ClassIds() const
{
    // Identyfikatory rodzica
    vector<IterationDataIdType> base_ids(IterationData::ClassIds());

    base_ids.insert(base_ids.begin(), SecantDivisionIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
SecantDivisionIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId


double
SecantDivisionIteration::LeftBound() const
{
    return mA;
}// LeftBound

double
SecantDivisionIteration::InsidePoint() const
{
    return mInside;
}// InsidePoint

double
SecantDivisionIteration::RightBound() const
{
    return mB;
}// RightBound

SecantDivisionIteration::PartChosenType
SecantDivisionIteration::PartChosen() const
{
    return mPartChosen;
}// PartChosen

SecantDivisionIteration::PartChosenType&
SecantDivisionIteration::rPartChosen()
{
    return mPartChosen;
}// rPartChosen

double
SecantDivisionIteration::Length() const
{
    return mB - mA;
}// Length

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
