/** Dane pojedynczej iteracji podziau odcinka metod siecznych.
 *
 * @see DichotomousDivision, Result
 */

#ifndef _SecantDivisionIteration_h
#define _SecantDivisionIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../IterationData.h"

// FORWARD REFERENCES
//


class SecantDivisionIteration
    : public IterationData
{
public:

    typedef enum
    {
        LEFT = 1,
        RIGHT = 2,
        NONE = 3
    } PartChosenType;

// LIFECYCLE

    /** Konstruktor.
     */
    SecantDivisionIteration(double             a,
                            double             inside,
                            double             b);

    /** Destruktor.
     */
    ~SecantDivisionIteration(void);

// OPERATORS
// OPERATIONS
// ACCESS

    virtual ColumnVector                EndValuePoint() const;

    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();

    /** Zwraca lewy kraniec przedziau pocztkowego.
     */
    double              LeftBound() const;

    /** Zwraca rodkowy punkt prbny (rodek przedziau)
     */
    double              InsidePoint() const;

    /** Zwraca prawy kraniec przedziau pocztkowego.
     */
    double              RightBound() const;

    PartChosenType      PartChosen() const;
    PartChosenType&     rPartChosen();

    double              Length() const;

// INQUIRY

protected:
private:

    double  mA;         ///< Lewy kraniec przedziau pocztkowego.
    double  mInside;    ///< Punkt prbny wewntrz przedziau.
    double  mB;         ///< Prawy kraniec przedziau pocztkowego.

    PartChosenType  mPartChosen;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _SecantDivisionIteration_h
