#include <precomp.h>

#include "SignOfDerivativeIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

SignOfDerivativeIteration::SignOfDerivativeIteration(double startingPoint,
                                         double firstAlpha,
                                         double gamma)
    : mStartingPoint(startingPoint),
      mFirstAlpha(firstAlpha),
      mGamma(gamma)
{
}// SignOfDerivativeIteration

SignOfDerivativeIteration::~SignOfDerivativeIteration()
{
}// ~SignOfDerivativeIteration


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ ColumnVector
SignOfDerivativeIteration::EndValuePoint() const
{
    ColumnVector end_value_point(1);

    end_value_point(1) = mTrialPoints.back();
    return end_value_point;
}// EndValuePoint

/* virtual */ vector<IterationData::IterationDataIdType>
SignOfDerivativeIteration::ClassIds() const
{
    // Identyfikatory rodzica
    vector<IterationDataIdType> base_ids(IterationData::ClassIds());

    base_ids.insert(base_ids.begin(), SignOfDerivativeIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
SignOfDerivativeIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId


double
SignOfDerivativeIteration::StartingPoint() const
{
    return mStartingPoint;
}// LeftBound

const std::vector<double>&
SignOfDerivativeIteration::TrialPoints() const
{
    return mTrialPoints;
}

std::vector<double>&
SignOfDerivativeIteration::rTrialPoints()
{
    return mTrialPoints;
}

double
SignOfDerivativeIteration::FirstAlpha() const
{
    return mFirstAlpha;
}

double
SignOfDerivativeIteration::Gamma() const
{
    return mGamma;
}

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
