/** Dane pojedynczej iteracji metody podziau dychotomicznego.
 *
 * @see SignOfDerivative, Result
 */

#ifndef _SignOfDerivativeIteration_h
#define _SignOfDerivativeIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../IterationData.h"

// FORWARD REFERENCES
//


class SignOfDerivativeIteration
    : public IterationData
{
public:

// LIFECYCLE

    /** Konstruktor.
     */
    SignOfDerivativeIteration(double x, double firstAlpha, double gamma);

    /** Destruktor.
     */
    ~SignOfDerivativeIteration(void);

// OPERATORS
// OPERATIONS
// ACCESS

    virtual ColumnVector                EndValuePoint() const;

    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();

    double                      StartingPoint() const;

    const std::vector<double>&  TrialPoints() const;
    std::vector<double>&        rTrialPoints();

    double                      FirstAlpha() const;

    double                      Gamma() const;

// INQUIRY

protected:
private:

    double  mStartingPoint;     ///< Punkt startowy iteracji

    /** Punkty pribne w iteracji (ostatni jest zawsze zaakceptowanym)
     */
    std::vector<double> mTrialPoints;

    double  mFirstAlpha;
    double  mGamma;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _SignOfDerivativeIteration_h
