#include <precomp.h>

#include "SteepestDescentIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

SteepestDescentIteration::SteepestDescentIteration()
    : GradientMethodIteration()
{
}// SteepestDescentIteration

SteepestDescentIteration::SteepestDescentIteration(
        const ColumnVector& startingPoint,
        const ColumnVector& gradient)
    : GradientMethodIteration(startingPoint, gradient)
{
}// SteepestDescentIteration

SteepestDescentIteration::~SteepestDescentIteration()
{
}// ~SteepestDescentIteration

//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ vector<IterationData::IterationDataIdType>
SteepestDescentIteration::ClassIds() const
{
    // Bierzemy identyfikatory od bezporedniego rodzica
    vector<IterationDataIdType> base_ids(GradientMethodIteration::ClassIds());

    base_ids.insert(base_ids.begin(), SteepestDescentIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
SteepestDescentIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////
/////////////////////////////// PRIVATE    ///////////////////////////////////
