/** Klasa danych iteracji metody najwikszego spadku.
 *
 * @see SteepestDescent, GradientMethodIteration, Result
 */

#ifndef _SteepestDescentIteration_h
#define _SteepestDescentIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../GradientMethodIteration.h"
#include "../util.h"

// FORWARD REFERENCES
//


class SteepestDescentIteration
    : public GradientMethodIteration
{
public:

// LIFECYCLE

    /** Konstruktor domylny.
     */
    SteepestDescentIteration(void);

    /** Konstruktor.
     *
     * @param staringPoint Punkt wyjcia dla tej iteracji.
     * @param gradient Gradient funkcji w punkcie wyjcia.
     */
    SteepestDescentIteration(const ColumnVector& staringPoint,
                             const ColumnVector& gradient);

    /** Destruktor.
     */
    ~SteepestDescentIteration(void);

// OPERATORS
// OPERATIONS
// ACCESS
    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();

// INQUIRY
protected:
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _SteepestDescentIteration_h
