#include <precomp.h>

#include "UniformDivisionIteration.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

UniformDivisionIteration::UniformDivisionIteration(double   a,
                                                   double   b,
                                                   double   x)
    : mA(a), mB(b), mX(x)
{
}// UniformDivisionIteration

UniformDivisionIteration::~UniformDivisionIteration()
{
}// ~UniformDivisionIteration


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

/* virtual */ ColumnVector
UniformDivisionIteration::EndValuePoint() const
{
    ColumnVector end_value_point(1);

    end_value_point(1) = mX;
    return end_value_point;
}// EndValuePoint

/* virtual */ vector<IterationData::IterationDataIdType>
UniformDivisionIteration::ClassIds() const
{
    // Identyfikatory rodzica
    vector<IterationDataIdType> base_ids(IterationData::ClassIds());

    base_ids.insert(base_ids.begin(), UniformDivisionIteration::ClassId());

    return base_ids;
}// ClassIds

/* static */ IterationData::IterationDataIdType
UniformDivisionIteration::ClassId()
{
    static IterationDataIdType class_id = GenerateId();

    return class_id;
}// ClassId

double
UniformDivisionIteration::LeftBound() const
{
    return mA;
}// LeftBound

double
UniformDivisionIteration::RightBound() const
{
    return mB;
}// RightBound

double
UniformDivisionIteration::TrialPoint() const
{
    return mX;
}// TrialPoint

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////
/////////////////////////////// PRIVATE    ///////////////////////////////////
