/** Dane pojedynczej iteracji metody podziau rwnomiernego.
 *
 * @see UniformDivision, Result
 */

#ifndef _UniformDivisionIteration_h
#define _UniformDivisionIteration_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../IterationData.h"

// FORWARD REFERENCES
//


class UniformDivisionIteration
    : public IterationData
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    UniformDivisionIteration(double a,
                             double b,
                             double x);

    /** Destruktor.
     */
    ~UniformDivisionIteration(void);

// OPERATORS

// OPERATIONS


// ACCESS

    virtual ColumnVector  EndValuePoint() const;

    virtual vector<IterationDataIdType> ClassIds() const;

    static IterationDataIdType          ClassId();

    /** Zwraca lewy kraniec przedziau pocztkowego.
     */
    double      LeftBound() const;

    /** Zwraca prawy kraniec przedziau pocztkowego.
     */
    double      RightBound() const;

    /** Zwraca punkt prbny.
     */
    double      TrialPoint() const;

// INQUIRY

protected:
private:

    double  mA;     ///< Lewy kraniec przedziau pocztkowego.
    double  mB;     ///< Prawy kraniec przedziau pocztkowego.

    double  mX;     ///< Punkt prbny.
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _UniformDivisionIteration_h
