// -*- C++ -*- generated by wxGlade 0.4 on Tue Mar 28 18:16:39 2006
#include <precomp.h>

#include "../Symbols.h"

#include "AlphaDivisionPanel.h"
#include "DoubleParameterValidator.h"
#include "InitialSectionValidator.h"
#include "MethodPanelFactory.h"
#include "ui_util.h"

BEGIN_EVENT_TABLE(AlphaDivisionPanel, wxPanel)
    EVT_CHECKBOX(ID_CHECKBOX_GOLDENSECTION,
                 AlphaDivisionPanel::OnGoldenSectionChecked)
END_EVENT_TABLE()

AlphaDivisionPanel::AlphaDivisionPanel(wxWindow*            parent,
                                       int                  id,
                                       AlphaDivision*       pMethod,
                                       bool                 standalone,
                                       const                wxPoint& pos,
                                       const                wxSize& size,
                                       long                 style):
    wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL)
{
    // Kontrolka pocztkowego odcinka.
    if (standalone)
    {
        mLeftBound  = pMethod->mInitialA;
        mRightBound = pMethod->mInitialB;
        mpInitialSectionControl = new InitialSectionControl(this, -1,
                mLeftBound, mRightBound);
    }
    else
    {
        mpInitialSectionControl = NULL;
    }

    // begin wxGlade: AlphaDivisionPanel::AlphaDivisionPanel
    mpAlphaLabel = new wxStaticText(this, -1, _("[Label set explicitly in ui/AlphaDivisionPanel::set_properties().]"));
    mpAlphaTextCtrl = new wxTextCtrl(this, ID_TEXT_ALPHA, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpGoldenSectionCheckBox = new wxCheckBox(this, ID_CHECKBOX_GOLDENSECTION, _("Golden section"));
    mpEpsilonLabel = new wxStaticText(this, -1, _("[Label set explicitly in ui/AlphaDivisionPanel::set_properties().]"));
    mpEpsilonTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);

    set_properties();
    do_layout();
    // end wxGlade

    // Walidatory
    mpAlphaTextCtrl->SetValidator(DoubleParameterValidator(pMethod->mAlpha));
    mpEpsilonTextCtrl->SetValidator(
            DoubleParameterValidator(pMethod->mEpsilon));
    mpGoldenSectionCheckBox->SetValidator(wxGenericValidator(
            &(pMethod->mGoldenSection)));

    if (pMethod->mGoldenSection)
    {
        mpAlphaTextCtrl->SetEditable(false);
        mpAlphaTextCtrl->SetBackgroundColour(wxColour(*wxLIGHT_GREY));
    }

}


void AlphaDivisionPanel::set_properties()
{
    // begin wxGlade: AlphaDivisionPanel::set_properties
    // end wxGlade

    // Etykiety z greckimi literami.
    const Symbols& symbols = Symbols::GetInstance();
    const wxString& alpha_label_text    =   _("Division ratio") + 
        wxString(wxT(" (")) + symbols[Symbols::ALPHA] + wxString(wxT("):"));
    const wxString& epsilon_label_text  = _("Minimal section length");
        wxString(wxT(" (")) + symbols[Symbols::EPSILON] + wxString(wxT("):"));

    mpAlphaLabel->SetLabel(alpha_label_text);
    mpEpsilonLabel->SetLabel(epsilon_label_text);
}


void AlphaDivisionPanel::do_layout()
{
    // begin wxGlade: AlphaDivisionPanel::do_layout
    wxBoxSizer* sizer_22 = new wxBoxSizer(wxVERTICAL);
    wxGridSizer* grid_sizer_6 = new wxGridSizer(3, 2, 0, 0);
    grid_sizer_6->Add(mpAlphaLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_6->Add(mpAlphaTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_6->Add(20, 20, 0, wxADJUST_MINSIZE, 0);
    grid_sizer_6->Add(mpGoldenSectionCheckBox, 0, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_6->Add(mpEpsilonLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_6->Add(mpEpsilonTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    sizer_22->Add(grid_sizer_6, 0, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_22);
    sizer_22->Fit(this);
    sizer_22->SetSizeHints(this);
    // end wxGlade

    if (mpInitialSectionControl != NULL)
        sizer_22->Add(mpInitialSectionControl, 1, wxEXPAND, 0);
}

/* static */ wxPanel*
AlphaDivisionPanel::CreatePanel(MethodPanelInfo   panelInfo)
{
    AlphaDivision* p_method =
            dynamic_cast<AlphaDivision*>(panelInfo.pMethod());
    if (panelInfo.PanelType() == MethodPanelInfo::STANDALONE)
    {
        // Tworzy panel z panelu metody w kierunku oraz kontrolki
        // ustawiania odcinka pocztkowego.
        AlphaDivisionPanel* p_panel =  new AlphaDivisionPanel(
                panelInfo.pParent(), -1, p_method, true);
        p_panel->SetValidator(InitialSectionValidator(
                    dynamic_cast<SectionLineSearch*>(panelInfo.pMethod()),
                    p_panel->mLeftBound, p_panel->mRightBound));
        return p_panel;
    }
    else
    {
        return new AlphaDivisionPanel(panelInfo.pParent(), -1, p_method, false);
    }
}// CreatePanel

void AlphaDivisionPanel::OnGoldenSectionChecked(wxCommandEvent& event)
{
    static double golden_ratio = (sqrt(5) - 1) / 2;

    if (mpGoldenSectionCheckBox->GetValue() == true)
    {
        mpAlphaTextCtrl->SetValue(wxString::Format(wxT("%.6g"), golden_ratio));
        mpAlphaTextCtrl->SetEditable(false);
        mpAlphaTextCtrl->SetBackgroundColour(wxColour(*wxLIGHT_GREY));
    }
    else if (mpGoldenSectionCheckBox->GetValue() == false)
    {
        mpAlphaTextCtrl->SetEditable(true);
        mpAlphaTextCtrl->SetBackgroundColour(wxColour(*wxWHITE));
    }
}

// Zarejestruj metod tworzc panel
const void* AlphaDivisionPanel::mpRegistrationDummy =
        MethodPanelFactory::GetInstance().Register(
                AlphaDivision::ClassId(),
                AlphaDivisionPanel::CreatePanel);

