/** Pseudo-warstwa, ktrej celem jest jedynie wyznaczenie minimalnego rozmiaru.
 *
 * @see PlotControl
 */

#ifndef _BoundingBoxLayer_h
#define _BoundingBoxLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../Region.h"
#include "PlotLayer.h"

// FORWARD REFERENCES
//


class BoundingBoxLayer
    : public PlotLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    BoundingBoxLayer(const PlotControl& targetPlot, const Region& bounding_box);


    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    BoundingBoxLayer(const BoundingBoxLayer& from);


    /** Destruktor.
     */
    ~BoundingBoxLayer(void);


// OPERATORS

// OPERATIONS

    virtual void        Draw(wxDC& dc) const;

// ACCESS

    virtual Region      BoundingBox() const;

// INQUIRY

protected:
private:
    const Region    mBoundingBox;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _BoundingBoxLayer_h
