// -*- C++ -*- generated by wxGlade 0.4.1 on Mon Mar 13 14:49:52 2006

#include <precomp.h>

#include "../Configuration.h"

#include "ConfigurationDialog.h"
#include "DoubleParameterValidator.h"
#include "IntegerValidator.h"

BEGIN_EVENT_TABLE(ConfigurationDialog, wxDialog)
    EVT_BUTTON(ID_BUTTON_DEFAULT, ConfigurationDialog::OnDefault)
END_EVENT_TABLE()

ConfigurationDialog::ConfigurationDialog(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxDialog(parent, id, title, pos, size, wxDEFAULT_DIALOG_STYLE)
{
    mpStepLimitLabel = new wxStaticText(this, -1, _("Step limit:"));
    mpStepLimitCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpInitialSectionLengthLabel = new wxStaticText(this, -1, _("Initial section length:"));
    mpInitialSectionLengthCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpDifferentiationDeltaLabel = new wxStaticText(this, -1, _("Differentiation delta:"));
    mpDifferentiationDeltaCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpDefaultButton = new wxButton(this, ID_BUTTON_DEFAULT, _("Default"));
    mpOkButton = new wxButton(this, wxID_OK, _("OK"));
    mpCancelButton = new wxButton(this, wxID_CANCEL, _("Cancel"));

    set_properties();
    do_layout();

    // Nie jest to najlepsze miejsce na limit, ale czy ma sens tworzy
    // IntegerParameter ?
    mpStepLimitCtrl->SetValidator(IntegerValidator(
                Configuration::GetInstance().mStepLimit, 100));
    mpInitialSectionLengthCtrl->SetValidator(DoubleParameterValidator(
                Configuration::GetInstance().mInitialSectionLength));
    mpDifferentiationDeltaCtrl->SetValidator(DoubleParameterValidator(
                Configuration::GetInstance().mDifferentiationDelta));
}

void ConfigurationDialog::set_properties()
{
    SetTitle(_("Configuration"));
}


void ConfigurationDialog::do_layout()
{
    wxBoxSizer* sizer_17 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_18 = new wxBoxSizer(wxHORIZONTAL);
    wxGridSizer* grid_sizer_4 = new wxGridSizer(3, 2, 0, 0);
    grid_sizer_4->Add(mpStepLimitLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_4->Add(mpStepLimitCtrl, 0, wxALL|wxEXPAND|wxADJUST_MINSIZE, 2);
    grid_sizer_4->Add(mpInitialSectionLengthLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_4->Add(mpInitialSectionLengthCtrl, 0, wxALL|wxEXPAND|wxADJUST_MINSIZE, 2);
    grid_sizer_4->Add(mpDifferentiationDeltaLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_4->Add(mpDifferentiationDeltaCtrl, 0, wxALL|wxEXPAND|wxADJUST_MINSIZE, 2);
    sizer_17->Add(grid_sizer_4, 0, wxEXPAND, 0);
    sizer_18->Add(mpDefaultButton, 0, wxALL, 2);
    sizer_18->Add(20, 0, 1);
    sizer_18->Add(mpOkButton, 0, wxALL, 2);
    sizer_18->Add(mpCancelButton, 0, wxALL, 2);
    sizer_17->Add(sizer_18, 0, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_17);
    sizer_17->Fit(this);
    sizer_17->SetSizeHints(this);
    Layout();
}

void
ConfigurationDialog::OnDefault(wxCommandEvent& event)
{
    Configuration::GetInstance().SetDefaults();
    TransferDataToWindow();
}// OnDefault
