// -*- C++ -*- generated by wxGlade 0.4 on Sun Dec 11 11:28:21 2005

#include <precomp.h>

#include "../Logger.h"

#include "ConstraintDialog.h"
#include "FunctionValidator.h"

LOGGER(DEBUG)

BEGIN_EVENT_TABLE(ConstraintDialog, wxDialog)
    EVT_BUTTON(wxID_OK, ConstraintDialog::OnOk)
END_EVENT_TABLE()

ConstraintDialog::ConstraintDialog(wxWindow*                    parent,
                                   int                          id,
                                   Constraint&                  rConstraint,
                                   const VariableNames&         variables,
                                   const ProblemBase*           pProblem,
                                   CountedPtr<const Parser>     cpParser,
                                   History&                     rHistory,
                                   const wxString&              title,
                                   const wxPoint&               pos,
                                   const wxSize&                size,
                                   long                         style)
    : wxDialog(parent, id, title, pos, size, wxDEFAULT_DIALOG_STYLE|wxRESIZE_BORDER|wxTHICK_FRAME),
      mrConstraint(rConstraint),
      mcpVariables(new VariableNames(variables))
{
    // begin wxGlade: ConstraintDialog::ConstraintDialog
    const wxString mpFunctionCombo_choices[] = {
        
    };
    mpFunctionCombo = new wxComboBox(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, 0, mpFunctionCombo_choices, wxCB_DROPDOWN);
    const wxString mpTypeChoice_choices[] = {
        _("<= 0"),
        _("= 0")
    };
    mpTypeChoice = new wxChoice(this, -1, wxDefaultPosition, wxDefaultSize, 2, mpTypeChoice_choices, 0);
    mpOkButton = new wxButton(this, wxID_OK, wxT(""));
    mpCancelButton = new wxButton(this, wxID_CANCEL, wxT(""));

    set_properties();
    do_layout();
    // end wxGlade

    mpFunctionCombo->SetValidator(FunctionValidator(cpParser,
                mrConstraint.mcpFunction, mcpVariables, pProblem, false,
                rHistory, FunctionValidator::CONSTRAINT));

    const static int type_index[] = {  1, 0, 2 };
    mpTypeChoice->SetSelection(type_index[rConstraint.mType]);
}


void ConstraintDialog::set_properties()
{
    // begin wxGlade: ConstraintDialog::set_properties
    SetTitle(_("Enter Constraint"));
    mpFunctionCombo->SetSelection(-1);
    mpTypeChoice->SetSelection(0);
    mpOkButton->SetDefault();
    // end wxGlade
}


void ConstraintDialog::do_layout()
{
    // begin wxGlade: ConstraintDialog::do_layout
    wxBoxSizer* sizer_7 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_9 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_8 = new wxBoxSizer(wxHORIZONTAL);
    sizer_8->Add(mpFunctionCombo, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    sizer_8->Add(mpTypeChoice, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    sizer_7->Add(sizer_8, 1, wxEXPAND, 0);
    sizer_9->Add(100, 1, 1, wxEXPAND|wxADJUST_MINSIZE, 0);
    sizer_9->Add(mpOkButton, 0, wxALIGN_RIGHT|wxADJUST_MINSIZE, 0);
    sizer_9->Add(mpCancelButton, 0, wxALIGN_RIGHT|wxADJUST_MINSIZE, 0);
    sizer_7->Add(sizer_9, 0, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_7);
    sizer_7->Fit(this);
    sizer_7->SetSizeHints(this);
    Layout();
    // end wxGlade
}

void
ConstraintDialog::OnOk(wxCommandEvent& event)
{
    if (Validate())
    {
        const static Constraint::ConstraintType constraints[] =
                {
                    Constraint::LESS_EQUAL_THAN,
                    Constraint::EQUAL,
//                    Constraint::GREATER_EQUAL_THAN
                };

        TransferDataFromWindow();
        mrConstraint.mType = constraints[mpTypeChoice->GetSelection()];

        EndModal(wxID_OK);
    }
}// OnOk

