/** Warstwa wykresu odpowiedzialna za przedstawienie ogranicze na wykresie X-Y.
 *
 * @see PlotControl
 */

#ifndef _ConstraintsLayer_h
#define _ConstraintsLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../Constraint.h"
#include "PlotLayer.h"

// FORWARD REFERENCES
//


class ConstraintsLayer
    : public PlotLayer
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    ConstraintsLayer(const PlotControl&           plotControl,
                     const Constraint::Container  constraints);

    /** Konstruktor kopiujcy.
     */
    ConstraintsLayer(const ConstraintsLayer& from);

    /** Destruktor.
     */
    ~ConstraintsLayer(void);


// OPERATORS

// OPERATIONS

    virtual vector<ToolbarTool> CreateTools(PlotControl* pPlotControl);

// ACCESS

    /** Zwraca referencj na flag okrelajc, czy rysowana bdzie legenda.
     */
    bool&           rLegend();

// INQUIRY

    /** Sprawdza, czy rysowana jest legenda.
     */
    bool            IsLegend() const;

protected:
    void            DrawLegend(wxDC& dc) const;

    const wxPen&    GetConstraintPen(const Constraint&  constraint,
                                     unsigned&          rEqualityIndex,
                                     unsigned&          rInequalityIndex) const;

    /// Ograniczenia
    const Constraint::Container     mConstraints;

private:
    bool    mLegend;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _ConstraintsLayer_h
