#include <precomp.h>

#include "ConstraintsLegendAction.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

ConstraintsLegendAction::ConstraintsLegendAction(
        PlotControl*        pPlotControl,
        ConstraintsLayer*   pConstraintsLayer)
    : mpPlotControl(pPlotControl), mpConstraintsLayer(pConstraintsLayer)
{
}// ConstraintsLegendAction

ConstraintsLegendAction::ConstraintsLegendAction(
        const ConstraintsLegendAction& from)
    : mpPlotControl(from.mpPlotControl),
      mpConstraintsLayer(from.mpConstraintsLayer)
// ToggleToolAction nie ma adnych pl ani konstruktora kopiujcego.
{
}// ConstraintsLegendAction

ConstraintsLegendAction::~ConstraintsLegendAction()
{
}// ~ConstraintsLegendAction


//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================

/* virtual */ bool
ConstraintsLegendAction::Action(bool toggle)
{
    mpConstraintsLayer->rLegend() = toggle;
    mpPlotControl->RefreshPlot();

    return mpConstraintsLayer->IsLegend();
}// Action

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

/* virtual */ bool
ConstraintsLegendAction::IsToggled() const
{
    return mpConstraintsLayer->IsLegend();
}// IsToggled

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
