/** Akcja narzdzia "Dopasuj do iteracji".
 *
 * @see FullPlotVisualizer, PlotToolbar, ResultLayer
 */

#ifndef _ConstraintsLegendAction_h
#define _ConstraintsLegendAction_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "PlotControl.h"
#include "ToggleToolAction.h"
#include "ConstraintsLayer.h"

// FORWARD REFERENCES
//

class ConstraintsLegendAction
    : public ToggleToolAction
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    ConstraintsLegendAction(PlotControl*        pPlotControl,
                            ConstraintsLayer*   pConstraintsLayer);

    /** Konstruktor kopiujcy.
     */
    ConstraintsLegendAction(const ConstraintsLegendAction& from);

    /** Destruktor.
     */
    ~ConstraintsLegendAction(void);


// OPERATORS
// OPERATIONS

    virtual bool    Action(bool toggle);

// ACCESS
// INQUIRY

    virtual bool    IsToggled() const;

protected:
private:
    PlotControl*        mpPlotControl;
    ConstraintsLayer*   mpConstraintsLayer;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _ConstraintsLegendAction_h
