// -*- C++ -*- generated by wxGlade 0.4 on Sat Dec 10 22:01:21 2005

#include <precomp.h>

#include "../HistoryManager.h"
#include "../Logger.h"
#include "../ProblemBase.h"
#include "../util.h"

#include "ConstraintDialog.h"
#include "ConstraintsPanel.h"
#include "FunctionValidator.h"

LOGGER(INFO)

// Event oznaczajcy, e zmieniy si (zostay usunite) jakie ograniczenia, co
// oznacza, i trzeba odwiey list.
DECLARE_EVENT_TYPE(CONSTRAINTS_CHANGED_EVENT, -1);
DEFINE_EVENT_TYPE(CONSTRAINTS_CHANGED_EVENT);

BEGIN_EVENT_TABLE(ConstraintsPanel, wxPanel)
    EVT_BUTTON      (wxID_ADD,     ConstraintsPanel::OnAdd)
    EVT_BUTTON      (ID_BUTTON_EDIT,    ConstraintsPanel::OnEdit)
    EVT_BUTTON      (wxID_REMOVE,  ConstraintsPanel::OnRemove)
    EVT_TEXT        (ID_COMBO_FUNCTION, ConstraintsPanel::OnTextUpdate)
    EVT_TEXT_ENTER  (ID_COMBO_FUNCTION, ConstraintsPanel::OnTextEnter)
//    EVT_COMBOBOX    (ID_COMBO_FUNCTION, ConstraintsPanel::OnComboSelect)
    EVT_LISTBOX     (ID_LISTBOX,        ConstraintsPanel::OnListSelect)
// apie co drugiego doubleclicka na GTK, na Windows co drugi si wywala.
//    EVT_LISTBOX_DCLICK (ID_LISTBOX,     ConstraintsPanel::OnEdit)
    EVT_COMMAND     (ID_LISTBOX, CONSTRAINTS_CHANGED_EVENT,
            ConstraintsPanel::OnConstraintsChange)
END_EVENT_TABLE()

ConstraintsPanel::ConstraintsPanel(
            wxWindow*                   parent,
            int                         id,
            CountedPtr<const Parser>    cpParser,
            ProblemBase*                pProblem,
            FunctionValidator::Type     functionValidatorType,
            History&                    rFunctionHistory,
            History&                    rConstraintHistory,
            const wxPoint&              pos,
            const wxSize&               size,
            long                        style)
    : wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL),
      mcpParser(cpParser),
      mcpFunction(),
      mcpVariables(),
      mConstraints(),
      mpProblem(pProblem),
      mFunctionDirty(), // Inicjowana poniej
      mrConstraintHistory(rConstraintHistory)
{
    // begin wxGlade: ConstraintsPanel::ConstraintsPanel
    sizer_5_staticbox = new wxStaticBox(this, -1, _("Constraints"));
    sizer_10_staticbox = new wxStaticBox(this, -1, _("Function"));
    const wxString mpFunctionCombo_choices[] = {

    };
    mpFunctionCombo = new wxComboBox(this, ID_COMBO_FUNCTION, wxT(""), wxDefaultPosition, wxDefaultSize, 0, mpFunctionCombo_choices, wxCB_DROPDOWN);
    const wxString mpConstraintList_choices[] = {

    };
    mpConstraintList = new wxListBox(this, ID_LISTBOX, wxDefaultPosition, wxDefaultSize, 0, mpConstraintList_choices, wxLB_EXTENDED);
    mpAddButton = new wxButton(this, wxID_ADD, _("Add"));
    mpEditButton = new wxButton(this, ID_BUTTON_EDIT, _("Edit"));
    mpRemoveButton = new wxButton(this, wxID_REMOVE, _("Remove"));

    set_properties();
    do_layout();
    // end wxGlade

    InitFunctionDirty();

    assert(pProblem != NULL);
    mpFunctionCombo->SetValidator(
            FunctionValidator(mcpParser, mcpFunction, mcpVariables, pProblem,
                true, rFunctionHistory, functionValidatorType));
}


void ConstraintsPanel::set_properties()
{
    // begin wxGlade: ConstraintsPanel::set_properties
    mpFunctionCombo->SetSelection(-1);
    mpConstraintList->SetMinSize(wxSize(-1,150));
    mpEditButton->Enable(false);
    mpRemoveButton->Enable(false);
    // end wxGlade
}


void ConstraintsPanel::do_layout()
{
    // begin wxGlade: ConstraintsPanel::do_layout
    wxBoxSizer* sizer_3 = new wxBoxSizer(wxVERTICAL);
    wxStaticBoxSizer* sizer_5 = new wxStaticBoxSizer(sizer_5_staticbox, wxVERTICAL);
    wxBoxSizer* sizer_4 = new wxBoxSizer(wxHORIZONTAL);
    wxStaticBoxSizer* sizer_10 = new wxStaticBoxSizer(sizer_10_staticbox, wxVERTICAL);
    sizer_10->Add(mpFunctionCombo, 0, wxEXPAND|wxADJUST_MINSIZE, 0);
    sizer_3->Add(sizer_10, 0, wxEXPAND, 0);
    sizer_5->Add(mpConstraintList, 1, wxEXPAND|wxADJUST_MINSIZE, 0);
    sizer_4->Add(mpAddButton, 1, wxADJUST_MINSIZE, 0);
    sizer_4->Add(mpEditButton, 1, wxADJUST_MINSIZE, 0);
    sizer_4->Add(mpRemoveButton, 1, wxADJUST_MINSIZE, 0);
    sizer_5->Add(sizer_4, 0, wxEXPAND, 0);
    sizer_3->Add(sizer_5, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_3);
    sizer_3->Fit(this);
    sizer_3->SetSizeHints(this);
    // end wxGlade
}


void
ConstraintsPanel::OnAdd(wxCommandEvent& event)
{
    LOG(DEBUG, wxT("function dirty: ") << mFunctionDirty);
    // Parsuj funkcj, jeli trzeba
    UpdateFunction();

    if (!mFunctionDirty)
    {
        Constraint new_constraint;
        ConstraintDialog dialog(this, -1, new_constraint, *mcpVariables,
                mpProblem, mcpParser, mrConstraintHistory);

        dialog.CenterOnParent();
        if (wxID_OK == dialog.ShowModal())
        {   // zatwierdzono, dodaj ograniczenie
            mConstraints.push_back(new_constraint);

            LOG(DEBUG, wxT("New constraint: ") << new_constraint.ToString(false));

            RefreshList();
        }
    }
}// OnAdd

void
ConstraintsPanel::OnEdit(wxCommandEvent& event)
{
    assert(!mFunctionDirty);

    // Na wxMSW GetSelection zwracao -1.
    wxArrayInt selections;
    int number = mpConstraintList->GetSelections(selections);
    assert(number == 1);

    int index = selections[0];

    LOG(DEBUG, wxT("Selection index: ") << index);
    assert(index >= 0);

    Constraint constraint(mConstraints[index]);
    ConstraintDialog dialog(this, -1, constraint, *mcpVariables, mpProblem,
            mcpParser, mrConstraintHistory);

    dialog.CenterOnParent();
    if (wxID_OK == dialog.ShowModal())
    {   // zatwierdzono, zmie ograniczenie
        mConstraints[index] = constraint;

        mpConstraintList->SetString(index, constraint.ToString(false));
    }
}// OnEdit

void
ConstraintsPanel::OnRemove(wxCommandEvent& event)
{
    wxMessageDialog dialog(this, _("Are you sure?"), _("Remove constraint(s)"),
            wxICON_QUESTION|wxYES_NO);

    dialog.CenterOnParent();
    if (dialog.ShowModal() == wxID_YES)
    {
        wxArrayInt selections;

        mpConstraintList->GetSelections(selections);
        assert(selections.GetCount() > 0);

        // Na wszelki wypadek...
        selections.Sort(CompareIntegers);

        for (int i = selections.GetCount() - 1; i >= 0; --i)
        {
            mConstraints.erase(mConstraints.begin() + selections[i]);
            mpConstraintList->Delete(selections[i]);
        }

        mpEditButton->Enable(false);
        mpRemoveButton->Enable(false);
    }
}// OnRemove

void
ConstraintsPanel::OnTextUpdate(wxCommandEvent& event)
{
    mFunctionDirty = true;
}// OnTextUpdate

void
ConstraintsPanel::OnTextEnter(wxCommandEvent& event)
{
    UpdateFunction();
}// OnTextEnter

// TODO: remove
void
ConstraintsPanel::OnComboSelect(wxCommandEvent& event)
{
    mFunctionDirty = true;

    // Taki hack, bo wywoanie UpdateFunction() update'uje list combo boxa. Ten
    // z kolei w wxMSW czyci swoje pole tekstowe. Jest ono ponownie wypeniane
    // w walidatorze. Ale nie dziaa, gdy jest wywoane z tego event handlera.
    // Dlatego wysyamy zdarzenie, ktre update'uje funkcj.
    wxCommandEvent new_event(wxEVT_COMMAND_CHECKBOX_CLICKED, ID_COMBO_FUNCTION);
    AddPendingEvent(new_event);
}// OnComboSelect

void
ConstraintsPanel::OnConstraintsChange(wxCommandEvent& event)
{
    RefreshList();
}// OnConstraintsChange

void
ConstraintsPanel::OnListSelect(wxCommandEvent& event)
{
    LOG(DEBUG, wxT("OnListSelect"));
    if (mFunctionDirty)
    {
        ParseFunction();
    }

    // Aktywuj odp. przyciski
    wxArrayInt dummy;
    int selection_count = mpConstraintList->GetSelections(dummy);

    if (selection_count == 1)
    {
        mpRemoveButton->Enable(true);
        mpEditButton->Enable(true);
    }
    else if (selection_count > 1)
    {
        mpRemoveButton->Enable(true);
        mpEditButton->Enable(false);
    }
    else
    {
        mpRemoveButton->Enable(false);
        mpEditButton->Enable(false);
    }
}// OnListSelect

////////////////////////////////// PRIVATE ///////////////////////////////////

void
ConstraintsPanel::UpdateFunction()
{
    LOG(DEBUG, wxT("UpdateFunction"));
    if (mFunctionDirty)
    {
        ParseFunction();
    }
}// UpdateFunction

bool
ConstraintsPanel::ParseFunction()
{
    wxValidator* p_function_validator = mpFunctionCombo->GetValidator();

    LOG(DEBUG, wxT("ParseFunction()"));
    bool valid = p_function_validator->Validate(this);
    if (valid && (p_function_validator->TransferFromWindow()))
    {
        mFunctionDirty = false;
    }

    return valid;
}// ParseFunction

void
ConstraintsPanel::InitFunctionDirty()
{
    mFunctionDirty = (mcpFunction.Get() == NULL);
}// InitFunctionDirty

void
ConstraintsPanel::RefreshList()
{
    Constraint::Container::const_iterator i;

    mpConstraintList->Clear();
    for (i = mConstraints.begin(); i != mConstraints.end(); ++i)
    {
        // Tutaj MUSI by ToString, ktry nie oblicza wartoci funkcji. A to
        // dlatego, e w tym panelu NIE WOLNO tego robi, bo jeszcze nie s
        // ustawione zmienne w problemie (bo uytkownik moe wcisn Cancel).
        mpConstraintList->Append(i->ToString(false));
    }

    mpEditButton->Enable(false);
    mpRemoveButton->Enable(false);
}// RefreshList
