// -*- C++ -*- generated by wxGlade 0.4 on Sat Dec 10 22:01:21 2005

#include "../Constraint.h"
#include "../CountedPtr.h"
#include "../History.h"
#include "../Parser.h"
#include "../VariableNames.h"

#include "FunctionValidator.h"

#ifndef CONSTRAINTSPANEL_H
#define CONSTRAINTSPANEL_H

// begin wxGlade: ::dependencies
// end wxGlade


class ConstraintsPanel: public wxPanel {
public:
    friend class ConstraintsValidator;

    enum {
        // TODO: usun zbdne
//        ID_BUTTON_ADD = 1,
        ID_BUTTON_EDIT = 1,
//        ID_BUTTON_REMOVE,
        ID_COMBO_FUNCTION,
        ID_LISTBOX
    };

    // begin wxGlade: ConstraintsPanel::ids
    // end wxGlade

    ConstraintsPanel(wxWindow*                      parent,
                     int                            id,
                     CountedPtr<const Parser>       cpParser,
                     ProblemBase*                   pProblem,
                     FunctionValidator::Type        functionValidatorType,
                     History&                       rFunctionHistory,
                     History&                       rConstraintHistory,
                     const wxPoint&                 pos=wxDefaultPosition,
                     const wxSize&                  size=wxDefaultSize,
                     long                           style=0);


    void        OnAdd(wxCommandEvent& event);
    void        OnEdit(wxCommandEvent& event);
    void        OnRemove(wxCommandEvent& event);
    void        OnTextUpdate(wxCommandEvent& event);
    void        OnComboSelect(wxCommandEvent& event);
    void        OnTextEnter(wxCommandEvent& event);
    void        OnListSelect(wxCommandEvent& event);
    void        OnConstraintsChange(wxCommandEvent& event);

    /** Ustaw flag mFunctionDirty w zalenoci od tego, czy jest funkcja
     */
    void        InitFunctionDirty();
private:
    // begin wxGlade: ConstraintsPanel::methods
    void set_properties();
    void do_layout();
    // end wxGlade

    /** Sprawdza, czy pole tekstowe zostao zmienione i jeli trzeba parsuje
     *  funkcj i odwiea list ogranicze.
     */
    void        UpdateFunction();
    /// Parsuje funkcj.
    bool        ParseFunction();
    /// Odwiea list ogranicze (okienko).
    void        RefreshList();

    /** Sprawdza, ktre ograniczenia zawieraj zmienne nieobecne w funkcji.
     *
     * @return Tablica indeksw ogranicze, ktre naley usun.
     */
    wxArrayInt  MarkInvalidConstraints() const;

    /** Usuwa ograniczenia o indeksach znajdujcych si w tablicy
     * <code>indexes</code>.
     *
     * Nie odwiea zawartoci okienka.
     */
    void        RemoveInvalidConstraints(const wxArrayInt& indexes);


    CountedPtr<const Parser>        mcpParser;      ///< Parser.
    CountedPtr<const FunctionBase>  mcpFunction;    ///< Funkcja.
    CountedPtr<const VariableNames> mcpVariables;   ///< Zmienne.
    vector<Constraint>              mConstraints;   ///< Edytowane ograniczenia.

    ProblemBase*    mpProblem;  ///< Edytowany problem.

    bool        mFunctionDirty; ///< Czy funkcj trzeba ponownie parsowa

    History&    mrConstraintHistory;    ///< Historia wprowadzanych ogranicze.

protected:
    // begin wxGlade: ConstraintsPanel::attributes
    wxStaticBox* sizer_5_staticbox;
    wxStaticBox* sizer_10_staticbox;
    wxComboBox* mpFunctionCombo;
    wxListBox* mpConstraintList;
    wxButton* mpAddButton;
    wxButton* mpEditButton;
    wxButton* mpRemoveButton;
    // end wxGlade

    DECLARE_EVENT_TABLE()
}; // wxGlade: end class


#endif // CONSTRAINTSPANEL_H
