#include <precomp.h>

#include "DerivativeLineSearchPanel.h"

#include "MethodPanelFactory.h"
#include "../methods/Derivative.h"
#include "../methods/SignOfDerivative.h"

static void* RegisterPanels()
{
    MethodPanelFactory& factory = MethodPanelFactory::GetInstance();

    factory.Register(Derivative::ClassId(),
            DerivativeLineSearchPanel<Derivative>::CreatePanel);

    factory.Register(SignOfDerivative::ClassId(),
            DerivativeLineSearchPanel<SignOfDerivative>::CreatePanel);

    return NULL;
}

static const void* trigger_dummy = RegisterPanels();


