/** Warstwa wykresu rysujca iteracj metody podziau dychotomicznego.
 *
 * @see DichotomousDivision, DichotomousDivisionIteration
 */

#ifndef _DichotomousDivisionLayer_h
#define _DichotomousDivisionLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "UnivariateResultLayer.h"

// FORWARD REFERENCES
//

class FunctionBase;

class DichotomousDivisionLayer
    : public UnivariateResultLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    DichotomousDivisionLayer(const PlotControl&         plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    DichotomousDivisionLayer(const DichotomousDivisionLayer& from);


    /** Destruktor.
     */
    ~DichotomousDivisionLayer(void);


// OPERATORS

// OPERATIONS

    virtual void    Draw(wxDC& dc) const;

    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);

// ACCESS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

// INQUIRY

protected:

    void            DrawIteration(wxDC&             dc,
                                  unsigned          iterationNumber,
                                  bool              highlight) const;

    void            DrawActiveIterationBackground(wxDC& dc) const;

private:

    static const void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _DichotomousDivisionLayer_h
