/**  wxValidator dla parametrw metod w polach tekstowych.
 *
 * @see DoubleParameter, wxValidator
 */

#ifndef _DoubleParameterValidator_h
#define _DoubleParameterValidator_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//
#include <wx/validate.h>

// LOCAL INCLUDES
//
#include "../DoubleParameter.h"

// FORWARD REFERENCES
//


class DoubleParameterValidator
    : public wxValidator
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    DoubleParameterValidator(DoubleParameter&   rParameter,
                             const wxString&    format = wxT("%.6g"));

    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    DoubleParameterValidator(const DoubleParameterValidator& from);

    /** Destruktor.
     */
    ~DoubleParameterValidator(void);


// OPERATORS

// OPERATIONS

    /** Tworzy kopi obiektu.
     */
    virtual wxObject*       Clone() const;

    /** Wprowadza dane ze zmiennej do kontrolki.
     */
    virtual bool            TransferToWindow();

    /** Wyprowadza dane z kontrolki do zmiennej.
     */
    virtual bool            TransferFromWindow();

    /** Sprawdza poprawno danych wprowadzonych do kontrolki.
     *
     * W przypadku nieprawidowoci wywietla okienko z komunikatem.
     */
    virtual bool            Validate(wxWindow* pParent);

    /** Filtruje nieodpowiednie znaki.
     *
     * Wszystkie, oprcz cyfr, minusa i przecinka/kropki.
     */
    void                    OnChar(wxKeyEvent& event);

// ACCESS
// INQUIRY

protected:
private:
    /// Referencja na zmienn skojarzon z walidatorem
    DoubleParameter&    mrParameter;

    const wxString      mFormat; ///< Format konwersji liczby do cigu znakw
    static wxChar       mDecimalSeparator;  ///< Znak separatora dziesitnego

    DECLARE_EVENT_TABLE()

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _DoubleParameterValidator_h
