#include <precomp.h>

#include "DrawDeceasedAction.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

DrawDeceasedAction::DrawDeceasedAction(
                        PlotControl*                pPlotControl,
                        EvolutionaryMethodLayer*    pEvolutionaryMethodLayer)
    : mpPlotControl(pPlotControl),
      mpEvolutionaryMethodLayer(pEvolutionaryMethodLayer)
{
}// DrawDeceasedAction

DrawDeceasedAction::DrawDeceasedAction(const DrawDeceasedAction& from)
    : mpPlotControl(from.mpPlotControl),
      mpEvolutionaryMethodLayer(from.mpEvolutionaryMethodLayer)
// ToggleToolAction nie ma adnych pl ani konstruktora kopiujcego.
{
}// DrawDeceasedAction

DrawDeceasedAction::~DrawDeceasedAction()
{
}// ~DrawDeceasedAction

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================

/* virtual */ bool
DrawDeceasedAction::Action(bool toggle)
{
    mpEvolutionaryMethodLayer->mDrawDeceased = toggle;
    mpPlotControl->RefreshPlot();

    return mpEvolutionaryMethodLayer->mDrawDeceased;
}// Action

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

/* virtual */ bool
DrawDeceasedAction::IsToggled() const
{
    return mpEvolutionaryMethodLayer->mDrawDeceased;
}// IsToggled

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
