#include <precomp.h>

#include "../Symbols.h"
#include "../text-util.h"

#include "DoubleParameterValidator.h"
#include "EpsilonControl.h"

EpsilonControl::EpsilonControl(wxWindow*              parent,
                               int                    id,
                               DoubleParameter&       rEpsilon,
                               const wxPoint&         pos,
                               const wxSize&          size,
                               long                   style)
    : wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL)
{
    // Tworzenie kontrolek.
    mpEpsilonLabel = new wxStaticText(this, -1, _("Stop condition")
        + LabelSymbol(Symbols::GetInstance()[Symbols::EPSILON]));  
    mpEpsilonTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);

    do_layout();

    // Walidator.
    mpEpsilonTextCtrl->SetValidator(DoubleParameterValidator(rEpsilon));

}// EpsilonControl

void EpsilonControl::do_layout()
{
    wxBoxSizer* sizer_23 = new wxBoxSizer(wxVERTICAL);
    wxGridSizer* grid_sizer_2 = new wxGridSizer(1, 2, 0, 0);
    grid_sizer_2->Add(mpEpsilonLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_2->Add(mpEpsilonTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 0);
    sizer_23->Add(grid_sizer_2, 0, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_23);
    sizer_23->Fit(this);
    sizer_23->SetSizeHints(this);
}

