#ifndef EVOLUTIONARYMETHODPANEL_H
#define EVOLUTIONARYMETHODPANEL_H

#include "../methods/EvolutionaryMethod.h"

#include "MethodPanelInfo.h"
#include "RangeControl.h"
#include "GeneticOperatorControl.h"
#include "StopConditionControl.h"

class EvolutionaryMethodPanel: public wxPanel {
public:

    EvolutionaryMethodPanel(wxWindow*       parent,
                    int                     id,
                    EvolutionaryMethod*     pMethod,
                    const ProblemBase&      problem,
                    const wxPoint&          pos=wxDefaultPosition,
                    const wxSize&           size=wxDefaultSize,
                    long style=0);

    /** Tworzy panel tej klasy.
     *
     * Metoda wywoywana przez MethodPanelFactory.
     */
    static wxPanel*         CreatePanel(MethodPanelInfo     panelInfo);


private:

    void set_properties();
    void do_layout();

    static const void*      mpRegistrationDummy;

protected:

    wxStaticBox*                    mpInitialPopulationSizer_staticbox;
    GeneticOperatorControl<SelectionMethod>*
                                    mpSelectionMethodPanel;
    GeneticOperatorControl<MutationMethod>*
                                    mpMutationMethodPanel;
    GeneticOperatorControl<CrossoverMethod>*
                                    mpCrossoverMethodPanel;
    StopConditionControl*           mpStopCondition;
    wxStaticText*                   mpSurvivalRateLabel;
    wxTextCtrl*                     mpSurvivalRateCtrl;
    wxStaticText*                   mpRadioactivityLabel;
    wxTextCtrl*                     mpRadioactivityCtrl;
    wxStaticText*                   mpMutationRateLabel;
    wxTextCtrl*                     mpMutationRateCtrl;
    wxStaticText*                   mpCrossoverRateLabel;
    wxTextCtrl*                     mpCrossoverRateCtrl;
    wxStaticText*                   mpNumberOfChromosomesLabel;
    wxTextCtrl*                     mpNumberOfChromosomesTextCtrl;
    RangeControl*                   mpStartingRange;

};

#endif // EVOLUTIONARYMETHODPANEL_H
