/** Warstwa wykresu rysujca iteracj metody alfa-podziau.
 *
 * @see FibonacciDivision, FibonacciDivisionIteration
 */

#ifndef _FibonacciDivisionLayer_h
#define _FibonacciDivisionLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "UnivariateResultLayer.h"

// FORWARD REFERENCES
//


class FibonacciDivisionLayer
    : public UnivariateResultLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    FibonacciDivisionLayer(const PlotControl&       plotControl,
                       const Result&            result,
                       CountedPtr<PlotLayer>    cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    FibonacciDivisionLayer(const FibonacciDivisionLayer& from);

    /** Destruktor.
     */
    ~FibonacciDivisionLayer(void);


// OPERATORS

// OPERATIONS

    virtual void    Draw(wxDC& dc) const;

    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);

// ACCESS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

// INQUIRY

protected:

    void            DrawIteration(wxDC&             dc,
                                  unsigned          iterationNumber,
                                  bool              highlight) const;


    void            DrawActiveIterationBackground(wxDC& dc) const;

private:

    static const void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _FibonacciDivisionLayer_h
