/**
 *
 * @see wxValidator
 */

#ifndef _GeneticOperatorValidator_h
#define _GeneticOperatorValidator_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "GeneticOperatorControl.h"

// FORWARD REFERENCES
//

template <class T>
class GeneticOperatorValidator
    : public wxValidator
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    GeneticOperatorValidator
                        (CountedPtr<const T>& rcpGeneticOperator)
        : mrcpGeneticOperator(rcpGeneticOperator)
    {
    }// GeneticOperatorValidator

    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    GeneticOperatorValidator(const GeneticOperatorValidator& from)
        : mrcpGeneticOperator(from.mrcpGeneticOperator)
    {
    }// GeneticOperatorValidator

    /** Destruktor.
     */
    ~GeneticOperatorValidator(void)
    {
    }

// OPERATORS
// OPERATIONS

    /** Tworzy kopi obiektu.
     */
    virtual wxObject*       Clone() const
    {
        return new GeneticOperatorValidator(*this);
    }// Clone

    /** Wprowadza dane do kontrolki.
     */
    virtual bool            TransferToWindow()
    {
        if (mrcpGeneticOperator.Get() != NULL)
        {
            GeneticOperatorControl<T>* p_control
                = dynamic_cast<GeneticOperatorControl<T>*>(GetWindow());

            int pos = p_control->SelectName(mrcpGeneticOperator->Name());

            assert(pos != wxNOT_FOUND);
        }

        return true;
    }// TransferToWindow

    /** Wyciga dane z kontrolki.
     */
    virtual bool            TransferFromWindow()
    {
        GeneticOperatorControl<T> *p_control
            = dynamic_cast<GeneticOperatorControl<T>*>(GetWindow());

        mrcpGeneticOperator = CountedPtr<const T>(p_control->CreateSelected());

        return true;
    }// TransferFromWindow

    /** Sprawdza poprawno danych w kontrolce.
     */
    virtual bool            Validate(wxWindow* pParent)
    {
        return GetWindow()->Validate();
    }// Validate

// ACCESS
// INQUIRY

protected:
private:

    /// Referencja na <code>CountedPtr</code> na operator genetyczny
    CountedPtr<const T>&    mrcpGeneticOperator;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _GeneticOperatorValidator_h
