/** Warstwa wykresu rysujca przebieg optymalizacji metod gradientow.
 *
 * @see PlotControl, GradientMethodIteration
 */

#ifndef _GradientMethodLayer_h
#define _GradientMethodLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "XyUnconstrainedLayer.h"

// FORWARD REFERENCES
//


class GradientMethodLayer
    : public XyUnconstrainedLayer
{
public:
// LIFECYCLE

    /** Konstruktor
     */
    GradientMethodLayer(const PlotControl&      plotControl,
                        const Result&           result,
                        CountedPtr<PlotLayer>   cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    GradientMethodLayer(const GradientMethodLayer& from);

    /** Destruktor.
     */
    ~GradientMethodLayer(void);


// OPERATORS

// OPERATIONS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

    /** Metoda fabryki.
     */
    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);
// ACCESS

// INQUIRY


protected:
private:
    virtual void        DrawIteration(wxDC&     dc,
                                      unsigned  iterationNumber,
                                      bool      highlight) const;

    const static void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _GradientMethodLayer_h
