// -*- C++ -*- generated by wxGlade 0.4 on Thu Dec  8 20:19:59 2005

#include <precomp.h>

#include "../Symbols.h"
#include "../text-util.h"

#include "DoubleParameterValidator.h"
#include "MethodPanelFactory.h"
#include "HookeJeevesDiscretePanel.h"


HookeJeevesDiscretePanel::HookeJeevesDiscretePanel(
        wxWindow*               parent,
        int                     id,
        HookeJeevesDiscrete*    pMethod,
        const ProblemBase&      problem,
        const wxPoint&          pos,
        const wxSize&           size,
        long                    style)
    : wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL),
      mpMethod(pMethod)
{
    // begin wxGlade: HookeJeevesDiscretePanel::HookeJeevesDiscretePanel
    mpLabelTau = new wxStaticText(this, -1, _("[Label set explicitly in ui/HookeJeevesDiscretePanel::set_properties().]"));
    mpTextCtrlTau = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpLabelBeta = new wxStaticText(this, -1, _("[Label set explicitly in ui/HookeJeevesDiscretePanel::set_properties().]"));
    mpTextCtrlBeta = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpLabelEpsilon = new wxStaticText(this, -1, _("[Label set explicitly in ui/HookeJeevesDiscretePanel::set_properties().]"));
    mpTextCtrlEpsilon = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpStartingPoint = new PointControl(this, -1, wxDefaultPosition, wxDefaultSize, 0, _("Starting point"));

    set_properties();
    do_layout();
    // end wxGlade

    // Walidatory
    mpTextCtrlTau->SetValidator(DoubleParameterValidator(mpMethod->mTau));
    mpTextCtrlEpsilon->SetValidator(
            DoubleParameterValidator(mpMethod->mEpsilon));
    mpTextCtrlBeta->SetValidator(DoubleParameterValidator(mpMethod->mBeta));

    // Punkt startowy
    mpStartingPoint->Init(problem.Variables(),
          /*mpMethod->mStartingPoint*/mpMethod->mInitialStartingPoint);

    // TODO: dorobi przycisk "Zastosuj"

    Layout();
}


void HookeJeevesDiscretePanel::set_properties()
{
    // begin wxGlade: HookeJeevesDiscretePanel::set_properties
    // end wxGlade

    // Etykiety z greckimi literami.
    const Symbols& symbols = Symbols::GetInstance();
    const wxString& tau_label_text     = _("Trial step length")
            + LabelSymbol(symbols[Symbols::TAU]);
    const wxString& beta_label_text    = _("Contraction factor")
            + LabelSymbol(symbols[Symbols::BETA]);
    const wxString& epsilon_label_text = _("Stop condition")
            + LabelSymbol(symbols[Symbols::EPSILON]);

    mpLabelTau->SetLabel(tau_label_text);
    mpLabelBeta->SetLabel(beta_label_text);
    mpLabelEpsilon->SetLabel(epsilon_label_text);
}


void HookeJeevesDiscretePanel::do_layout()
{
    // begin wxGlade: HookeJeevesDiscretePanel::do_layout
    wxBoxSizer* sizer_1 = new wxBoxSizer(wxVERTICAL);
    wxFlexGridSizer* grid_sizer_1 = new wxFlexGridSizer(3, 2, 0, 0);
    grid_sizer_1->Add(mpLabelTau, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_1->Add(mpTextCtrlTau, 0, wxALL|wxEXPAND|wxADJUST_MINSIZE, 2);
    grid_sizer_1->Add(mpLabelBeta, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_1->Add(mpTextCtrlBeta, 0, wxALL|wxEXPAND|wxADJUST_MINSIZE, 2);
    grid_sizer_1->Add(mpLabelEpsilon, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_1->Add(mpTextCtrlEpsilon, 0, wxALL|wxEXPAND|wxADJUST_MINSIZE, 2);
    grid_sizer_1->AddGrowableCol(0);
    grid_sizer_1->AddGrowableCol(1);
    sizer_1->Add(grid_sizer_1, 0, wxEXPAND, 0);
    sizer_1->Add(mpStartingPoint, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_1);
    sizer_1->Fit(this);
    sizer_1->SetSizeHints(this);
    // end wxGlade
}

/* static */ wxPanel*
HookeJeevesDiscretePanel::CreatePanel(MethodPanelInfo   panelInfo)
{
    return new HookeJeevesDiscretePanel(
            panelInfo.pParent(),
            -1,
            dynamic_cast<HookeJeevesDiscrete*>(panelInfo.pMethod()),
            *panelInfo.pProblem());
}// CreatePanel

// Zarejestruj metod tworzc panel
const void* HookeJeevesDiscretePanel::mpRegistrationDummy =
        MethodPanelFactory::GetInstance().Register(
                HookeJeevesDiscrete::ClassId(),
                HookeJeevesDiscretePanel::CreatePanel);
