/** Warstwa wykresu rysujca przebieg optymalizacji algorytmem Hooke'a Jeevesa.
 *
 * @see PlotControl
 */

#ifndef _HookeJeevesLayer_h
#define _HookeJeevesLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "PointControl.h"
#include "XyUnconstrainedLayer.h"

// FORWARD REFERENCES
//


class HookeJeevesLayer
    : public XyUnconstrainedLayer
{
public:
// LIFECYCLE

    /** Konstruktor
     */
    HookeJeevesLayer(const PlotControl&     plotControl,
                     const Result&          result,
                     CountedPtr<PlotLayer>  cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    HookeJeevesLayer(const HookeJeevesLayer& from);


    /** Destruktor.
     */
    ~HookeJeevesLayer(void);


// OPERATORS

// OPERATIONS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

    /** Metoda fabryki.
     */
    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);
// ACCESS

// INQUIRY


protected:
private:
    virtual void            DrawIteration(wxDC&     dc,
                                  unsigned  iterationNumber,
                                  bool      highlight) const;

    const static void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _HookeJeevesLayer_h
