/**  wxValidator dla pocztkowego odcinka metod w kierunku.
 *
 * @see InitialSection, wxValidator
 */

#ifndef _InitialSectionValidator_h
#define _InitialSectionValidator_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//
#include <wx/validate.h>

// LOCAL INCLUDES
//
#include "../DoubleParameter.h"
#include "../SectionLineSearch.h"

// FORWARD REFERENCES
//

class InitialSectionValidator
    : public wxValidator
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    InitialSectionValidator(SectionLineSearch*      pMethod,
                            DoubleParameter&        rLeftBound,
                            DoubleParameter&        rRightBound);


    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    InitialSectionValidator(const InitialSectionValidator& from);

    /** Destruktor.
     */
    ~InitialSectionValidator(void);


// OPERATORS

// OPERATIONS

    /** Tworzy kopi obiektu.
     */
    virtual wxObject*       Clone() const;

    /** Wprowadza dane ze zmiennej do kontrolki.
     */
    virtual bool            TransferToWindow();

    /** Wyprowadza dane z kontrolki do zmiennej.
     */
    virtual bool            TransferFromWindow();

    /** Sprawdza poprawno danych wprowadzonych do kontrolki.
     *
     * W przypadku nieprawidowoci wywietla okienko z komunikatem.
     */
    virtual bool            Validate(wxWindow* pParent);

// ACCESS
// INQUIRY

protected:
    SectionLineSearch*  mpMethod;
    DoubleParameter&    mrLeftBound;
    DoubleParameter&    mrRightBound;
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _InitialSectionValidator_h
