/** Walidator liczb cakowitych z wymuszaniem wartoci minimalnej i maksymalnej.
 */

#ifndef _IntegerValidator_h
#define _IntegerValidator_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//

// FORWARD REFERENCES
//


class IntegerValidator
    : public wxValidator
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     *
     * @param rValue Referencja na edytowan zmienn.
     * @param min Minimalna dopuszczalna warto.
     * @param max Maksymalna dopuszczalna warto.
     * @param format Format wywietlania liczb (rwnie w komunikatach o
     * nieprawidowej wartoci).
     */
    IntegerValidator(long&              rValue,
                     long               min = LONG_MIN,
                     long               max = LONG_MAX,
                     const wxString&    format = wxT("%ld"));

    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    IntegerValidator(const IntegerValidator& from);


    /** Destruktor.
     */
    ~IntegerValidator(void);


// OPERATORS

// OPERATIONS

    /// Klonowanie
    virtual wxObject*       Clone() const;

    /// Sprawdza poprawno wprowadzonej wartoci
    virtual bool            Validate(wxWindow* pParent);

    /** Przenosi warto ze zmiennej do okienka.
     */
    virtual bool            TransferToWindow();

    /** Przenosi warto z okienka do zmiennej zwizanej z walidatorem.
     */
    virtual bool            TransferFromWindow();


    /** Przechwytuje eventy nacinicia klawisza i przepuszcza tylko cyfry oraz
     * + i -.
     */
    void                    OnChar(wxKeyEvent& event);

// ACCESS
// INQUIRY

protected:
private:
    DECLARE_EVENT_TABLE()

    /** Wywietla okienko z komunikatem o wprowadzeniu zej wartoci.
     */
    void                    ShowError(wxWindow*         pParent,
                                      const wxString&   message);

    long&           mrValue;    ///< Referencja na zmienn.
    const wxString  mFormat;    ///< Format wywietlania liczb.
    long            mMin;       ///< Minimalna dop. warto.
    long            mMax;       ///< Maksymalna dop. warto.
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _IntegerValidator_h
