/** Kontrolka wyboru metody optymalizacji w kierunku.
 *
 * Suy do stosowania w panelach ustawie metod optymalizacji, ktre
 * wykorzystuj optymalizacj w kierunku.
 */

#ifndef _LineSearchControl_h
#define _LineSearchControl_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../LineSearch.h"

#include "AutoChoice.h"

// FORWARD REFERENCES
//


class LineSearchControl
    : public wxPanel
{
public:
    enum {
        ID_SETTINGS_BUTTON = 1
    };

// LIFECYCLE

    /** Konstruktor.
     */
    LineSearchControl(wxWindow*          pParent,
                      wxWindowID         id,
                      const ProblemBase& problem,
                      const wxPoint&     pos = wxDefaultPosition,
                      const wxSize&      size = wxDefaultSize,
                      long               style = 0);

    /** Destruktor.
     */
    ~LineSearchControl(void);


// OPERATORS

// OPERATIONS

    /** Tworzy (klonuje) obiekt metody na podstawie wyboru z listy.
     */
    std::auto_ptr<const LineSearch> CreateSelected() const;

    /** Ustawia wybr na elementu o podanej nazwie.
     */
    void                        SelectName(const wxString& name);

    /** Zmienia zadanie optymalizacji, dla ktrego wybierana jest metoda.
     */
    void                        Reset(const ProblemBase* pProblem);


    /** Otwiera okienko ustawie wybranej metody.
     *
     * Wywoywane w reakcji na nacinicie przycisku.
     */
    void                        OnSettings(wxCommandEvent& event);

// ACCESS
// INQUIRY

protected:
private:
    AutoChoice<LineSearch>* mpLineSearchChoice;
    wxButton*               mpSettingsButton;

    DECLARE_EVENT_TABLE()
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _LineSearchControl_h
