#include <precomp.h>

#include "LineSearchSettingsDialog.h"  // class implemented
#include "MethodPanelFactory.h"

BEGIN_EVENT_TABLE(LineSearchSettingsDialog, wxDialog)
    EVT_BUTTON(wxID_OK, LineSearchSettingsDialog::OnOk)
END_EVENT_TABLE()

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

LineSearchSettingsDialog::LineSearchSettingsDialog(wxWindow*        pParent,
                                                   wxWindowID       id,
                                                   Method*          pMethod)
    : wxDialog(pParent, id, pMethod->Name())
{
    wxBoxSizer* p_button_sizer = new wxBoxSizer(wxHORIZONTAL);

    mpOkButton = new wxButton(this, wxID_OK, _("OK"));
    mpCancelButton = new wxButton(this, wxID_CANCEL, _("Cancel"));

    p_button_sizer->Add(0, 0, 1);   // spejser
    p_button_sizer->Add(mpOkButton, 0, wxALL, 2);
    p_button_sizer->Add(mpCancelButton, 0, wxALL, 2);

    wxBoxSizer* p_main_sizer = new wxBoxSizer(wxVERTICAL);

    mpMethodPanel = MethodPanelFactory::GetInstance().CreatePanel(
            MethodPanelInfo(pMethod, this));

    p_main_sizer->Add(mpMethodPanel, 1, wxEXPAND, 0);
    p_main_sizer->Add(p_button_sizer, 0, wxEXPAND, 0);

    SetSizer(p_main_sizer);
    SetAutoLayout(true);
    p_main_sizer->Fit(this);
    p_main_sizer->SetSizeHints(this);
    mpMethodPanel->SetExtraStyle(wxWS_EX_VALIDATE_RECURSIVELY);

    mpMethodPanel->TransferDataToWindow();
}// LineSearchSettingsDialog

LineSearchSettingsDialog::~LineSearchSettingsDialog()
{
}// ~LineSearchSettingsDialog


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

void
LineSearchSettingsDialog::OnOk(wxCommandEvent& event)
{
    if (mpMethodPanel->Validate() && mpMethodPanel->TransferDataFromWindow())
    {
        EndModal(wxID_OK);
    }
}// OnOk

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
