#include <precomp.h>

#include "../Logger.h"
#include "LineSearchValidator.h"  // class implemented

LOGGER(INFO);

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

LineSearchValidator::LineSearchValidator(
        CountedPtr<const LineSearch>&   rcpLineSearch,
        const ProblemBase*              pProblem)
    : mrcpLineSearch(rcpLineSearch), mpProblem(pProblem)
{
}// LineSearchValidator

LineSearchValidator::LineSearchValidator(const LineSearchValidator& from)
    : mrcpLineSearch(from.mrcpLineSearch), mpProblem(from.mpProblem)
{
}// LineSearchValidator

LineSearchValidator::~LineSearchValidator()
{
}// ~LineSearchValidator


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

/* virtual */ wxObject*
LineSearchValidator::Clone() const
{
    return new LineSearchValidator(*this);
}// Clone

/* virtual */ bool
LineSearchValidator::TransferToWindow()
{
    LOG(DEBUG, wxT("TransferToWindow"));
    if (mrcpLineSearch.Get() != NULL)
    {
        LineSearchControl *p_control
            = dynamic_cast<LineSearchControl*>(GetWindow());

        p_control->SelectName(mrcpLineSearch->Name());

        p_control->Reset(mpProblem);
    }

    return true;
}// TransferToWindow

/* virtual */ bool
LineSearchValidator::TransferFromWindow()
{
    LOG(DEBUG, wxT("TransferFromWindow"));

    LineSearchControl *p_control
        = dynamic_cast<LineSearchControl*>(GetWindow());

    mrcpLineSearch = p_control->CreateSelected();

    return true;
}// TransferFromWindow

/* virtual */ bool
LineSearchValidator::Validate(wxWindow* pParent)
{
    LOG(DEBUG, wxT("Validate"));
    return true;
}// Validate


//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
