/**  wxValidator dla kontrolki ustawiania metody optymalizacji w kierunku.
 *
 * @see wxValidator
 */

#ifndef _LineSearchValidator_h
#define _LineSearchValidator_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../CountedPtr.h"
#include "LineSearchControl.h"

// FORWARD REFERENCES
//


class LineSearchValidator
    : public wxValidator
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    LineSearchValidator(CountedPtr<const LineSearch>&   rcpLineSearch,
                        const ProblemBase*              pProblem);

    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    LineSearchValidator(const LineSearchValidator& from);

    /** Destruktor.
     */
    ~LineSearchValidator(void);


// OPERATORS

// OPERATIONS

    /** Tworzy kopi obiektu.
     */
    virtual wxObject*       Clone() const;

    /** Wprowadza dane do kontrolki.
     */
    virtual bool            TransferToWindow();

    /** Wyciga dane z kontrolki.
     */
    virtual bool            TransferFromWindow();

    /** Sprawdza poprawno danych w kontrolce.
     */
    virtual bool            Validate(wxWindow* pParent);

// ACCESS
// INQUIRY

protected:
private:
    /// Referencja na <code>CountedPtr</code> na warunek stopu.
    CountedPtr<const LineSearch>&   mrcpLineSearch;
    const ProblemBase*              mpProblem;   ///< Wskanik na problem.
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _LineSearchValidator_h
