
#ifndef _MainFrame_H
#define _MainFrame_H

#include "AutoChoice.h"
#include "ProblemChoice.h"

class MainFrame: public wxFrame {
public:
    enum {
        ID_BUTTON_PROBLEM = 1,
        ID_BUTTON_CONFIGURE,
        ID_BUTTON_OPTIMIZE,
	ID_BUTTON_ABOUT,
        ID_METHOD_CHOICE
    };

    MainFrame(wxWindow* parent, int id, const wxString& title, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxDEFAULT_FRAME_STYLE);

    void        OnMethodChoice(wxCommandEvent& event);
    void        OnConfigure(wxCommandEvent& event);
    void        OnAbout(wxCommandEvent& event);
    void        OnClose(wxCloseEvent& event);
    void        OnOptimize(wxCommandEvent& event);
    void        OnProblem(wxCommandEvent& event);

private:
    void        set_properties();
    void        do_layout();

    void        ChangeMethodPanel(Method* pMethod);

    ProblemBase*    mpProblem;

    /// Oznacza, e nie zdefiniowano jeszcze zadania optymalizacji
    bool            mNoProblem;

protected:
    wxPanel*        mpMainPanel;
    wxSplitterWindow* mpSplitter;
    wxPanel*        mpProblemPane;
    wxStaticBox*    mpProblemStaticbox;
    wxTextCtrl*     mpProblemText;
    wxButton*       mpProblemButton;

    wxPanel*        mpMethodPane;
    wxSizer*        mpMethodSizer;
    //MethodChoice*   mpMethodChoice;
    AutoChoice<Method>* mpMethodChoice;
    wxPanel*        mpMethodPanel;

    wxButton*       mpAboutButton;
    wxButton*       mpConfigureButton;
    wxButton*       mpOptimizeButton;

    DECLARE_EVENT_TABLE();
}; // wxGlade: end class


#endif // _MainFrame_H
