/** Warstwa wykresu rysujca iteracj metody Marquardta.
 *
 * @see Marquardt, MarquardtIteration
 */

#ifndef _MarquardtLayer_h
#define _MarquardtLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "XyUnconstrainedLayer.h"

// FORWARD REFERENCES
//


class MarquardtLayer
    : public XyUnconstrainedLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    MarquardtLayer(const PlotControl&           plotControl,
                   const Result&                result,
                         CountedPtr<PlotLayer>  cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    MarquardtLayer(const MarquardtLayer& from);

    /** Destruktor.
     */
    ~MarquardtLayer(void);


// OPERATORS

// OPERATIONS

    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);

// ACCESS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

// INQUIRY

protected:

    virtual void        DrawIteration(wxDC&             dc,
                                      unsigned          iterationNumber,
                                      bool              highlight) const;

private:

    static const void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _MarquardtLayer_h
