// -*- C++ -*- generated by wxGlade 0.4 on Wed May 10 20:31:32 2006
#include <precomp.h>

#include "../Logger.h"
#include "../Symbols.h"
#include "../text-util.h"

#include "DoubleParameterValidator.h"
#include "MethodPanelFactory.h"
#include "MarquardtPanel.h"

LOGGER(INFO);

MarquardtPanel::MarquardtPanel(wxWindow*            parent,
                               int                  id,
                               Marquardt*           pMethod,
                               const ProblemBase&   problem,
                               const                wxPoint& pos,
                               const                wxSize& size,
                               long                 style):
    wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL)
{
    // begin wxGlade: MarquardtPanel::MarquardtPanel
    mpLambdaLabel = new wxStaticText(this, -1, _("[Label set explicitly in ui/MarquardtPanel::set_properties().]"));
    mpLambdaTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpStopCondition = new StopConditionControl(this, -1);
    mpStartingPoint = new PointControl(this, -1, wxDefaultPosition, wxDefaultSize, 0, _("Starting point"));

    set_properties();
    do_layout();
    // end wxGlade

    // Inicjowanie listy warunkw stopu.
    mpStopCondition->SetList(pMethod->AllowedStopConditions());

    // Walidatory.
    mpLambdaTextCtrl->SetValidator(
            DoubleParameterValidator(pMethod->mInitialLambda));
    mpStopCondition->SetValidator(StopConditionValidator(
                    reinterpret_cast<CountedPtr<const StopConditionBase>&>(
                        pMethod->mcpStopCondition)));

    // Punkt startowy.
    mpStartingPoint->Init(problem.Variables(),
            /*pMethod->mStartingPoint*/pMethod->mInitialStartingPoint);

}


void MarquardtPanel::set_properties()
{
    // begin wxGlade: MarquardtPanel::set_properties
    // end wxGlade

    // Etykiety z greckimi literami.
    const wxString& lambda_label_text =
        _("Initial identity matrix weight")
        + LabelSymbol(Symbols::GetInstance()[Symbols::LAMBDA]);
    mpLambdaLabel->SetLabel(lambda_label_text);

}


void MarquardtPanel::do_layout()
{
    // begin wxGlade: MarquardtPanel::do_layout
    wxBoxSizer* p_main_sizer = new wxBoxSizer(wxVERTICAL);
    wxFlexGridSizer* p_grid_sizer = new wxFlexGridSizer(1, 2, 0, 0);
    p_grid_sizer->Add(mpLambdaLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_grid_sizer->Add(mpLambdaTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_grid_sizer->AddGrowableCol(0);
    p_grid_sizer->AddGrowableCol(1);
    p_main_sizer->Add(p_grid_sizer, 0, wxEXPAND, 0);
    p_main_sizer->Add(mpStopCondition, 0, wxEXPAND, 0);
    p_main_sizer->Add(mpStartingPoint, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(p_main_sizer);
    p_main_sizer->Fit(this);
    p_main_sizer->SetSizeHints(this);
    // end wxGlade
}

/* static */ wxPanel*
MarquardtPanel::CreatePanel(MethodPanelInfo   panelInfo)
{
    return new MarquardtPanel(
            panelInfo.pParent(),
            -1,
            dynamic_cast<Marquardt*>(panelInfo.pMethod()),
            *panelInfo.pProblem());
}// CreatePanel

// Zarejestruj metod tworzc panel
const void* MarquardtPanel::mpRegistrationDummy =
        MethodPanelFactory::GetInstance().Register(
                Marquardt::ClassId(),
                MarquardtPanel::CreatePanel);

