/**  Fabryka paneli ustawie parametrw metod.
 */

#ifndef _MethodPanelFactory_h
#define _MethodPanelFactory_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../Method.h"

#include "MethodPanelInfo.h"

// FORWARD REFERENCES
//


class MethodPanelFactory
{
public:
    /** Wskanik na funkcj tworzc panel metody.
     */
    typedef wxPanel*(*PanelCreator)(MethodPanelInfo);

// LIFECYCLE

    /** Destruktor.
     */
    ~MethodPanelFactory(void);


// OPERATORS
// OPERATIONS

    /** Rejestruje funkcj tworzc panel dla danej metody.
     *
     * @return NULL (warto bez znaczenia, jej zwracanie jest przydatne przy
     * automatycznym rejestrowaniu przez tworzenie statycznej skadowej klasy).
     */
    void*                   Register(MethodIdType id, PanelCreator function);

    /** Tworzy panel dla danej metody.
     */
    wxPanel*                CreatePanel(MethodPanelInfo panelInfo) const;

    /** Oblicza minimalny rozmiar, ktry pomieci kady panel.
     */
    wxSize                  MinSize();

// ACCESS

    /** Zwraca referencj na singleton.
     */
    static MethodPanelFactory&  GetInstance();

// INQUIRY

protected:
private:
    /** Konstruktor domylny.
     */
    MethodPanelFactory(void);

    map<MethodIdType, PanelCreator>  mFactories;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _MethodPanelFactory_h
