#include <precomp.h>

#include "MethodPanelInfo.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

MethodPanelInfo::MethodPanelInfo(Method*            pMethod,
                                 wxWindow*          pParent,
                                 const ProblemBase* pProblem)
    : mType(STANDALONE), mpMethod(pMethod), mpParent(pParent), mpProblem(pProblem)
{
}// MethodPanelInfo

MethodPanelInfo::MethodPanelInfo(Method*            pMethod,
                                 wxWindow*          pParent)
    : mType(LINESEARCH), mpMethod(pMethod), mpParent(pParent), mpProblem(NULL)
{
}// MethodPanelInfo

MethodPanelInfo::MethodPanelInfo(const MethodPanelInfo& from)
    : mType(from.mType),
      mpMethod(from.mpMethod),
      mpParent(from.mpParent),
      mpProblem(from.mpProblem)
{
}// MethodPanelInfo

MethodPanelInfo::~MethodPanelInfo()
{
}// ~MethodPanelInfo


//============================= OPERATORS ====================================

MethodPanelInfo&
MethodPanelInfo::operator=(const MethodPanelInfo& from)
{
    mType       = from.mType;
    mpMethod    = from.mpMethod;
    mpParent    = from.mpParent;
    mpProblem   = from.mpProblem;

    return *this;
}// =

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================

MethodPanelInfo::Type
MethodPanelInfo::PanelType() const
{
    return mType;
}// Type

Method*
MethodPanelInfo::pMethod() const
{
    return mpMethod;
}// Method

wxWindow*
MethodPanelInfo::pParent() const
{
    return mpParent;
}// Parent

const ProblemBase*
MethodPanelInfo::pProblem() const
{
    assert(mType == STANDALONE);
    return mpProblem;
}// Problem

//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
