/** Klasa zawierajca informacje o panelu, jaki ma zosta utworzony przez
 * fabryk.
 *
 * @see MethodPanelFactory
 */

#ifndef _MethodPanelInfo_h
#define _MethodPanelInfo_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../Method.h"
#include "../ProblemBase.h"

// FORWARD REFERENCES
//


class MethodPanelInfo
{
public:

    enum Type {
        STANDALONE,
        LINESEARCH
    };

// LIFECYCLE

    /** Konstruktor dla panelu metody "samodzielnej".
     */
    MethodPanelInfo(Method*             pMethod,
                    wxWindow*           pParent,
                    const ProblemBase*  pProblem);

    /** Konstruktor dla panelu metody "pomocniczej" w kierunku.
     */
    MethodPanelInfo(Method*             pMethod,
                    wxWindow*           pParent);

    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    MethodPanelInfo(const MethodPanelInfo& from);


    /** Destruktor.
     */
    ~MethodPanelInfo(void);


// OPERATORS

    /** Operator przypisania.
     *
     * @param from Przypisywana warto.
     *
     * @return Referencja do biecego obiektu.
     */
    MethodPanelInfo&                     operator=(const MethodPanelInfo& from);

// OPERATIONS
// ACCESS

    /** Zwraca typ.
     */
    Type                    PanelType() const;

    /** Zwraca wskanik na metod.
     */
    Method*                 pMethod() const;

    /** Zwraca wskanik na okno rodzica.
     */
    wxWindow*               pParent() const;

    /** Zwraca wskanik na problem.
     */
    const ProblemBase*      pProblem() const;

// INQUIRY

protected:
private:

    Type                mType;
    Method*             mpMethod;
    wxWindow*           mpParent;
    const ProblemBase*  mpProblem;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _MethodPanelInfo_h
