#include <precomp.h>

#include "MethodWithLineSearchPanel.h"
#include "../methods/DFP.h"
#include "../methods/FletcherReeves.h"
#include "../methods/HookeJeevesOptimal.h"
#include "../methods/NewtonModified.h"
#include "../methods/PolakRibiere.h"
#include "../methods/PowellVariant1.h"
#include "../methods/PowellVariant2.h"
#include "../methods/RosenbrockOptimal.h"
#include "../methods/SteepestDescent.h"


static void* RegisterPanels()
{
    MethodPanelFactory& factory = MethodPanelFactory::GetInstance();
/*
    factory.Register(DFP::ClassId(),
            MethodWithLineSearchPanel<DFP>::CreatePanel);

    factory.Register(FletcherReeves::ClassId(),
            MethodWithLineSearchPanel<FletcherReeves>::CreatePanel);
*/
    factory.Register(HookeJeevesOptimal::ClassId(),
            MethodWithLineSearchPanel<HookeJeevesOptimal>::CreatePanel);

    factory.Register(NewtonModified::ClassId(),
            MethodWithLineSearchPanel<NewtonModified>::CreatePanel);

    factory.Register(PolakRibiere::ClassId(),
            MethodWithLineSearchPanel<PolakRibiere>::CreatePanel);

    factory.Register(PowellVariant1::ClassId(),
            MethodWithLineSearchPanel<PowellVariant1>::CreatePanel);

    factory.Register(PowellVariant2::ClassId(),
            MethodWithLineSearchPanel<PowellVariant2>::CreatePanel);

    factory.Register(RosenbrockOptimal::ClassId(),
            MethodWithLineSearchPanel<RosenbrockOptimal>::CreatePanel);

    factory.Register(SteepestDescent::ClassId(),
            MethodWithLineSearchPanel<SteepestDescent>::CreatePanel);

    return NULL;
}

static const void* trigger_dummy = RegisterPanels();

