/** Warstwa wykresu rysujca przebieg optymalizacji metod Neldera-Meada.
 *
 * @see PlotControl
 */

#ifndef _NelderMeadLayer_h
#define _NelderMeadLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "PointControl.h"
#include "XyUnconstrainedLayer.h"

// FORWARD REFERENCES
//


class NelderMeadLayer
    : public XyUnconstrainedLayer
{
public:
// LIFECYCLE

    /** Konstruktor
     */
    NelderMeadLayer(const PlotControl&      plotControl,
                    const Result&           result,
                    CountedPtr<PlotLayer>   cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    NelderMeadLayer(const NelderMeadLayer& from);


    /** Destruktor.
     */
    ~NelderMeadLayer(void);


// OPERATORS

// OPERATIONS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

    /** Metoda fabryki.
     */
    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);
// ACCESS

// INQUIRY


protected:
private:

    virtual void            DrawIteration(wxDC&     dc,
                                  unsigned  iterationNumber,
                                  bool      highlight) const;

    const static void*  mRegistrationDummy;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _NelderMeadLayer_h
