// -*- C++ -*- generated by wxGlade 0.4 on Thu May 11 11:44:38 2006
#include <precomp.h>

#include "DoubleParameterValidator.h"
#include "MethodPanelFactory.h"
#include "NelderMeadPanel.h"


NelderMeadPanel::NelderMeadPanel(wxWindow* parent,
                                 int                    id,
                                 NelderMead*            pMethod,
                                 const ProblemBase&     problem,
                                 const                  wxPoint& pos,
                                 const                  wxSize& size,
                                 long                   style):
    wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL)
{
    // begin wxGlade: NelderMeadPanel::NelderMeadPanel
    mpStartingSimplexSizer_staticbox = new wxStaticBox(this, -1, _("Starting simplex"));
    mpReflectionLabel = new wxStaticText(this, -1, _("Reflection factor (r):"));
    mpReflectionTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpExpansionLabel = new wxStaticText(this, -1, _("Expansion factor (e):"));
    mpExpansionTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpContractionLabel = new wxStaticText(this, -1, _("Contraction factor (c):"));
    mpContractionTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpShrinkageLabel = new wxStaticText(this, -1, _("Shrinkage factor (s):"));
    mpShrinkageTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpStopCondition = new StopConditionControl(this, -1);
    mpSideLengthLabel = new wxStaticText(this, -1, _("Edge length:"));
    mpSideLengthTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpStartingCenter = new PointControl(this, -1, wxDefaultPosition, wxDefaultSize, 0, _("Center"));

    set_properties();
    do_layout();
    // end wxGlade

    // Inicjowanie listy warunkw stopu.
    mpStopCondition->SetList(pMethod->AllowedStopConditions());

    // Walidatory.
    mpReflectionTextCtrl->SetValidator(
            DoubleParameterValidator(pMethod->mReflectionCoefficient));
    mpExpansionTextCtrl->SetValidator(
            DoubleParameterValidator(pMethod->mExpansionCoefficient));
    mpContractionTextCtrl->SetValidator(
            DoubleParameterValidator(pMethod->mContractionCoefficient));
    mpShrinkageTextCtrl->SetValidator(
            DoubleParameterValidator(pMethod->mShrinkageCoefficient));

    mpStopCondition->SetValidator(StopConditionValidator(
                    reinterpret_cast<CountedPtr<const StopConditionBase>&>(
                        pMethod->mcpStopCondition)));

    mpSideLengthTextCtrl->SetValidator(
            DoubleParameterValidator(pMethod->mSideLength));

    // Punkt startowy.
    mpStartingCenter->Init(problem.Variables(),
                                        pMethod->mInitialStartingPoint);

}


void NelderMeadPanel::set_properties()
{
    // begin wxGlade: NelderMeadPanel::set_properties
    // end wxGlade
}


void NelderMeadPanel::do_layout()
{
    // begin wxGlade: NelderMeadPanel::do_layout
    wxBoxSizer* p_main_sizer = new wxBoxSizer(wxVERTICAL);
    wxStaticBoxSizer* mpStartingSimplexSizer = new wxStaticBoxSizer(mpStartingSimplexSizer_staticbox, wxVERTICAL);
    wxFlexGridSizer* p_start_grid_sizer = new wxFlexGridSizer(1, 2, 0, 0);
    wxFlexGridSizer* p_grid_sizer = new wxFlexGridSizer(4, 2, 0, 0);
    p_grid_sizer->Add(mpReflectionLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_grid_sizer->Add(mpReflectionTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_grid_sizer->Add(mpExpansionLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_grid_sizer->Add(mpExpansionTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_grid_sizer->Add(mpContractionLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_grid_sizer->Add(mpContractionTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_grid_sizer->Add(mpShrinkageLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_grid_sizer->Add(mpShrinkageTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_grid_sizer->AddGrowableCol(0);
    p_grid_sizer->AddGrowableCol(1);
    p_main_sizer->Add(p_grid_sizer, 0, wxEXPAND, 0);
    p_main_sizer->Add(mpStopCondition, 0, wxEXPAND, 0);
    p_start_grid_sizer->Add(mpSideLengthLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_start_grid_sizer->Add(mpSideLengthTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_start_grid_sizer->AddGrowableCol(0);
    p_start_grid_sizer->AddGrowableCol(1);
    mpStartingSimplexSizer->Add(p_start_grid_sizer, 0, wxEXPAND, 0);
    mpStartingSimplexSizer->Add(mpStartingCenter, 1, wxEXPAND, 0);
    p_main_sizer->Add(mpStartingSimplexSizer, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(p_main_sizer);
    p_main_sizer->Fit(this);
    p_main_sizer->SetSizeHints(this);
    // end wxGlade
}

/* static */ wxPanel*
NelderMeadPanel::CreatePanel(MethodPanelInfo   panelInfo)
{
    return new NelderMeadPanel(
            panelInfo.pParent(),
            -1,
            dynamic_cast<NelderMead*>(panelInfo.pMethod()),
            *panelInfo.pProblem());
}// CreatePanel

// Zarejestruj metod tworzc panel
const void* NelderMeadPanel::mpRegistrationDummy =
        MethodPanelFactory::GetInstance().Register(
                NelderMead::ClassId(),
                NelderMeadPanel::CreatePanel);

