/** Warstwa wykresu rysujca przebieg optymalizacji metod Newtona.
 *
 * @see PlotControl, NewtonIteration
 */

#ifndef _NewtonLayer_h
#define _NewtonLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "XyUnconstrainedLayer.h"

// FORWARD REFERENCES
//


class NewtonLayer
    : public XyUnconstrainedLayer
{
public:
// LIFECYCLE

    /** Konstruktor
     */
    NewtonLayer(const PlotControl&      plotControl,
                      const Result&           result,
                      CountedPtr<PlotLayer>   cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    NewtonLayer(const NewtonLayer& from);

    /** Destruktor.
     */
    ~NewtonLayer(void);


// OPERATORS

// OPERATIONS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

    /** Metoda fabryki.
     */
    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);
// ACCESS

// INQUIRY


protected:
private:
    virtual void            DrawIteration(wxDC&     dc,
                                  unsigned  iterationNumber,
                                  bool      highlight) const;

    const static void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _NewtonLayer_h
