#include <precomp.h>

#include "OnlyBestAction.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

OnlyBestAction::OnlyBestAction(
                        PlotControl*                pPlotControl,
                        EvolutionaryMethodLayer*    pEvolutionaryMethodLayer)
    : mpPlotControl(pPlotControl),
      mpEvolutionaryMethodLayer(pEvolutionaryMethodLayer)
{
}// OnlyBestAction

OnlyBestAction::OnlyBestAction(const OnlyBestAction& from)
    : mpPlotControl(from.mpPlotControl),
      mpEvolutionaryMethodLayer(from.mpEvolutionaryMethodLayer)
// ToggleToolAction nie ma adnych pl ani konstruktora kopiujcego.
{
}// OnlyBestAction

OnlyBestAction::~OnlyBestAction()
{
}// ~OnlyBestAction

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================

/* virtual */ bool
OnlyBestAction::Action(bool toggle)
{
    mpEvolutionaryMethodLayer->mDrawOnlyBest = toggle;
    mpPlotControl->RefreshPlot();

    return mpEvolutionaryMethodLayer->mDrawOnlyBest;
}// Action

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

/* virtual */ bool
OnlyBestAction::IsToggled() const
{
    return mpEvolutionaryMethodLayer->mDrawOnlyBest;
}// IsToggled

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
