/** Akcja narzdzia zmieniajcego tryb wywietlania przebiegu optymalizacji
 * metod ewolucyjn
 *
 * @see FullPlotVisualizer, PlotToolbar, ResultLayer
 */

#ifndef _OnlyBestAction_h
#define _OnlyBestAction_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "PlotControl.h"
#include "ToggleToolAction.h"
#include "EvolutionaryMethodLayer.h"

// FORWARD REFERENCES
//

class OnlyBestAction
    : public ToggleToolAction
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    OnlyBestAction(PlotControl*             pPlotControl,
                   EvolutionaryMethodLayer* pEvolutionaryMethodLayer);

    /** Konstruktor kopiujcy.
     */
    OnlyBestAction(const OnlyBestAction& from);

    /** Destruktor.
     */
    ~OnlyBestAction(void);

// OPERATORS
// OPERATIONS

    virtual bool    Action(bool toggle);

// ACCESS
// INQUIRY

    virtual bool    IsToggled() const;

protected:
private:

    PlotControl*                mpPlotControl;
    EvolutionaryMethodLayer*    mpEvolutionaryMethodLayer;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _OnlyBestAction_h
