#include <precomp.h>

#include "ParseErrorDialog.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

ParseErrorDialog::ParseErrorDialog(wxWindow*            pParent,
                                   wxWindowID           id,
                                   const ParseError&    error)
    // wxString, bo kompilator nie wiedzial, jak rzutowac.
    : wxDialog(pParent, id, wxString(_("Parse Error!")))
{
    mpTopLabel  = new wxStaticText(this, wxID_ANY,
            _("An error occured while parsing input:"));

    mpErrorLabel = CreateErrorLabel(this, error.ErrorMessage());
    mpInputErrorLabel = new ParseErrorText(this, wxID_ANY, error);

    wxSizer* p_main_sizer   = new wxBoxSizer(wxVERTICAL);


    p_main_sizer->Add(mpTopLabel, 0, wxEXPAND | wxALL, 2);
    p_main_sizer->Add(mpErrorLabel, 0, wxEXPAND | wxALL, 10);
    p_main_sizer->Add(mpInputErrorLabel, 0, wxALIGN_CENTER | wxALL, 2);

    p_main_sizer->Add(CreateButtonSizer(wxOK), 0, wxEXPAND | wxTOP, 7);

    SetSizer(p_main_sizer);
    p_main_sizer->SetSizeHints(this);
    Layout();
}// ParseErrorDialog


ParseErrorDialog::~ParseErrorDialog()
{
}// ~ParseErrorDialog


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

wxStaticText*
ParseErrorDialog::CreateErrorLabel(wxWindow*        pParent,
                                   const wxString&  message) const
{
    wxStaticText* p_static_text = new wxStaticText(pParent, wxID_ANY, message);

    p_static_text->Wrap(ParseErrorDialog::mMessageWrapWidth);

    return p_static_text;
}// CreateErrorLabel

const /* static */ unsigned ParseErrorDialog::mMessageWrapWidth = 250;
