#ifndef _PlotLayer_h
#define _PlotLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../Region.h"
#include "ToolbarTool.h"

// FORWARD REFERENCES
//
class PlotControl;

/** Warstwa wykresu.
 *
 * @see PlotControl
 */
class PlotLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     *
     * @param targetPlot Kontrolka wykresu, na ktrej bdzie rysowana ta
     * warstwa.
     */
    PlotLayer(const PlotControl& targetPlot);

    /** Konstruktor kopiujcy.
     */
    PlotLayer(const PlotLayer& from);

    /** Destruktor.
     */
    virtual ~PlotLayer(void);

// OPERATORS


// OPERATIONS

    /** Rysuje warstw.
     *
     * @param dc Kontekst graficzny, na ktrym bdzie rysowana warstwa.
     */
    virtual void    Draw(wxDC& dc) const = 0;

    /** Tworzy i zwraca nietypowe narzdzia dla danej warstwy.
     *
     * Moe przekaza narzdziu <code>this</code>.
     */
    virtual vector<ToolbarTool> CreateTools(PlotControl* pPlotControl);

// ACCESS

    /** Zwraca prostoktny obszar obejmujcy wszystkie "istotne" punkty warstwy.
     */
    virtual Region  BoundingBox() const;

// INQUIRY

protected:

    const PlotControl&  mTargetPlot;

private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _PlotLayer_h
