/** Kontrolka wywietlajca wsprzdne kursora myszy, gdy jest on nad obszarem
 * funkcji.
 *
 * @see PlotControl
 */

#ifndef _PlotStatus_h
#define _PlotStatus_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//

// FORWARD REFERENCES
//


class PlotStatus
    : public wxPanel
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    PlotStatus(wxWindow*      pParent,
               wxWindowID     id,
               bool           univariate,
               const wxPoint& position = wxDefaultPosition,
               const wxSize&  size = wxDefaultSize);


    /** Destruktor.
     */
    ~PlotStatus(void);


// OPERATORS
// OPERATIONS

    void        UpdatePosition(double value,
                               double argument1,
                               double argument2 = 0.0);

    void        UpdatePositionNoValue(double argument1,
                                      double argument2 = 0.0);

    void        ClearPosition();

    void        UpdateVariables(const wxString& variable1,
                                const wxString& variable2 = wxT(""));

    void        UpdateFormatStrings(double functionScale,
                                    double variable1Scale,
                                    double variable2Scale = 0.0);
// ACCESS
// INQUIRY

protected:
private:
    wxStaticText*   mpVariable1Label;
    wxStaticText*   mpVariable1Value;
    wxStaticText*   mpVariable2Label;
    wxStaticText*   mpVariable2Value;
    wxStaticText*   mpFunctionLabel;
    wxStaticText*   mpFunctionValue;

    wxString        mNumberFormat;

    bool            mUnivariate;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _PlotStatus_h
