/**  Kontrolka ustawiania wartoci punktu.
 *
 * Dla danego wektora wartoci oraz listy zmiennych wywietla zestaw etykiet
 * (nazw zmiennych) oraz pl wprowadzania wartoci liczbowych.
 */

#ifndef _PointControl_h
#define _PointControl_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../VariableNames.h"

// FORWARD REFERENCES
//


class PointControl
    : public wxPanel
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    PointControl(wxWindow*          pParent,
                 wxWindowID         id = -1,
                 const wxPoint&     pos = wxDefaultPosition,
                 const wxSize&      size = wxDefaultSize,
                 long               style = 0,
                 const wxString&    name = wxT("Point Control"));

    /** Destruktor.
     */
    ~PointControl(void);


// OPERATORS

// OPERATIONS

    /** Inicjuje kontrolk.
     *
     * Ustawia etykiety oraz kojarzy wektor wartoci z poszczeglnymi polami
     * tekstowymi.
     *
     * @param variables Zmienne, ktrych nazwy s etykietami poszczeglnych
     *  wartoci.
     * @param rValues Referencja na wektor, ktrego skadowe bd skojarzone z
     * polami tekstowymi i edytowane.
     * @param initialValue Pocztkowa warto wszystkich pl wektora.
     */
    void            Init(const VariableNames&   variables,
                         ColumnVector&          rValues,
                         double                 initialValue=0);

// ACCESS
    /** Ustawia nazw kontrolki.
     */
    void            SetCaption(const wxString& caption);

// INQUIRY

protected:

    /** Dodaje wiersz.
     */
    void            AddRow(const wxString& label, double& rValue);

    /** Czyci kontrolk.
     */
    void            Clear();


private:
    wxScrolledWindow*   mpScrolledPanel;
    wxStaticBoxSizer*   mpMainSizer;
    wxFlexGridSizer*    mpGridSizer;

    const static int mMinHeight;    ///< Minimalna wysoko kontrolki
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _PointControl_h
