/** Warstwa wykresu rysujca przebieg optymalizacji obu wariantw
 * metody Powella.
 *
 * @see PlotControl
 */

#ifndef _PowellLayer_h
#define _PowellLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "PointControl.h"
#include "XyUnconstrainedLayer.h"

// FORWARD REFERENCES
//


class PowellLayer
    : public XyUnconstrainedLayer
{
public:
// LIFECYCLE

    /** Konstruktor
     */
    PowellLayer(const PlotControl&      plotControl,
                const Result&           result,
                CountedPtr<PlotLayer>   cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    PowellLayer(const PowellLayer& from);


    /** Destruktor.
     */
    ~PowellLayer(void);


// OPERATORS

// OPERATIONS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

    /** Metoda fabryki.
     */
    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);
// ACCESS

// INQUIRY


protected:
private:
    void            DrawPreliminaryIteration(wxDC&      dc,
                                             bool       highlight) const;

    virtual void    DrawIteration(wxDC&     dc,
                                  unsigned  iterationNumber,
                                  bool      highlight) const;

    const static void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _PowellLayer_h
