/** wxValidator dla panelu ustawie problemu <code>ProblemWithPenalty</code>
 *
 * @see wxValidator
 */

#ifndef _ProblemWithPenaltyValidator_h
#define _ProblemWithPenaltyValidator_h

// SYSTEM INCLUDES
//
#include <memory>

// PROJECT INCLUDES
//
#include <wx/object.h>
#include <wx/validate.h>

// LOCAL INCLUDES
//
#include "../ProblemBase.h"

// FORWARD REFERENCES
//

class ProblemWithPenaltyValidator
    : public wxValidator
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    ProblemWithPenaltyValidator(ProblemBase* pProblem);


    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    ProblemWithPenaltyValidator(const ProblemWithPenaltyValidator& from);


    /** Destruktor.
     */
    ~ProblemWithPenaltyValidator(void);


// OPERATORS

// OPERATIONS


    /** Tworzy kopi obiektu.
     */
    virtual wxObject*       Clone() const;

    /** Sprawdza poprawno danych w panelu.
     */
    virtual bool            Validate(wxWindow* parent);

    /** Wstawia dane z panelu do kontrolek.
     */
    virtual bool            TransferToWindow();

    /** Ustawia dane problemu wg wprowadzonych do kontrolek panelu.
     */
    virtual bool            TransferFromWindow();

// ACCESS
// INQUIRY

protected:
private:
    /** Wskaznik na problem, ktorego opcje sa ustawiane przez panel
     */
    ProblemWithPenalty* mpProblem;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _ProblemWithPenaltyValidator_h
