// -*- C++ -*- generated by wxGlade 0.4 on Wed Mar  8 17:40:56 2006

#include <precomp.h>

#include "../Eduoptim2.h"
#include "../Logger.h"
#include "../Method.h"

#include "ProgressDialog.h"

LOGGER(DEBUG);

BEGIN_EVENT_TABLE(ProgressDialog, wxDialog)
    EVT_BUTTON      (ID_BUTTON_ABORT, ProgressDialog::OnAbort)
END_EVENT_TABLE()

DECLARE_APP(Eduoptim2)

ProgressDialog::ProgressDialog(wxWindow*        parent,
                               int              id,
                               const wxString&  title,
                               const wxPoint&   pos,
                               const wxSize&    size,
                               long             style)
    : wxDialog(parent, id, title, pos, size, wxDEFAULT_DIALOG_STYLE),
      Observer(),
      mRotorState(0),
      mPreviousTime(wxGetLocalTimeMillis()),
      mAbortPressed(false)
{
    // begin wxGlade: ProgressDialog::ProgressDialog
    mpMainLabel = new wxStaticText(this, -1, _("Please wait..."), wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE);
    mpRotor = new wxStaticText(this, -1, _("/"));
    mpAbortButton = new wxButton(this, ID_BUTTON_ABORT, _("Abort"));

    set_properties();
    do_layout();
    // end wxGlade
}

void ProgressDialog::set_properties()
{
    // begin wxGlade: ProgressDialog::set_properties
    SetTitle(_("In progress..."));
    // end wxGlade
}

void ProgressDialog::do_layout()
{
    // begin wxGlade: ProgressDialog::do_layout
    wxBoxSizer* sizer_11 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_13 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_14 = new wxBoxSizer(wxHORIZONTAL);
    sizer_14->Add(mpMainLabel, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 10);
    sizer_14->Add(mpRotor, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 10);
    sizer_11->Add(sizer_14, 1, wxEXPAND, 0);
    sizer_13->Add(mpAbortButton, 0, wxALL|wxADJUST_MINSIZE, 2);
    sizer_11->Add(sizer_13, 0, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_11);
    sizer_11->Fit(this);
    sizer_11->SetSizeHints(this);
    Layout();
    // end wxGlade
}

/* virtual */ void
ProgressDialog::Update()
{
    RefreshAndYield();
}// Update

void
ProgressDialog::RefreshAndYield()
{
    const long interval = 250;

    wxLongLong now = wxGetLocalTimeMillis();

    if ((now - mPreviousTime).ToLong() > interval)
    {
        mPreviousTime = now;

        // TODO: rysuj animacj...
        static wxChar rotor[] = { wxT('|'), wxT('/'), wxT('-'), wxT('\\') };

        if (mRotorState < 3)    ++mRotorState;
        else                    mRotorState = 0;

        mpRotor->SetLabel(rotor[mRotorState]);
        // TODO: ...zamiast tego.

        wxGetApp().Yield();
    }
}// RefreshAndYield

void
ProgressDialog::OnAbort(wxCommandEvent& event)
{
    LOG(DEBUG, wxT("Abort pressed!"));
    mAbortPressed = true;

    // TODO: To musi si da bez rzutowania
    set<const Observable*>::const_iterator i;
    for (i = mObservables.begin(); i != mObservables.end(); ++i)
    {
        const Method* p_method = static_cast<const Method*>(*i);

        assert(p_method != NULL);
        p_method->Abort();
    }
}// OnAbort

bool
ProgressDialog::IsAborted() const
{
    return mAbortPressed;
}// IsAborted
