#ifndef _PwpAdvancedDialog_H
#define _PwpAdvancedDialog_H

#include "../ProblemWithPenalty.h"

class PwpAdvancedDialog
    : public wxDialog
{
public:

    PwpAdvancedDialog(wxWindow*             parent,
                      int                   id,
                      ProblemWithPenalty*   pProblem,
                      const wxString&       title,
                      const wxPoint&        pos = wxDefaultPosition,
                      const wxSize&         size = wxDefaultSize,
                      long                  style = wxDEFAULT_DIALOG_STYLE);

private:

    void set_properties();
    void do_layout();

protected:

    ProblemWithPenaltyPanel*    mpParent;
    ProblemWithPenalty*         mpProblem;

    wxTextCtrl*                 mpEpsilonCtrl;
    wxCheckBox*                 mpReuseSpBox;
    wxRadioBox*                 mpReactionRadio;
    wxButton*                   mpOkButton;
    wxButton*                   mpCancelButton;
};

#endif // PwpAdvancedDialog_h
