/** Warstwa wykresu rysujca iteracj metody aproksymacji kwadratowej.
 *
 * @see QuadraticApproximation, QuadraticApproximationIteration
 */

#ifndef _QuadraticApproximationLayer_h
#define _QuadraticApproximationLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "UnivariateResultLayer.h"

// FORWARD REFERENCES
//


class QuadraticApproximationLayer
    : public UnivariateResultLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    QuadraticApproximationLayer(const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    QuadraticApproximationLayer(const QuadraticApproximationLayer& from);


    /** Destruktor.
     */
    ~QuadraticApproximationLayer(void);


// OPERATORS

// OPERATIONS

    virtual void    Draw(wxDC& dc) const;

    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);

// ACCESS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

// INQUIRY

protected:

    void            DrawIteration(wxDC&             dc,
                                  unsigned          iterationNumber,
                                  bool              highlight) const;


    void            DrawActiveIterationBackground(wxDC& dc) const;
private:

    static const void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _QuadraticApproximationLayer_h
