/** Kontrolka ustawiania wartoci ograniczonego obszaru.
 *
 * Dla dwch wektorw wartoci: ogranicze dolnych i grnych oraz listy
 * zmiennych wywietla zestaw etykiet
 * (nazw zmiennych) oraz pl wprowadzania wartoci liczbowych.
 */

#ifndef _RangeControl_h
#define _RangeControl_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../VariableNames.h"

// FORWARD REFERENCES
//


class RangeControl
    : public wxPanel
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    RangeControl(wxWindow*          pParent,
                 wxWindowID         id = -1,
                 const wxPoint&     pos = wxDefaultPosition,
                 const wxSize&      size = wxDefaultSize,
                 long               style = 0,
                 const wxString&    name = wxT("Point Control"));

    /** Destruktor.
     */
    ~RangeControl(void);


// OPERATORS

// OPERATIONS

    /** Inicjuje kontrolk.
     *
     * Ustawia etykiety oraz kojarzy wektor wartoci z poszczeglnymi polami
     * tekstowymi.
     *
     * @param variables Zmienne, ktrych nazwy s etykietami poszczeglnych
     *  wartoci.
     * // TODO: komentarz
     * @param initialValue Pocztkowa warto wszystkich pl wektora.
     */
    void            Init(const VariableNames&   variables,
                         ColumnVector&          rMinBounds,
                         ColumnVector&          rMaxBounds,
                         double                 initialMinValue = -10.0,
                         double                 initialMaxValue = 10.0);

// ACCESS

    /** Ustawia nazw kontrolki.
     */
    void            SetCaption(const wxString& caption);

// INQUIRY

protected:

    /** Dodaje wiersz.
     */
    void            AddRow(const wxString&  label,
                                 double&    rMinBound,
                                 double&    rMaxBound);

    /** Czyci kontrolk.
     */
    void            Clear();


private:

    wxScrolledWindow*   mpScrolledPanel;
    wxStaticBoxSizer*   mpMainSizer;
    wxFlexGridSizer*    mpGridSizer;

    const static int mMinHeight;    ///< Minimalna wysoko kontrolki
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _RangeControl_h
