/** Warstwa wykresu rysujca przebieg optymalizacji algorytmem Rosenbrocka
 * z dyskretnym krokiem prbnym.
 *
 * @see PlotControl
 */

#ifndef _RosenbrockDiscreteLayer_h
#define _RosenbrockDiscreteLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "PointControl.h"
#include "XyUnconstrainedLayer.h"

// FORWARD REFERENCES
//


class RosenbrockDiscreteLayer
    : public XyUnconstrainedLayer
{
public:
// LIFECYCLE

    /** Konstruktor
     */
    RosenbrockDiscreteLayer(const PlotControl&      plotControl,
                            const Result&           result,
                            CountedPtr<PlotLayer>   cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    RosenbrockDiscreteLayer(const RosenbrockDiscreteLayer& from);

    /** Destruktor.
     */
    ~RosenbrockDiscreteLayer(void);


// OPERATORS

// OPERATIONS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

    /** Metoda fabryki.
     */
    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);
// ACCESS

// INQUIRY


protected:
private:
    virtual void            DrawIteration(wxDC&     dc,
                                          unsigned  iterationNumber,
                                          bool      highlight) const;

    const static void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _RosenbrockDiscreteLayer_h
