// -*- C++ -*- generated by wxGlade 0.4 on Sat Mar 25 14:10:59 2006
#include <precomp.h>

#include "../Symbols.h"
#include "../text-util.h"

#include "DoubleParameterValidator.h"
#include "MethodPanelFactory.h"
#include "RosenbrockDiscretePanel.h"

RosenbrockDiscretePanel::RosenbrockDiscretePanel(
                            wxWindow*           parent,
                            int                 id,
                            RosenbrockDiscrete* pMethod,
                            const ProblemBase&  problem,
                            const               wxPoint& pos,
                            const               wxSize& size,
                            long                style):
    wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL)
{
    // begin wxGlade: RosenbrockDiscretePanel::RosenbrockDiscretePanel
    mpAlphaLabel = new wxStaticText(this, -1, _("[Label set explicitly in ui/RosenbrockDiscretePanel::set_properties().]"));
    mpAlphaTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpBetaLabel = new wxStaticText(this, -1, _("[Label set explicitly in ui/RosenbrockDiscretePanel::set_properties().]"));
    mpBetaTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpDeltaLabel = new wxStaticText(this, -1, _("[Label set explicitly in ui/RosenbrockDiscretePanel::set_properties().]"));
    mpDeltaTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);
    mpInitialStepLength = new PointControl(this, -1, wxDefaultPosition, wxDefaultSize, 0, _("Initial step length in directions") + LabelSymbol(Symbols::GetInstance()[Symbols::TAU]));
    mpStopCondition = new StopConditionControl(this, -1);
    mpStartingPoint = new PointControl(this, -1, wxDefaultPosition, wxDefaultSize, 0, _("Starting point"));

    set_properties();
    do_layout();
    // end wxGlade

    // Inicjowanie listy warunkw stopu
    mpStopCondition->SetList(pMethod->AllowedStopConditions());

    // Walidatory
    mpAlphaTextCtrl->SetValidator(DoubleParameterValidator(pMethod->mAlpha));
    mpBetaTextCtrl->SetValidator(DoubleParameterValidator(pMethod->mBeta));
    mpDeltaTextCtrl->SetValidator(DoubleParameterValidator(pMethod->mDelta));
    mpStopCondition->SetValidator(StopConditionValidator(
                    reinterpret_cast<CountedPtr<const StopConditionBase>&>(
                        pMethod->mcpStopCondition)));

    // Punkt startowy
    mpInitialStepLength->Init(problem.Variables(), pMethod->mTau, 0.1);
    mpStartingPoint->Init(problem.Variables(),
            /*pMethod->mStartingPoint*/pMethod->mInitialStartingPoint);

}


void RosenbrockDiscretePanel::set_properties()
{
    // begin wxGlade: RosenbrockDiscretePanel::set_properties
    // end wxGlade

    // Etykiety z greckimi literami.
    const Symbols& symbols = Symbols::GetInstance();
    const wxString& alpha_label_text    = _("Expansion factor")
	   + LabelSymbol(symbols[Symbols::ALPHA]);
    const wxString& beta_label_text     = _("Contraction factor")
	   + LabelSymbol(symbols[Symbols::BETA]);
    const wxString& delta_label_text    =
           _("Minimal step length in single direction")
           + LabelSymbol(symbols[Symbols::DELTA]);


    mpAlphaLabel->SetLabel(alpha_label_text);
    mpBetaLabel->SetLabel(beta_label_text);
    mpDeltaLabel->SetLabel(delta_label_text);
    // mpInitialStepLength->SetCaption(tau_box_text);
}


void RosenbrockDiscretePanel::do_layout()
{
    // begin wxGlade: RosenbrockDiscretePanel::do_layout
    wxBoxSizer* sizer_19 = new wxBoxSizer(wxVERTICAL);
    wxFlexGridSizer* grid_sizer_5 = new wxFlexGridSizer(3, 2, 0, 0);
    grid_sizer_5->Add(mpAlphaLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_5->Add(mpAlphaTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_5->Add(mpBetaLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_5->Add(mpBetaTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_5->Add(mpDeltaLabel, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_5->Add(mpDeltaTextCtrl, 0, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    grid_sizer_5->AddGrowableCol(0);
    grid_sizer_5->AddGrowableCol(1);
    sizer_19->Add(grid_sizer_5, 0, wxEXPAND, 0);
    sizer_19->Add(mpInitialStepLength, 1, wxEXPAND, 0);
    sizer_19->Add(mpStopCondition, 1, wxEXPAND, 0);
    sizer_19->Add(mpStartingPoint, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_19);
    sizer_19->Fit(this);
    sizer_19->SetSizeHints(this);
    // end wxGlade
}

/* static */ wxPanel*
RosenbrockDiscretePanel::CreatePanel(MethodPanelInfo   panelInfo)
{
    return new RosenbrockDiscretePanel(
            panelInfo.pParent(),
            -1,
            dynamic_cast<RosenbrockDiscrete*>(panelInfo.pMethod()),
            *panelInfo.pProblem());
}// CreatePanel


// Zarejestruj metod tworzc panel
const void* RosenbrockDiscretePanel::mpRegistrationDummy =
        MethodPanelFactory::GetInstance().Register(
                RosenbrockDiscrete::ClassId(),
                RosenbrockDiscretePanel::CreatePanel);

