/** Warstwa wykresu rysujca przebieg optymalizacji algorytmem Rosenbrocka
 * z optymalnym krokiem prbnym.
 *
 * @see PlotControl
 */

#ifndef _RosenbrockOptimalLayer_h
#define _RosenbrockOptimalLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "PointControl.h"
#include "XyUnconstrainedLayer.h"

// FORWARD REFERENCES
//


class RosenbrockOptimalLayer
    : public XyUnconstrainedLayer
{
public:
// LIFECYCLE

    /** Konstruktor
     */
    RosenbrockOptimalLayer(const PlotControl&       plotControl,
                           const Result&            result,
                           CountedPtr<PlotLayer>    cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    RosenbrockOptimalLayer(const RosenbrockOptimalLayer& from);


    /** Destruktor.
     */
    ~RosenbrockOptimalLayer(void);


// OPERATORS

// OPERATIONS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

    /** Metoda fabryki.
     */
    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);
// ACCESS

// INQUIRY


protected:
private:
    virtual void            DrawIteration(wxDC&     dc,
                                          unsigned  iterationNumber,
                                          bool      highlight) const;

    const static void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _RosenbrockOptimalLayer_h
