/** Warstwa wykresu rysujca iteracj metody podziau dychotomicznego.
 *
 * @see SecantDivision, SecantDivisionIteration
 */

#ifndef _SecantDivisionLayer_h
#define _SecantDivisionLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "UnivariateResultLayer.h"

// FORWARD REFERENCES
//

class FunctionBase;

class SecantDivisionLayer
    : public UnivariateResultLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    SecantDivisionLayer(const PlotControl&         plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    SecantDivisionLayer(const SecantDivisionLayer& from);


    /** Destruktor.
     */
    ~SecantDivisionLayer(void);


// OPERATORS

// OPERATIONS

    virtual void    Draw(wxDC& dc) const;

    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);

// ACCESS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

// INQUIRY

protected:

    void            DrawIteration(wxDC&             dc,
                                  unsigned          iterationNumber,
                                  bool              highlight) const;

    void            DrawActiveIterationBackground(wxDC& dc) const;

private:

    static const void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _SecantDivisionLayer_h
