#include <precomp.h>

#include "SectionLineSearchPanel.h"

#include "MethodPanelFactory.h"
#include "../methods/BolzanoDivision.h"
#include "../methods/DichotomousDivision.h"
#include "../methods/FibonacciDivision.h"
#include "../methods/QuadraticApproximation.h"
#include "../methods/SecantDivision.h"

static void* RegisterPanels()
{
    MethodPanelFactory& factory = MethodPanelFactory::GetInstance();

    factory.Register(BolzanoDivision::ClassId(),
            SectionLineSearchPanel<BolzanoDivision>::CreatePanel);

    factory.Register(DichotomousDivision::ClassId(),
            SectionLineSearchPanel<DichotomousDivision>::CreatePanel);

    factory.Register(FibonacciDivision::ClassId(),
            SectionLineSearchPanel<FibonacciDivision>::CreatePanel);

    factory.Register(QuadraticApproximation::ClassId(),
            SectionLineSearchPanel<QuadraticApproximation>::CreatePanel);

    factory.Register(SecantDivision::ClassId(),
            SectionLineSearchPanel<SecantDivision>::CreatePanel);

    return NULL;
}

static const void* trigger_dummy = RegisterPanels();

