/** Warstwa wykresu rysujca przebieg optymalizacji metody simplex.
 *
 * @see PlotControl, Simplex
 */

#ifndef _SimplexLayer_h
#define _SimplexLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "XyConstraintsLayer.h"
#include "XyResultLayer.h"

// FORWARD REFERENCES
//


class SimplexLayer
    : public XyResultLayer
{
public:
// LIFECYCLE

    /** Konstruktor
     */
    SimplexLayer(
            const PlotControl&                          plotControl,
            const Result&                               result,
            CountedPtr<PlotLayer>                 cpFunctionLayer,
            std::auto_ptr<XyConstraintsLayer>           apConstraintsLayer);

    /** Konstruktor kopiujcy.
     */
    SimplexLayer(const SimplexLayer& from);

    /** Destruktor.
     */
    ~SimplexLayer(void);

// OPERATORS
// OPERATIONS

    virtual void    Draw(wxDC& dc) const;

    virtual vector<ToolbarTool> CreateTools(PlotControl* pPlotControl);

    /** Metoda fabryki.
     */
    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl& plotControl,
                                const Result&      result,
                                CountedPtr<PlotLayer> cpFunctionLayer);

// ACCESS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

// INQUIRY

protected:
private:

    void            DrawIteration(wxDC&     dc,
                                  unsigned  iterationNumber,
                                  bool      highlight) const;

    CountedPtr<XyConstraintsLayer>          mcpConstraintsLayer;

    const static void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _SimplexLayer_h
