#include <precomp.h>

#include "../Logger.h"
#include "StopConditionValidator.h"  // class implemented

LOGGER(INFO);

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

StopConditionValidator::StopConditionValidator(
        CountedPtr<const StopConditionBase>& rcpStopCondition)
    : mrcpStopCondition(rcpStopCondition)
{
}// StopConditionValidator

StopConditionValidator::StopConditionValidator(const StopConditionValidator& from)
    : mrcpStopCondition(from.mrcpStopCondition)
{
}// StopConditionValidator

StopConditionValidator::~StopConditionValidator()
{
}// ~StopConditionValidator


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

/* virtual */ wxObject*
StopConditionValidator::Clone() const
{
    return new StopConditionValidator(*this);
}// Clone

/* virtual */ bool
StopConditionValidator::TransferToWindow()
{
    LOG(DEBUG, wxT("TransferToWindow"));
    if (mrcpStopCondition.Get() != NULL)
    {
        StopConditionControl *p_control
            = dynamic_cast<StopConditionControl*>(GetWindow());

        int pos = p_control->SelectName(mrcpStopCondition->Name());

        assert(pos != wxNOT_FOUND);

        p_control->rEpsilon() = mrcpStopCondition->Epsilon();
    }

    return true;
}// TransferToWindow

/* virtual */ bool
StopConditionValidator::TransferFromWindow()
{
    LOG(DEBUG, wxT("TransferFromWindow"));

    StopConditionControl *p_control
        = dynamic_cast<StopConditionControl*>(GetWindow());

    // TODO: usun Reset i release, przywrci przypisanie (jak bd typy
    // gray).
    //mrcpStopCondition = p_control->CreateSelected();
    mrcpStopCondition.Reset(p_control->CreateSelected().release());

    return true;
}// TransferFromWindow

/* virtual */ bool
StopConditionValidator::Validate(wxWindow* pParent)
{
    LOG(DEBUG, wxT("Validate"));
    return GetWindow()->Validate();
}// Validate


//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
