/**  wxValidator dla wartoci kontrolki ustawiania warunku stopu.
 *
 * @see wxValidator
 */

#ifndef _StopConditionValidator_h
#define _StopConditionValidator_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../CountedPtr.h"
#include "StopConditionControl.h"

// FORWARD REFERENCES
//


class StopConditionValidator
    : public wxValidator
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    StopConditionValidator(CountedPtr<const StopConditionBase>& rcpStopCondition);

    /** Konstruktor kopiujcy.
     *
     * @param from Obiekt, ktrego warto jest kopiowana.
     */
    StopConditionValidator(const StopConditionValidator& from);

    /** Destruktor.
     */
    ~StopConditionValidator(void);


// OPERATORS

// OPERATIONS

    /** Tworzy kopi obiektu.
     */
    virtual wxObject*       Clone() const;

    /** Wprowadza dane do kontrolki.
     */
    virtual bool            TransferToWindow();

    /** Wyciga dane z kontrolki.
     */
    virtual bool            TransferFromWindow();

    /** Sprawdza poprawno danych w kontrolce.
     */
    virtual bool            Validate(wxWindow* pParent);

// ACCESS
// INQUIRY

protected:
private:
    /// Referencja na <code>CountedPtr</code> na warunek stopu.
    CountedPtr<const StopConditionBase>&    mrcpStopCondition;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _StopConditionValidator_h
