#include <precomp.h>

#include "SubsequentIterationsAction.h"  // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

SubsequentIterationsAction::SubsequentIterationsAction(
        PlotControl*            pPlotControl,
        XyUnconstrainedLayer*   pResultLayer)
    : mpPlotControl(pPlotControl),
      mpResultLayer(pResultLayer)
{
}// SubsequentIterationsAction

SubsequentIterationsAction::SubsequentIterationsAction(
        const SubsequentIterationsAction& from)
    : mpPlotControl(from.mpPlotControl),
      mpResultLayer(from.mpResultLayer)
// ToggleToolAction nie ma adnych pl ani konstruktora kopiujcego.
{
}// SubsequentIterationsAction

SubsequentIterationsAction::~SubsequentIterationsAction()
{
}// ~SubsequentIterationsAction

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================

/* virtual */ bool
SubsequentIterationsAction::Action(bool toggle)
{
    mpResultLayer->SetDrawSubsequentIterations(toggle);
    mpPlotControl->RefreshPlot();

    return mpResultLayer->DrawsSubsequentIterations();
}// Action

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

/* virtual */ bool
SubsequentIterationsAction::IsToggled() const
{
    return mpResultLayer->DrawsSubsequentIterations();
}// IsToggled

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////
