/** Akcja narzdzia "Rysuj kolejne iteracje".
 *
 * @see FullPlotVisualizer, PlotToolbar, XyUnconstrainedLayer
 */

#ifndef _SubsequentIterationsAction_h
#define _SubsequentIterationsAction_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "PlotControl.h"
#include "ToggleToolAction.h"
#include "XyUnconstrainedLayer.h"

// FORWARD REFERENCES
//

class SubsequentIterationsAction
    : public ToggleToolAction
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    SubsequentIterationsAction(PlotControl*             pPlotControl,
                               XyUnconstrainedLayer*    pResultLayer);

    /** Konstruktor kopiujcy.
     */
    SubsequentIterationsAction(const SubsequentIterationsAction& from);

    /** Destruktor.
     */
    ~SubsequentIterationsAction(void);


// OPERATORS
// OPERATIONS

    virtual bool    Action(bool toggle);

// ACCESS
// INQUIRY

    virtual bool    IsToggled() const;

protected:
private:
    PlotControl*            mpPlotControl;
    XyUnconstrainedLayer*   mpResultLayer;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _SubsequentIterationsAction_h
