/** Klasa bazowa dla wizualizatorw tekstowych iteracji optymalizacji z
 * ograniczeniami.
 *
 * @see IterationData, ProblemWithPenalty
 */

#ifndef _TivConstrainedOptimization_h
#define _TivConstrainedOptimization_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "TextIterationVisualizer.h"

// FORWARD REFERENCES
//


class TivConstrainedOptimization
    : public TextIterationVisualizer
{
public:

// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivConstrainedOptimization(void);

    /** Destruktor.
     */
    ~TivConstrainedOptimization(void);


// OPERATORS
//

// OPERATIONS
//
    virtual void    Print(wxTextCtrl*           pTargetCtrl,
                          const IterationData&  iteration,
                          const FunctionBase&   function,
                          bool                  highlight) const;

// ACCESS
// INQUIRY

protected:

    virtual wxString    PrintNewApproximation
                                (      wxTextCtrl*      pTargetCtrl,
                                 const IterationData&   iteration,
                                 const FunctionBase&    function,
                                 bool                   highlight) const = 0;

private:

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivConstrainedOptimization_h
