/** Klasa wizualizacji tekstowej optymalizacji metod ewolucyjn
 *
 * @see IterationData, EvolutionaryMethod
 */

#ifndef _TivEvolutionaryMethod_h
#define _TivEvolutionaryMethod_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../methods/EvolutionaryMethodIteration.h"

#include "TextIterationVisualizer.h"

// FORWARD REFERENCES
//


class TivEvolutionaryMethod
    : public TextIterationVisualizer
{
public:

// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivEvolutionaryMethod(void);

    /** Destruktor.
     */
    ~TivEvolutionaryMethod(void);


// OPERATORS
//

// OPERATIONS
//
    virtual void    Print(
                        wxTextCtrl*           pTargetCtrl,
                        const IterationData&  iteration,
                        const FunctionBase&   function,
                        bool                  highlight) const;

    static std::auto_ptr<const TextIterationVisualizer>    Create();

// ACCESS
// INQUIRY

protected:

    /**
     */
    wxString PrintStartingStatistics
                (      wxTextCtrl*                      pTargetCtrl,
                 const EvolutionaryMethodIteration&     iteration,
                 const FunctionBase&                    function,
                       bool                             highlight) const;

    /**
     */
    wxString PrintChromosomeCounts
                (      wxTextCtrl*                      pTargetCtrl,
                 const EvolutionaryMethodIteration&     iteration,
                 const FunctionBase&                    function,
                       bool                             highlight) const;

    /**
     */
    wxString PrintEndStatistics
                (      wxTextCtrl*                      pTargetCtrl,
                 const EvolutionaryMethodIteration&     iteration,
                 const FunctionBase&                    function,
                       bool                             highlight) const;

private:

    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivEvolutionaryMethod_h
