/** Wizualizator tekstowy dla iteracji algorytmu Hooke'a Jeevesa.
 *
 * @see IterationData, HookeJeeves
 */

#ifndef _TivHookeJeeves_h
#define _TivHookeJeeves_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../methods/HookeJeevesIteration.h"
#include "TextIterationVisualizer.h"

// FORWARD REFERENCES
//


class TivHookeJeeves
    : public TextIterationVisualizer
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivHookeJeeves(void);

    /** Destruktor.
     */
    ~TivHookeJeeves(void);


// OPERATORS

// OPERATIONS

    virtual void        Print(wxTextCtrl*           pTargetCtrl,
                              const IterationData&  iterationData,
                              const FunctionBase&   function,
                              bool                  highlight) const;

// ACCESS
// INQUIRY

protected:

    void        PrintTrialSteps(wxTextCtrl*                 pTargetCtrl,
                                const HookeJeevesIteration& iteration,
                                const FunctionBase&         function,
                                bool                        highlight) const;

    virtual wxString PrintTrialStep(const HookeJeevesIteration::TrialPoint& step,
                                    const FunctionBase& function) const = 0;

    virtual void     StepVector(
                            wxTextCtrl*                  pTargetCtrl,
                            wxString&                    rText,
                            const HookeJeevesIteration&  iteration,
                            bool                         highlight) const = 0;

    virtual wxString PrintTauContraction(
                        const HookeJeevesIteration& iteration) const = 0;

private:
    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivHookeJeeves_h
