#include <precomp.h>

#include "../methods/HookeJeevesOptimalIteration.h"
#include "../text-util.h"

#include "TivHookeJeevesOptimal.h"  // class implemented
#include "VisualizerFactory.h"

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

TivHookeJeevesOptimal::TivHookeJeevesOptimal()
{
}// TivHookeJeevesOptimal

TivHookeJeevesOptimal::~TivHookeJeevesOptimal()
{
}// ~TivHookeJeevesOptimal


//============================= OPERATORS ====================================

//============================= OPERATIONS ===================================

/* static */ std::auto_ptr<const TextIterationVisualizer>
TivHookeJeevesOptimal::Create()
{
    return auto_ptr<const TextIterationVisualizer>(new TivHookeJeevesOptimal);
}// Create

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/* virtual */ wxString
TivHookeJeevesOptimal::PrintTrialStep(
        const HookeJeevesIteration::TrialPoint& step,
        const FunctionBase&                     function) const
{
    wxString text;

    text  = wxT("  ");
    text << PrintPointWithValue(step.mPoint, function) << wxT('\n');

    return text;
}// PrintTrialStep

/* virtual */ void
TivHookeJeevesOptimal::StepVector(wxTextCtrl*                  pTargetCtrl,
                                   wxString&                    rText,
                                   const HookeJeevesIteration&  iteration,
                                   bool                         highlight) const
{
}// StepVector

/* virtual */ wxString
TivHookeJeevesOptimal::PrintTauContraction(
        const HookeJeevesIteration& iteration) const
{
    return wxString(wxT(""));
}// PrintTauContraction

/////////////////////////////// PRIVATE    ///////////////////////////////////

/* static */ void* TivHookeJeevesOptimal::mpRegistrationDummy =
    VisualizerFactory::RegisterTextVisualizer(
            HookeJeevesOptimalIteration::ClassId(),
            TivHookeJeevesOptimal::Create);
