/** Wizualizator tekstowy dla iteracji algorytmu HookeJeevesOptimal.
 *
 * @see IterationData, HookeJeevesOptimal
 */

#ifndef _TivHookeJeevesOptimal_h
#define _TivHookeJeevesOptimal_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "TivHookeJeeves.h"

// FORWARD REFERENCES
//


class TivHookeJeevesOptimal
    : public TivHookeJeeves
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivHookeJeevesOptimal(void);

    /** Destruktor.
     */
    ~TivHookeJeevesOptimal(void);


// OPERATORS

// OPERATIONS

    static std::auto_ptr<const TextIterationVisualizer>    Create();

// ACCESS
// INQUIRY

protected:

    virtual wxString PrintTrialStep(const HookeJeevesIteration::TrialPoint& step,
                                    const FunctionBase& function) const;

    virtual void     StepVector(wxTextCtrl*                  pTargetCtrl,
                                wxString&                    rText,
                                const HookeJeevesIteration&  iteration,
                                bool                         highlight) const;

    virtual wxString PrintTauContraction(
                               const HookeJeevesIteration& iteration) const;

private:
    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivHookeJeevesOptimal_h
