/** Klasa wizualizatora tekstowego dla iteracji metody Marquardta.
 *
 * @see IterationData, Marquardt
 */

#ifndef _TivMarquardt_h
#define _TivMarquardt_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../methods/MarquardtIteration.h"
#include "TextIterationVisualizer.h"

// FORWARD REFERENCES
//


class TivMarquardt
    : public TextIterationVisualizer
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivMarquardt(void);

    /** Destruktor.
     */
    ~TivMarquardt(void);


// OPERATORS
// OPERATIONS

    virtual void        Print(      wxTextCtrl*     pTargetCtrl,
                              const IterationData&  iterationData,
                              const FunctionBase&   function,
                                    bool            highlight) const;

    static std::auto_ptr<const TextIterationVisualizer>    Create();

// ACCESS
// INQUIRY

protected:

    wxString    PrintTrialPoints
                     (wxTextCtrl*                   pTargetCtrl,
                      const MarquardtIteration&     iteration,
                      const FunctionBase&           function,
                      bool                          highlight) const;

private:

    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivMarquardt_h
