#include <precomp.h>

#include "../Logger.h"
#include "../MultivariateConstrainedIteration.h"
#include "../Symbols.h"
#include "../text-util.h"
#include "AttributeDatabase.h"
#include "TivMultivariateConstrained.h"  // class implemented
#include "VisualizerFactory.h"
#include "ui_util.h"


LOGGER(DEBUG)

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

TivMultivariateConstrained::TivMultivariateConstrained()
{
}// TivMultivariateConstrained

TivMultivariateConstrained::~TivMultivariateConstrained()
{
}// ~TivMultivariateConstrained

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================

/* static */ std::auto_ptr<const TextIterationVisualizer>
TivMultivariateConstrained::Create()
{
    return auto_ptr<const TextIterationVisualizer>
                                        (new TivMultivariateConstrained);
}// Create

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/* virtual */ wxString
TivMultivariateConstrained::PrintNewApproximation
                    (      wxTextCtrl*             pTargetCtrl,
                     const IterationData&          iterationData,
                     const FunctionBase&           function,
                           bool                    highlight) const
{
    const MultivariateConstrainedIteration& iteration =
        dynamic_cast<const MultivariateConstrainedIteration&>(iterationData);

    return PrintPointWithValue(wxT("x"),
                               iteration.NewApproximation(),
                               function);
}

/////////////////////////////// PRIVATE    ///////////////////////////////////

/* static */ void* TivMultivariateConstrained::mpRegistrationDummy =
    VisualizerFactory::RegisterTextVisualizer(
            MultivariateConstrainedIteration::ClassId(),
            TivMultivariateConstrained::Create);

