/** Klasa wizualizatora tekstowego iteracji optymalizacji z ograniczeniami w
 * wielu wymiarach
 *
 * @see IterationData, ProblemWithPenalty
 */

#ifndef _TivMultivariateConstrained_h
#define _TivMultivariateConstrained_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "TivConstrainedOptimization.h"

// FORWARD REFERENCES
//


class TivMultivariateConstrained
    : public TivConstrainedOptimization
{
public:

// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivMultivariateConstrained(void);

    /** Destruktor.
     */
    ~TivMultivariateConstrained(void);


// OPERATORS
//

// OPERATIONS
//

    static std::auto_ptr<const TextIterationVisualizer>    Create();

// ACCESS
// INQUIRY

protected:

    virtual wxString    PrintNewApproximation
                                (      wxTextCtrl*      pTargetCtrl,
                                 const IterationData&   iteration,
                                 const FunctionBase&    function,
                                 bool                   highlight) const;

private:

    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivMultivariateConstrained_h
