/** Klasa bazowa dla wizualizatorw tekstowych iteracji optymalizacji z
 * ograniczeniami.
 *
 * @see IterationData, NelderMead
 */

#ifndef _TivNelderMead_h
#define _TivNelderMead_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../methods/NelderMeadIteration.h"

#include "TextIterationVisualizer.h"

// FORWARD REFERENCES
//


class TivNelderMead
    : public TextIterationVisualizer
{
public:

// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivNelderMead(void);

    /** Destruktor.
     */
    ~TivNelderMead(void);


// OPERATORS
//

// OPERATIONS
//
    virtual void    Print(
                        wxTextCtrl*           pTargetCtrl,
                        const IterationData&  iteration,
                        const FunctionBase&   function,
                        bool                  highlight) const;

    static std::auto_ptr<const TextIterationVisualizer>    Create();

// ACCESS
// INQUIRY

protected:

    /**
     */
    wxString PrintSimplex(wxTextCtrl*                   pTargetCtrl,
                          const vector<PointWithValue>& simplex,
                          bool                          highlight) const;

    /**
     */
    wxString PrintInitialSimplex(wxTextCtrl*                pTargetCtrl,
                                 const NelderMeadIteration& iteration,
                                 bool                       highlight) const;

    /**
     */
    wxString PrintTrialPoints(wxTextCtrl*                   pTargetCtrl,
                              const NelderMeadIteration&    iteration,
                              bool                          highlight) const;

    /**
     */
//    wxString PrintIterationSolution
//                            (wxTextCtrl*                pTargetCtrl,
//                             const NelderMeadIteration& iteration,
//                             bool                       highlight) const;

    /**
     */
    wxString PrintNewSimplex(wxTextCtrl*                pTargetCtrl,
                             const NelderMeadIteration& iteration,
                             bool                       highlight) const;

private:

    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivNelderMead_h
