/** Klasa bazowa dla wizualizatorw tekstowych iteracji PowellVariant1
 * i PowellVariant2.
 *
 * @see IterationData, PowellVariant1, PowellVariant2
 */

#ifndef _TivPowell_h
#define _TivPowell_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "TextIterationVisualizer.h"

// FORWARD REFERENCES
//


class TivPowell
    : public TextIterationVisualizer
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivPowell(void);

    /** Destruktor.
     */
    ~TivPowell(void);


// OPERATORS
    virtual void    Print(
                        wxTextCtrl*           pTargetCtrl,
                        const IterationData&  iterationData,
                        const FunctionBase&   function,
                        bool                  highlight) const;

// OPERATIONS
    static std::auto_ptr<const TextIterationVisualizer>    Create();
// ACCESS
// INQUIRY

protected:
    void            PrintPreliminaryIteration(
                        wxTextCtrl*                         pTargetCtrl,
                        const PowellIteration&              iterationData,
                        const FunctionBase&                 function,
                        bool                                highlight) const;

    wxString        PrintStartingParameters(
                        wxTextCtrl*                         pTargetCtrl,
                        const PowellIteration&              iterationData,
                        const FunctionBase&                 function,
                        bool                                highlight) const;

    wxString        PrintTrialSteps(
                        wxTextCtrl*                         pTargetCtrl,
                        const PowellIteration&              iterationData,
                        const FunctionBase&                 function,
                        bool                                highlight) const;

    wxString        PrintTrialSummary(
                        wxTextCtrl*                         pTargetCtrl,
                        const PowellIteration&              iterationData)
                                                                const;
    wxString        PrintNewDirection(
                        wxTextCtrl*                         pTargetCtrl,
                        const PowellIteration&              iterationData,
                        const FunctionBase&                 function,
                        bool                                highlight) const;

    virtual wxString    PrintNewBase(
                            wxTextCtrl*                     pTargetCtrl,
                            const PowellIteration&          iterationData,
                            bool                            highlight)
                                                                const = 0;
    private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivPowell_h
