#include <precomp.h>

#include "../methods/PowellVariant1Iteration.h"
#include "../text-util.h"

#include "AttributeDatabase.h"
#include "TivPowellVariant1.h"  // class implemented
#include "VisualizerFactory.h"
#include "ui_util.h"

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

TivPowellVariant1::TivPowellVariant1()
{
}// TivPowellVariant1

TivPowellVariant1::~TivPowellVariant1()
{
}// ~TivPowellVariant1

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
/* static */ std::auto_ptr<const TextIterationVisualizer>
TivPowellVariant1::Create()
{
    return auto_ptr<const TextIterationVisualizer>(new TivPowellVariant1);
}// Create
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////
/* virtual */ wxString
TivPowellVariant1::PrintNewBase(wxTextCtrl*                     pTargetCtrl,
                                const PowellIteration&          iterationData,
                                bool                            highlight)
                                                                    const
{
    const AttributeDatabase& attributes = AttributeDatabase::GetInstance();
    wxString text;

    text << PrintTwoColumnMatrix(pTargetCtrl, iterationData.NewD(),
                                 attributes.TextAttribute(
                                 AttributeDatabase::DEFAULT),
                                 attributes.TextAttribute(
                                 AttributeDatabase::STEP_IN_DIRECTION),
                                 _("New base (D): "),
                                 highlight);

    return text;
}// PrintNewBase

/////////////////////////////// PRIVATE    ///////////////////////////////////
/* static */ void* TivPowellVariant1::mpRegistrationDummy =
    VisualizerFactory::RegisterTextVisualizer(
            PowellVariant1Iteration::ClassId(),
            TivPowellVariant1::Create);

