/** Klasa bazowa dla wizualizatorw tekstowych iteracji RosenbrockDiscrete
 * i RosenbrockOptimal.
 *
 * @see IterationData, RosenbrockDiscrete, RosenbrockOptimal
 */

#ifndef _TivRosenbrock_h
#define _TivRosenbrock_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "TextIterationVisualizer.h"

// FORWARD REFERENCES
//


class TivRosenbrock
    : public TextIterationVisualizer
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivRosenbrock(void);

    /** Destruktor.
     */
    ~TivRosenbrock(void);


// OPERATORS
    virtual void    Print(
                        wxTextCtrl*           pTargetCtrl,
                        const IterationData&  iterationData,
                        const FunctionBase&   function,
                        bool                  highlight) const;

// OPERATIONS
// ACCESS
// INQUIRY

protected:
    wxString        PrintStartingParameters(
                        wxTextCtrl*                         pTargetCtrl,
                        const RosenbrockIteration&          iterationData,
                        const FunctionBase&                 function,
                        bool                                highlight) const;

    virtual wxString    PrintTrialSteps(
                            wxTextCtrl*                         pTargetCtrl,
                            const RosenbrockIteration&          iterationData,
                            const FunctionBase&                 function,
                            bool                                highlight)
                                                                    const = 0;

    virtual wxString    PrintFinalParameters(
                            wxTextCtrl*                         pTargetCtrl,
                            const RosenbrockIteration&          iterationData,
                            const FunctionBase&                 function)
                                                                const = 0;

    void            PrintNewBase(
                        wxTextCtrl*                         pTargetCtrl,
                        const RosenbrockIteration&          iterationData,
                        const FunctionBase&                 function,
                        bool                                highlight) const;
    private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivRosenbrock_h
