/** Wizualizator tekstowy dla iteracji algorytmu RosenbrockDiscrete.
 *
 * @see IterationData, RosenbrockDiscrete, TivRosenbrock
 */

#ifndef _TivRosenbrockDiscrete_h
#define _TivRosenbrockDiscrete_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "TivRosenbrock.h"

// FORWARD REFERENCES
//


class TivRosenbrockDiscrete
    : public TivRosenbrock
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivRosenbrockDiscrete(void);

    /** Destruktor.
     */
    ~TivRosenbrockDiscrete(void);


// OPERATORS

// OPERATIONS

    static std::auto_ptr<const TextIterationVisualizer>    Create();

// ACCESS
// INQUIRY

protected:

    virtual wxString    PrintTrialSteps(
                            wxTextCtrl*                         pTargetCtrl,
                            const RosenbrockIteration&          iterationData,
                            const FunctionBase&                 function,
                            bool                                highlight)
                                                                        const;

    virtual wxString    PrintFinalParameters(
                            wxTextCtrl*                         pTargetCtrl,
                            const RosenbrockIteration&          iterationData,
                            const FunctionBase&                 function) const;

private:
    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivRosenbrockDiscrete_h
