/** Wizualizator tekstowy dla iteracji algorytmu RosenbrockOptimal.
 *
 * @see IterationData, RosenbrockOptimal, TivRosenbrock
 */

#ifndef _TivRosenbrockOptimal_h
#define _TivRosenbrockOptimal_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "TivRosenbrock.h"

// FORWARD REFERENCES
//


class TivRosenbrockOptimal
    : public TivRosenbrock
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivRosenbrockOptimal(void);

    /** Destruktor.
     */
    ~TivRosenbrockOptimal(void);


// OPERATORS

// OPERATIONS

    static std::auto_ptr<const TextIterationVisualizer>    Create();

// ACCESS
// INQUIRY

protected:

    virtual wxString    PrintTrialSteps(
                            wxTextCtrl*                         pTargetCtrl,
                            const RosenbrockIteration&          iterationData,
                            const FunctionBase&                 function,
                            bool                                highlight)
                                                                    const;

    virtual wxString    PrintFinalParameters(
                            wxTextCtrl*                         pTargetCtrl,
                            const RosenbrockIteration&          iterationData,
                            const FunctionBase&                 function) const;


private:
    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivRosenbrockOptimal_h
