/** Klasa wizualizatora tekstowego dla iteracji metody podziau
 * dychotomicznego.
 *
 * @see IterationData, DichotomousDivision
 */

#ifndef _TivSecantDivision_h
#define _TivSecantDivision_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "TextIterationVisualizer.h"

// FORWARD REFERENCES
//


class TivSecantDivision
    : public TextIterationVisualizer
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivSecantDivision(void);

    /** Destruktor.
     */
    ~TivSecantDivision(void);


// OPERATORS
// OPERATIONS

    virtual void        Print(wxTextCtrl*           pTargetCtrl,
                              const IterationData&  iterationData,
                              const FunctionBase&   function,
                              bool                  highlight) const;

    static std::auto_ptr<const TextIterationVisualizer>    Create();

// ACCESS
// INQUIRY

protected:

    wxString    PrintPoints
                     (wxTextCtrl*                           pTargetCtrl,
                      const SecantDivisionIteration&        iteration,
                      const FunctionBase&                   function,
                      bool                                  highlight) const;

    wxString    PrintNewSection
                     (wxTextCtrl*                           pTargetCtrl,
                      const SecantDivisionIteration&        iteration,
                      const FunctionBase&                   function,
                      bool                                  highlight) const;

private:

    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivSecantDivision_h
