/** Klasa wizualizatora tekstowego dla iteracji metody znaku pochodnej.
 *
 * @see IterationData, SignOfDerivative
 */

#ifndef _TivSignOfDerivative_h
#define _TivSignOfDerivative_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "TextIterationVisualizer.h"

// FORWARD REFERENCES
//


class TivSignOfDerivative
    : public TextIterationVisualizer
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivSignOfDerivative(void);

    /** Destruktor.
     */
    ~TivSignOfDerivative(void);


// OPERATORS
// OPERATIONS

    virtual void        Print(wxTextCtrl*           pTargetCtrl,
                              const IterationData&  iterationData,
                              const FunctionBase&   function,
                              bool                  highlight) const;

    static std::auto_ptr<const TextIterationVisualizer>    Create();

// ACCESS
// INQUIRY

protected:

    wxString    PrintTrialPoints
                     (wxTextCtrl*                   pTargetCtrl,
                      const SignOfDerivativeIteration&    iteration,
                      const FunctionBase&           function,
                      bool                          highlight) const;

private:

    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivSignOfDerivative_h
