/** Klasa wizualizatorw tekstowych iteracji algorytmu Simplex.
 *
 * @see IterationData, Simplex
 */

#ifndef _TivSimplex_h
#define _TivSimplex_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "TextIterationVisualizer.h"

// FORWARD REFERENCES
//


class TivSimplex
    : public TextIterationVisualizer
{
public:
// LIFECYCLE

    /** Konstruktor domylny.
     */
    TivSimplex(void);

    /** Destruktor.
     */
    ~TivSimplex(void);


// OPERATORS
    virtual void    Print(
                        wxTextCtrl*           pTargetCtrl,
                        const IterationData&  iterationData,
                        const FunctionBase&   function,
                        bool                  highlight) const;

// OPERATIONS
    static std::auto_ptr<const TextIterationVisualizer>    Create();
// ACCESS
// INQUIRY

protected:
    void            PrintMainProblemMatrices(
                        wxTextCtrl*                         pTargetCtrl,
                        const SimplexIteration&             iterationData)
                                                                const;

    void            PrintExtendedProblemMatrices(
                        wxTextCtrl*                         pTargetCtrl,
                        const SimplexIteration&             iterationData)
                                                                const;
    void            PrintStepData(
                        wxTextCtrl*                         pTargetCtrl,
                        const FunctionBase&                 function,
                        const SimplexIteration&             iterationData)
                                                                const;

    void            PrintExtendedSolutionSummary(
                        wxTextCtrl*                         pTargetCtrl,
                        const SimplexIteration&             iterationData)
                                                                const;

    wxString        PrintColouredIndices(wxTextCtrl*            pTargetCtrl,
                                         const vector<int>&     indices,
                                         int                    highlighted,
                                         const wxTextAttr&      attribute)
                                                                const;

    void            PrintBasicMatrices(
                        wxTextCtrl*                      pTargetCtrl,
                        const SimplexIteration&          iterationData)
                                                                const;
    void            PrintBasicPoint(
                        wxTextCtrl*                      pTargetCtrl,
                        const SimplexIteration&          iterationData)
                                                                const;
    void            PrintFullPoint(
                        wxTextCtrl*                      pTargetCtrl,
                        const FunctionBase&              function,
                        const SimplexIteration&          iterationData)
                                                                    const;
    void            PrintReducedCosts(
                        wxTextCtrl*                      pTargetCtrl,
                         const SimplexIteration&          iterationData)
                                                                    const;

    void            PrintLeavingVariable(
                        wxTextCtrl*                      pTargetCtrl,
                         const SimplexIteration&          iterationData)
                                                                    const;

    void            PrintNewPoint(
                        wxTextCtrl*                      pTargetCtrl,
                         const SimplexIteration&          iterationData)
                                                                    const;
    private:
    /** Zmienna statyczna, ktrej inicjowanie rejestruje metod Create
     * w fabryce wizualizatorw.
     */
    static void*   mpRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _TivSimplex_h
