#include <precomp.h>

#include "../methods/UniformDivisionIteration.h"
#include "../UnivariateFunction.h"
#include "../text-util.h"

#include "AttributeDatabase.h"
#include "TivUniformDivision.h"  // class implemented
#include "VisualizerFactory.h"
#include "ui_util.h"

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

TivUniformDivision::TivUniformDivision()
{
}// TivUniformDivision

TivUniformDivision::~TivUniformDivision()
{
}// ~TivUniformDivision

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
/* virtual */ void
TivUniformDivision::Print(wxTextCtrl*             pTargetCtrl,
                          const IterationData&    iterationData,
                          const FunctionBase&     function,
                          bool                    highlight) const
{
    assert (pTargetCtrl != NULL);
    const UniformDivisionIteration& iteration =
        dynamic_cast<const UniformDivisionIteration&>(iterationData);
    wxString text;

    pTargetCtrl->Freeze();

    text << _("Trial point:\n")
         << PrintDoubleWithValue(wxT("x"), iteration.TrialPoint(),
                     function);

    pTargetCtrl->AppendText(text);

    pTargetCtrl->Thaw();
}// Print

/* static */ std::auto_ptr<const TextIterationVisualizer>
TivUniformDivision::Create()
{
    return auto_ptr<const TextIterationVisualizer>(new TivUniformDivision);
}// Create
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////
/////////////////////////////// PRIVATE    ///////////////////////////////////
/* static */ void* TivUniformDivision::mpRegistrationDummy =
    VisualizerFactory::RegisterTextVisualizer(
            UniformDivisionIteration::ClassId(),
            TivUniformDivision::Create);

