#include <precomp.h>

#include "../Logger.h"
#include "../Symbols.h"
#include "../text-util.h"
#include "AttributeDatabase.h"
#include "TivUnivariateConstrained.h"  // class implemented
#include "VisualizerFactory.h"
#include "ui_util.h"


LOGGER(DEBUG)

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

TivUnivariateConstrained::TivUnivariateConstrained()
{
}// TivUnivariateConstrained

TivUnivariateConstrained::~TivUnivariateConstrained()
{
}// ~TivUnivariateConstrained

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================

/* static */ std::auto_ptr<const TextIterationVisualizer>
TivUnivariateConstrained::Create()
{
    return auto_ptr<const TextIterationVisualizer>
                                        (new TivUnivariateConstrained);
}// Create

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/* virtual */ wxString
TivUnivariateConstrained::PrintNewApproximation
                    (      wxTextCtrl*             pTargetCtrl,
                     const IterationData&          iterationData,
                     const FunctionBase&           function,
                           bool                    highlight) const
{
    const UnivariateConstrainedIteration& iteration =
        dynamic_cast<const UnivariateConstrainedIteration&>(iterationData);

    return  PrintDoubleWithValue(wxT("x"),
                                 iteration.NewApproximation(),
                                 function);
}

/////////////////////////////// PRIVATE    ///////////////////////////////////

/* static */ void* TivUnivariateConstrained::mpRegistrationDummy =
    VisualizerFactory::RegisterTextVisualizer(
            UnivariateConstrainedIteration::ClassId(),
            TivUnivariateConstrained::Create);

