/** Akcja narzdzia wcz/wycz (toggle).
 *
 * @see ToolbarTool, ClickToolAction, PlotToolbar
 */

#ifndef _ToggleToolAction_h
#define _ToggleToolAction_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//

// FORWARD REFERENCES
//


class ToggleToolAction
{
public:
// LIFECYCLE

    /** Destruktor.
     */
    virtual ~ToggleToolAction(void);


// OPERATORS

    /** Akcja wykonywana przy klikniciu na narzdzie.
     *
     * @param toggled Wczenie czy wyczenie.
     * @return Stan, w jakim powinien si znale przycisk po wykonaniu akcji.
     * Jeli akcja si powioda, zwracana powinna by warto <code>toggle</code>.
     */
    virtual bool    Action(bool toggled) = 0;

// OPERATIONS
// ACCESS
// INQUIRY

    /** Sprawdza, jaki powinien by stan narzdzia.
     */
    virtual bool    IsToggled() const = 0;

protected:
private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _ToggleToolAction_h
