// -*- C++ -*- generated by wxGlade 0.4 on Thu Nov 17 18:11:41 2005

#include <precomp.h>

#include "../HistoryManager.h"
#include "../Logger.h"
#include "../NonlinearParser.h"

#include "FunctionValidator.h"
#include "GeneralValidator.h"
#include "ProblemPanelFactory.h"
#include "UnconstrainedProblemPanel.h"

LOGGER(DEBUG);

BEGIN_EVENT_TABLE(UnconstrainedProblemPanel, wxPanel)
    EVT_TEXT_ENTER(ID_COMBO_FUNCTION, UnconstrainedProblemPanel::ValidateFunction)
END_EVENT_TABLE()

UnconstrainedProblemPanel::UnconstrainedProblemPanel(
        wxWindow*               parent,
        int                     id,
        UnconstrainedProblem*   pProblem,
        const wxPoint&          pos,
        const wxSize&           size,
        long                    style)
    : wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL)
{
    // begin wxGlade: UnconstrainedProblemPanel::UnconstrainedProblemPanel
    p_function_sizer_staticbox = new wxStaticBox(this, -1, _("Function"));
    const wxString mpFunctionCombo_choices[] = {
        
    };
    mpFunctionCombo = new wxComboBox(this, ID_COMBO_FUNCTION, wxT(""), wxDefaultPosition, wxDefaultSize, 0, mpFunctionCombo_choices, wxCB_DROPDOWN);

    set_properties();
    do_layout();
    // end wxGlade

    mpFunctionCombo->SetValidator(FunctionValidator(
                std::auto_ptr<const Parser>(new NonlinearParser),
                pProblem->mcpFunction,
                pProblem->mcpVariables,
                pProblem,
                true,
                HistoryManager::GetHistory(HistoryManager::NONLINEAR_FUNCTION),
                FunctionValidator::ALLOW_UNIVARIATE));
}


void UnconstrainedProblemPanel::set_properties()
{
    // begin wxGlade: UnconstrainedProblemPanel::set_properties
    mpFunctionCombo->SetSelection(-1);
    // end wxGlade
}


void UnconstrainedProblemPanel::do_layout()
{
    // begin wxGlade: UnconstrainedProblemPanel::do_layout
    wxStaticBoxSizer* p_function_sizer = new wxStaticBoxSizer(p_function_sizer_staticbox, wxVERTICAL);
    p_function_sizer->Add(mpFunctionCombo, 0, wxEXPAND|wxADJUST_MINSIZE, 0);
    SetAutoLayout(true);
    SetSizer(p_function_sizer);
    p_function_sizer->Fit(this);
    p_function_sizer->SetSizeHints(this);
    // end wxGlade
}

void UnconstrainedProblemPanel::ValidateFunction(wxCommandEvent& event)
{
    // Tak si chyba nie powinno wywoywa walidatorw, ale nie umiem inaczej
    // sprawdzi tylko wybranej kontrolki.

    dynamic_cast<wxWindow*>(event.GetEventObject())
        ->GetValidator()->Validate(this);
}// ValidateFunction

/* static */ wxPanel*
UnconstrainedProblemPanel::CreatePanel(ProblemBase* pProblem,
                                       wxWindow*    pParent)
{
    wxPanel* p_panel = new UnconstrainedProblemPanel(
            pParent,
            -1,
            dynamic_cast<UnconstrainedProblem*>(pProblem));

    p_panel->SetValidator(GeneralValidator());

    return p_panel;
}// CreatePanel

// Zarejestruj metod tworzc panel
const void* UnconstrainedProblemPanel::mpRegistrationDummy =
        ProblemPanelFactory::GetInstance().Register(
                UnconstrainedProblem::ClassId(),
                UnconstrainedProblemPanel::CreatePanel);
