/** Warstwa wykresu rysujca iteracj metody podziau rwnomiernego.
 *
 * @see UniformDivision, UniformDivisionIteration
 */

#ifndef _UniformDivisionLayer_h
#define _UniformDivisionLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "UnivariateResultLayer.h"

// FORWARD REFERENCES
//


class UniformDivisionLayer
    : public UnivariateResultLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    UniformDivisionLayer(const PlotControl&     plotControl,
                         const Result&          result,
                         CountedPtr<PlotLayer>  cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    UniformDivisionLayer(const UniformDivisionLayer& from);

    /** Destruktor.
     */
    ~UniformDivisionLayer(void);


// OPERATORS

// OPERATIONS

    virtual void    Draw(wxDC& dc) const;

    static std::auto_ptr<ResultLayer>   Create(
                                const PlotControl&      plotControl,
                                const Result&           result,
                                CountedPtr<PlotLayer>   cpFunctionLayer);

// ACCESS

    virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

// INQUIRY

protected:

    void            DrawIteration(wxDC&             dc,
                                  unsigned          iterationNumber) const;


    void            DrawActiveIterationBackground(wxDC& dc) const;
private:

    static const void*  mRegistrationDummy;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _UniformDivisionLayer_h
