// -*- C++ -*- generated by wxGlade 0.4.1 on Fri Mar 10 17:10:45 2006

#include <precomp.h>

#include "../Symbols.h"
#include "../text-util.h"

#include "DoubleParameterValidator.h"
#include "InitialSectionControl.h"
#include "MethodPanelFactory.h"
#include "UniformDivisionPanel.h"
#include "ui_util.h"


UniformDivisionPanel::UniformDivisionPanel(
        wxWindow*           parent,
        int                 id,
        UniformDivision*    pMethod,
        const wxPoint&      pos,
        const wxSize&       size,
        long                style)
    : wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL)
{
    // begin wxGlade: UniformDivisionPanel::UniformDivisionPanel
    mpEpsilonLabel = new wxStaticText(this, -1, _("[Label set explicitly in ui/UniformDivisionPanel::set_properties().]"));
    mpEpsilonTextCtrl = new wxTextCtrl(this, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_RIGHT);

    set_properties();
    do_layout();
    // end wxGlade

    mpEpsilonTextCtrl->SetValidator(DoubleParameterValidator(pMethod->mEpsilon));
}


void UniformDivisionPanel::set_properties()
{
    // begin wxGlade: UniformDivisionPanel::set_properties
    // end wxGlade

    // Etykiety z greckimi literami.
    const wxString& epsilon_label_text = _("Step length") +
        LabelSymbol(Symbols::GetInstance()[Symbols::EPSILON]);
    mpEpsilonLabel->SetLabel(epsilon_label_text);
}


void UniformDivisionPanel::do_layout()
{
    // begin wxGlade: UniformDivisionPanel::do_layout
    wxBoxSizer* p_main_sizer = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* p_epsilon_sizer = new wxBoxSizer(wxHORIZONTAL);
    p_epsilon_sizer->Add(mpEpsilonLabel, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_epsilon_sizer->Add(mpEpsilonTextCtrl, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    p_main_sizer->Add(p_epsilon_sizer, 0, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(p_main_sizer);
    p_main_sizer->Fit(this);
    p_main_sizer->SetSizeHints(this);
    // end wxGlade
}

/* static */ wxPanel*
UniformDivisionPanel::CreatePanel(MethodPanelInfo   panelInfo)
{
    UniformDivision* p_method =
        dynamic_cast<UniformDivision*>(panelInfo.pMethod());

    if (panelInfo.PanelType() == MethodPanelInfo::STANDALONE)
    {
        return CreatePanelOfTwo(panelInfo.pParent(),
                new UniformDivisionPanel(panelInfo.pParent(), -1, p_method),
                new InitialSectionControl(panelInfo.pParent(), -1,
                    //p_method->mA, p_method->mB
                    p_method->mInitialA, p_method->mInitialB));
    }
    else
    {
        return new UniformDivisionPanel(panelInfo.pParent(), -1, p_method);
    }
}// CreatePanel

// Zarejestruj metod tworzc panel
const void* UniformDivisionPanel::mpRegistrationDummy =
        MethodPanelFactory::GetInstance().Register(
                UniformDivision::ClassId(),
                UniformDivisionPanel::CreatePanel);
