/** Warstwa wykresu odpowiedzialna za rysowanie wykresu funkcji jednej zmiennej.
 *
 * @see PlotControl
 */
#ifndef _UnivariateFunctionLayer_h
#define _UnivariateFunctionLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../UnivariateFunction.h"
#include "PlotLayer.h"

// FORWARD REFERENCES
//

class UnivariateFunctionLayer
    : public PlotLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    UnivariateFunctionLayer(const PlotControl&          targetPlot,
                            const UnivariateFunction&   function);

    /** Konstruktor kopiujcy.
     */
    UnivariateFunctionLayer(const UnivariateFunctionLayer& from);

    /** Destruktor.
     */
    ~UnivariateFunctionLayer(void);


// OPERATORS
// OPERATIONS

    virtual void    Draw(wxDC& dc) const;

// ACCESS
// INQUIRY

protected:
private:
    const UnivariateFunction&   mFunction;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _UnivariateFunctionLayer_h
