#ifndef _UnivariatePlot_h
#define _UnivariatePlot_h

#include "../UnivariateFunction.h"
#include "PlotControl.h"

class UnivariatePlot
    : public PlotControl
{
public:
    enum ToolType
    {
        PAN,
        ZOOM_IN,
        ZOOM_OUT
    };

    UnivariatePlot(
        wxWindow*                   pParent,
        wxWindowID                  id,
        const UnivariateFunction&   function,
        PlotStatus*                 pPlotStatus = NULL,
        const wxString&             variableName = wxT(""),
        const wxPoint&              position = wxDefaultPosition,
        const wxSize&               size = wxDefaultSize,
        bool                        integersOnX = false);

    ~UnivariatePlot();

    virtual void    OnAspectChange(bool redraw);
protected:

    virtual void    DrawDisplaced(long x, long y);

    virtual void    Pan(wxCoord x, wxCoord y);

    virtual void    PlotFunction(wxDC& dc);

    virtual void    ZoomIn(wxCoord x, wxCoord y);
    virtual void    ZoomRegionIn(wxCoord x,
                                 wxCoord y,
                                 wxCoord width,
                                 wxCoord height);
    virtual void    ZoomOut(wxCoord x, wxCoord y);

    virtual void    UpdateStatusOnMove(long x, long y);

    virtual void    UpdateScale();

private:
    void            UpdateYBounds();
};

#endif
