/** Warstwa wykresu prezentujca przebieg optymalizacji funkcji jednej zmiennej.
 *
 * @see PlotControl
 */

#ifndef _UnivariateResultLayer_h
#define _UnivariateResultLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "AttributeDatabase.h"
#include "ResultLayer.h"

// FORWARD REFERENCES
//

class UnivariateResultLayer
    : public ResultLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    UnivariateResultLayer(const PlotControl&    plotControl,
                          const Result&         result,
                          CountedPtr<PlotLayer> cpFunctionLayer);


    /** konstruktor kopiujcy.
     */
    UnivariateResultLayer(const UnivariateResultLayer& from);

    /** Destruktor.
     */
    ~UnivariateResultLayer(void);


// OPERATORS

// OPERATIONS
// ACCESS
// INQUIRY

protected:
    /** Wylicza wsprzdne punktu w kontekcie graficznym dla podanej wartoci
     * argumentu funkcji.
     */
    wxPoint     PlotToDcPoint(double point) const;

    /** Rysuje ostateczny wynik (jeli proces optymalizacji dobieg koca).
     */
    void        DrawFinalResult(wxDC& dc) const;

    /** Rysuje duy punkt o zadanym atrybucie.
     */
    void        DrawBigPoint(wxDC&                            dc,
                             double                           point,
                             AttributeDatabase::AttributeType attribute,
                             SymbolType                       symbol = CIRCLE)
                                                                        const;

    /** Rysuje pionow kresk przechodzc przez punkt.
     */
    void        DrawVerticalLine(
                        wxDC&                               dc,
                        double                              point,
                        AttributeDatabase::AttributeType    attribute) const;

    /** Zakolorowuje dany obszar.
     */
    void        DrawRangeBackground(
                        wxDC&                               dc,
                        wxCoord                             left,
                        wxCoord                             right,
                        AttributeDatabase::AttributeType    attribute) const;

    /** Zamalowuje cae DC kolorem 'poza zaznaczon iteracj'.
     *
     * @param dc DC.
     * @param attribute Atrybut, ktrego kolorem bdzie zamalowane to.
     * @see BackgroundAttribute.
     */
    void        GreyOutBackground(
                    wxDC&                               dc,
                    AttributeDatabase::AttributeType    attribute
                            = AttributeDatabase::PLOT_OUTSIDE_BG) const;

    AttributeDatabase::AttributeType
                BackgroundAttribute(unsigned iterationNumber) const;

private:
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _UnivariateResultLayer_h
