#include <precomp.h>

#include "../methods/DFP.h"
#include "../methods/FletcherReeves.h"
#include "../methods/HookeJeevesOptimal.h"
#include "../methods/NewtonModified.h"
#include "../methods/PolakRibiere.h"
#include "../methods/PowellVariant1.h"
#include "../methods/PowellVariant2.h"
#include "../methods/RosenbrockOptimal.h"
#include "../methods/SteepestDescent.h"

#include "VariantedMethodWithLineSearchPanel.h"

static void* RegisterPanels()
{
    MethodPanelFactory& factory = MethodPanelFactory::GetInstance();

    factory.Register(DFP::ClassId(),
            VariantedMethodWithLineSearchPanel<DFP>::CreatePanel);

    factory.Register(FletcherReeves::ClassId(),
            VariantedMethodWithLineSearchPanel<FletcherReeves>::CreatePanel);

    return NULL;
}

static const void* trigger_dummy = RegisterPanels();

