/** Okno zawierajce wizualizacje pojedynczego przebiegu optymalizacji.
 *
 * Zawiera wxNotebook, na ktrego zakadkach znajduj si poszczeglne
 * wizualizatory (ich nazwy s etykietami zakadek).
 *
 * Obiekty wizualizatorw poszczeglnych typw s tworzone za pomoc
 * VisualizerFactory na podstawie obiektu wyniku optymalizacji.
 *
 * @see Visualizer, VisualizerFactory.
 */

#ifndef _VisualizationFrame_h
#define _VisualizationFrame_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "../CountedPtr.h"
#include "../Result.h"

// FORWARD REFERENCES
//


class VisualizationFrame
    : public wxFrame
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    VisualizationFrame(wxWindow* pParent, CountedPtr<const Result> cpResult);

    /** Destruktor.
     */
    ~VisualizationFrame(void);

// OPERATORS

// OPERATIONS
// ACCESS
// INQUIRY

protected:
private:
    /// Generuje tytu okna.
    wxString    GenerateTitle();


    CountedPtr<const Result> mcpResult;      ///< Przebieg optymalizacji.

    /// Kontrolka z zakadkami.
    wxNotebook*                 mpVisualizerNotebook;

    /// Numer ostatniego okna.
    static unsigned             mWindowNumber;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _VisualizationFrame_h
