/** Warstwa wykresu prezentujca przebieg optymalizacji funkcji wielu zmiennych.
 *
 * @see PlotControl
 */

#ifndef _XyResultLayer_h
#define _XyResultLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "AttributeDatabase.h"
#include "ResultLayer.h"

// FORWARD REFERENCES
//


class XyResultLayer
    : public ResultLayer
{
public:
// LIFECYCLE

    /** Konstruktor.
     */
    XyResultLayer(const PlotControl&    plotControl,
                  const Result&         result,
                  CountedPtr<PlotLayer> cpFunctionLayer);


    /** Konstruktor kopiujcy.
     */
    XyResultLayer(const XyResultLayer& from);

    /** Destruktor.
     */
    ~XyResultLayer(void);


// OPERATORS
// OPERATIONS


// ACCESS

// INQUIRY

protected:

    /** Przelicza wsprzdne punktu na wsprzdne kontekstu graficznego.
     */
    wxPoint     PlotToDcPoint(const ColumnVector& point) const;

    /** Rysuje ostateczny wynik (jeli proces optymalizacji dobieg koca).
     */
    void        DrawFinalResult(wxDC& dc) const;

    /** Rysuje duy punkt o zadanym atrybucie.
     */
    void        DrawBigPoint(wxDC&                            dc,
                             const ColumnVector&              point,
                             AttributeDatabase::AttributeType attribute,
                             SymbolType                       symbol = CIRCLE)
                const;

    /** Rysuje lini czc dwa punkty.
     */
    void        DrawLine(wxDC&                              dc,
                         const ColumnVector&                point1,
                         const ColumnVector&                point2,
                         AttributeDatabase::AttributeType   attribute,
                         int                                style = wxSOLID)
                                                                        const;


    // Indeksy zmiennych, nie mog by ustawiane (mona robi tylko wykresy
    // funkcji 2 zmiennych).
    unsigned    mVariableXIndex;
    unsigned    mVariableYIndex;
private:

    static const int SOLID_WIDTH;       ///< Szeroko linii cigej
    static const int FANCY_WIDTH;       ///< Szeroko linii przerywanych itd.
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _XyResultLayer_h
