/** Klasa podstawowa dla klas warstw przebiegu optymalizacji
 * wielu zmiennych bez ogranicze.
 *
 * @see PlotControl, XyResultLayer
 */

#ifndef _XyUnconstrainedLayer_h
#define _XyUnconstrainedLayer_h

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "XyResultLayer.h"

// FORWARD REFERENCES
//


class XyUnconstrainedLayer
    : public XyResultLayer
{
public:
// LIFECYCLE

    /** Konstruktor
     */
    XyUnconstrainedLayer(const PlotControl&      plotControl,
                         const Result&           result,
                         CountedPtr<PlotLayer>   cpFunctionLayer);

    /** Konstruktor kopiujcy.
     */
    XyUnconstrainedLayer(const XyUnconstrainedLayer& from);

    /** Destruktor.
     */
    ~XyUnconstrainedLayer(void);


// OPERATORS

// OPERATIONS

    virtual void    Draw(wxDC& dc) const;

    // virtual Region  IterationBoundingBox(unsigned iterationNumber) const;

    virtual vector<ToolbarTool> CreateTools(PlotControl* pPlotControl);

    void            SetDrawSubsequentIterations(bool toggle);

// ACCESS

// INQUIRY
    bool            DrawsSubsequentIterations() const;


protected:
    virtual void    DrawIteration(wxDC&     dc,
                                  unsigned  iterationNumber,
                                  bool      highlight) const = 0;

private:
    bool mDrawSubsequentIterations; /// Informacja, czy powinny by rysowane
                                    /// rwnie iteracje od aktualnie ogldanej
                                    /// do ostatniej.
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _XyUnconstrainedLayer_h
