#ifndef _ui_util_h
#define _ui_util_h

#include "../FunctionBase.h"

#include "IntervalCountLimiter.h"

/** Tworzy panel, w ktrym umiesza dwa okna: pTopWindow i pBottomWindow.
 */
wxPanel*        CreatePanelOfTwo(wxWindow*  pParent,
                                 wxWindow*  pTopWindow,
                                 wxWindow*  pBottomWindow);

/** Generuje format string dla liczb <code>double</code>.
 *
 * Format jest taki, aby mona byo zapisa wszystkie znaczce miejsca po przecinku.
 *
 * @param interval_length Najmniejsza moliwa rnica midzy dwiema kolejnymi
 * liczbami.
 */
wxString        NumberFormat(double interval_length);

/** Znajduje najlepsz odlego midzy kolejnymi podziakami (ew. poziomicami).
 *
 * Zwracana warto jest wielokrotonoci 10 razy 1, 2 albo 5.
 *
 * @param initialSpan Rozpito midzy najwiksz a najmniejsz wartoci.
 * @param initialIntervalLength Pocztkowa dugo przedziau midzy
 * podziakami, powinna by rwna przynajmniej szerokoci caego obszaru rysunku
 * (np.  dugoci osi).
 * @param intervalCountLimiter Obiekt funkcyjny, ktrego argumentem jest
 * rozpatrywany wynik, a wynikiem maksymalna dopuszczalna ilo obszarw midzy
 * podziakami (liczba podziaek - 1).
 */
double
FindBestInterval(double                         initialSpan,
                 long long                      initialIntervalLength,
                 const IntervalCountLimiter&    intervalCountLimiter);

#endif // _ui_util_h
