/** Strumie przekazujcy dane do obiektu wxTextCtrl.
 */

#ifndef _wxTextCtrlOutputStream_h
#define _wxTextCtrlOutputStream_h


// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

//#include <wx/stream.h>
//#include <wx/textctrl.h>
//#include <wx/strconv.h>
//#include <wx/string.h>
//#include <wx/frame.h>
//#include <wx/gdicmn.h>

// LOCAL INCLUDES
//

// FORWARD REFERENCES
//

/**
 * Klasa dziedziczca po wxOutputStream, przekazujca dane do obiektu typu
 * wxTextCtrl;
 */
class wxTextCtrlOutputStream
    : public wxOutputStream
{
public:

// LIFECYCLE

    /** Konstruktor.
     */
    //wxTextCtrlOutputStream(wxTextCtrl* targetTextCtrl);

    /** Konstruktor.
     */
    wxTextCtrlOutputStream();

    /** Destruktor.
     */
    ~wxTextCtrlOutputStream();

// OPERATORS
// OPERATIONS
// ACCESS

    static void SetTextCtrl();

// INQUIRY

protected:

    /** Wylij przekazane dane do okna tekstowego.
     *
     * Funkcja wywoywana, gdy do strumienia zapisane zostay dane.
     * Przekazuje ona dane dalej do okna tekstowego mpTargetTextCtrl.
     *
     * @param buffer Bufor danych.
     * @param size Wielko bufora.
     * @return Wielko bufora.
     */
    virtual size_t OnSysWrite(const void* buffer, size_t size);

private:

    /**
     * Okno tekstowe, do ktrego przekazuje dane strumie.
     */
    static wxTextCtrl* mpTargetTextCtrl;

    /**
     * Konwerter kodowania znakw
     */
#if wxUSE_WCHAR_T
    wxMBConvUTF8 mConv;
#else
    wxMBConv mConv;
#endif

    // Deklaracja prywatnego konstruktora kopiujcego i operatora =.
    // Uniemoliwia skopiowanie obiektu tej klasy.
    DECLARE_NO_COPY_CLASS(wxTextCtrlOutputStream);

};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif  // _wxTextCtrlOutputStream_h
