#include <src/precomp.h>

#include <tut.h>

#include <src/CountedPtr.h>
#include <src/Logger.h>

LOGGER(DEBUG);

using namespace std;

namespace tut
{
    struct CountedPtrData
    {
    };

    typedef test_group<CountedPtrData> CountedPtrTestType;
    typedef CountedPtrTestType::object CountedPtrTest;
    CountedPtrTestType counted_ptr_group("counted ptr");

    // Ustawienie i dostp do wartoci
    template<>
    template<>
    void CountedPtrTest::test<1>()
    {
        CountedPtr<int> cpInt(new int(5));

        int *pInt = cpInt.Get();

        ensure(*pInt == 5);
        ensure(*cpInt == 5);
    }

    // Dwa wskaniki na jeden obiekt
    template<>
    template<>
    void CountedPtrTest::test<2>()
    {
        CountedPtr<int> cpInt(new int(5));

        int *pInt = cpInt.Get();

        CountedPtr<int> cpInt2(cpInt);

        ensure(pInt == cpInt.Get());
        ensure(pInt == cpInt2.Get());

        ++(*cpInt);

        ensure((*cpInt2) == 6);
    }

    // Przypisywanie wskanikw
    template<>
    template<>
    void CountedPtrTest::test<3>()
    {
        CountedPtr<double> cpInt(new double(5.0));
        CountedPtr<double> cpInt2;

        cpInt2 = cpInt;

        ensure(cpInt2.Get() == cpInt.Get());
    }

    // Reset i usuwanie wskanikw
    template<>
    template<>
    void CountedPtrTest::test<4>()
    {
        CountedPtr<int> cpInt(new int(5));
        CountedPtr<int> cpInt2(cpInt);

        {
            CountedPtr<int> cpInt3(cpInt2);

            ++(*cpInt2);
        }

        ensure(*cpInt == 6);

        ++(*cpInt);

        cpInt.Reset(new int(-1));

        ensure(*cpInt2 == 7);

        int* pInt = cpInt2.Get();

        cpInt2 = cpInt;

        ensure((cpInt2.Get() == cpInt.Get()) && (cpInt.Get() != pInt));
    }

    // Obsuga auto_ptrw
    template<>
    template<>
    void CountedPtrTest::test<5>()
    {
        std::auto_ptr<int> apInt(new int(5));
        int *pInt = apInt.get();

        CountedPtr<int> cpInt(apInt);

        ensure(apInt.get() == NULL);
        ensure(pInt == cpInt.Get());

        apInt.reset(new int(-1));
        pInt = apInt.get();

        cpInt = apInt;

        ensure(apInt.get() == NULL);
        ensure(pInt == cpInt.Get());
        ensure(*pInt == -1);
    }
}
