#include <src/precomp.h>

#include <tut.h>

#include <src/DoubleParameter.h>
#include <src/Logger.h>

LOGGER(DEBUG);

namespace tut
{
    struct DoubleParameterData
    {
    };

    typedef test_group<DoubleParameterData> DoubleParameterTestType;
    typedef DoubleParameterTestType::object DoubleParameterTest;
    DoubleParameterTestType double_parameter_group("double parameter");

    // Ustawienie i dostp do wartoci
    template<>
    template<>
    void DoubleParameterTest::test<1>()
    {
        DoubleParameter parameter(10.5);
        double value = parameter;

        ensure("Correct value", value == 10.5);
        ensure("Correct operator==", parameter == 10.5);
    }

    // Wartoci spoza zakresu
    template<>
    template<>
    void DoubleParameterTest::test<2>()
    {
        DoubleParameter parameter(10.5, -20.0, false, 20.0, true);
        bool gotException = false;

        ensure("IsValid on valid value", parameter.IsValid(-19.5) == true);
        ensure("IsValid on invalid value", parameter.IsValid(-20.5) == false);

        try
        {
            parameter = -20.5;
        }
        catch(const Error& e)
        {
            gotException = true;
        }

        ensure("Exception raised on invalid assignment", gotException);
    }

}
